#include <bits/stdc++.h>

using namespace std;

#define sz(x) (int)((x).size())
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const char en = '\n';
const int INF = 1e9 + 7;
const ll INFLL = 1e18;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

template<class T>
istream &operator>>(istream &is, vector<T> &a) {
    for (auto &i: a) {
        is >> i;
    }
    return is;
}

#ifdef LOCAL
#include "debug.h"
#else
#define debug(...) 42
#endif

void solve() {
    int q;
    cin >> q;
    for (int w = 0; w < q; ++w) {
        ll x;
        cin >> x;
        x = abs(x);
        if (x == 0) {
            cout << 0 << en;
            continue;
        }
        vector<int> bits;
        for (int l = 60; l >= 0; --l) {
            if ((x & (1LL << l)) == 0) {
                if (!bits.empty()) {
                    bits.emplace_back(0);
                }
            }
            else {
                bits.emplace_back(1);
            }
        }
        debug(bits);
        int cnt[2] = {0, 0};
        for (auto i: bits) {
            if (i) {
                cnt[i]++;
            }
        }
        int ans = cnt[1];
        int k = sz(bits);
        for (int i = 0; i < k; ++i) {
            if (bits[i] == 0) {
                ++cnt[0];
            }
            if (bits[i] == 1) {
                --cnt[1];
            }
            int here = 1 + 1 + cnt[1] + cnt[0];
            ans = min(ans, here);


        }
        ans = min(ans, 2 + cnt[0]);
        cout << ans << en;
    }
}

int32_t main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif
    solve();
    return 0;
}
