#include <bits/stdc++.h>

using namespace std;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const char en = '\n';
const int INF = 1e9 + 7;
const ll INFLL = 1e18;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

template<class T>
istream &operator>>(istream &is, vector<T> &a) {
    for (auto &i: a) {
        is >> i;
    }
    return is;
}

#ifdef LOCAL

#include "debug.h"

#else
#define debug(...) 42
#endif

void solve() {
    int n;
    cin >> n;
    string s;
    cin >> s;
    vector<int> ans;
    set<int> fr;
    for (int i = 1; i <= n; ++i) {
        fr.insert(i);
    }
    ans.push_back({n + 1});
    int gg = 0;
    for (int i = 0; i < n;) {
        if (s[i] == 'B') {
            int j = i;
            while (j < n && s[j] == 'B') {
                ++j;
            }
            for (int k = i; k < j; ++k) {
                if (gg % 2 == 0) {
                    ans.push_back(ans.back() - 1);
                    fr.erase(ans.back());
                } else {
                    ans.push_back(ans.back() + 1);
                    fr.erase(ans.back());
                }
            }
            i = j;
        } else {
            if (gg % 2 == 0) {
                ans.push_back(*fr.begin());
                fr.erase(fr.begin());
            } else {
                ans.push_back(*prev(fr.end()));
                fr.erase(prev(fr.end()));
            }
            ++gg;
            ++i;
        }
    }
    int r = 0, b = 0;
    for (int i = 0; i < n; ++i) {
        if (s[i] == 'A') {
            if (ans[i] > ans[i + 1]) {
                ++r;
            } else {
                ++b;
            }
        }
    }
    debug(abs(r - b));
    for (int i: ans) {
        cout << i << " ";
    }
}

int32_t main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif
    solve();
    return 0;
}
