#include <iostream>
#include <cmath>
#include <vector>
#include <string>
#include <cassert>
#include <cmath>
#include <queue>
#include <deque>
#include <algorithm>
#include <stack>
#include <iomanip>
#include <random>
#include <map>
#include <set>
#include <chrono>

#define fast() ios::sync_with_stdio(0); cin.tie(0);
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

using namespace std;
using ll = long long;
using ull = unsigned long long;
using ld = long double;
const ll inf = ll(1e18) * 2 + 36ll;
const int mod = ll(1e9) + 7ll;
const ld pi = acos(-1), eps = 1e-7;

using vll = vector<ll>;

mt19937_64 rnd(time(0));

ll find(ll x) {
	ll res = 1;
	while (res * 2 <= x) {
		res *= 2;
	} return res;
}

signed main() {
	fast();
	ll t;cin >> t;
	for (int _ = 0; _ < t; _++) {
		ll x;
		cin >> x;
		x = abs(x);
		queue<pair<ll, ll>> q;
		q.push({ x,0 });
		if (x == 0) {
			cout << 0 << '\n';
			continue;
		}
		while (!q.empty()) {
			pair<ll, ll> top = q.front();
			q.pop();
			ll b1 = find(top.first);
			ll b2 = b1 * 2;
			if (top.first - b1 == 0 || top.second - b2 == 0) {
				cout << top.second + 1 << '\n';
				break;
			}
			else {
				q.push({ top.first - b1, top.second + 1 });
				q.push({ b2 - top.first, top.second + 1 });
			}
		}
	}
	return 0;
}