#include <bits/stdc++.h>

using namespace std;

#define int long long
#define pii pair<int, int>
#define F first
#define S second
#define pb push_back
#define eb emplace_back
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define sz(a) int(a.size())
#define dbg(a) cout << #a << " = " << a << "\n"
#define dbg1(a) cout << #a << " = [ "; for (auto& _ : a) cout << _ << " "; cout << "]\n"
#define dbg2(a) cout << #a << " = [ "; for (auto& _ : a) cout << "(" << _.first << " " << _.second << ") "; cout << "]\n"
#define fastIo(a) ios_base::sync_with_stdio(a); cin.tie(a); cout.tie(a)

using ll = long long;
using ld = long double;
const double Pi = 3.14159265;


const int INF = 2e9;
const ll INFll = 2e18;
const double EPS = 1e-8;

mt19937 rnd(chrono::steady_clock().now().time_since_epoch().count());


void solve() {
    int n;
    cin >> n;
    vector<int> a(n), b(n);
    for (int i = 0; i < n; i++)
        cin >> a[i] >> b[i];
    vector<int> p(n);
    iota(all(p), 0);
    auto bad = [&](int i, int j, int k) {
        return a[i] * b[j] + a[j] * b[k] + a[k] * b[i] < a[i] * b[k] + a[k] * b[j] + a[j] * b[i];
    };
    bool ok = false;
    vector<int> res;
    while (!ok) {
        shuffle(all(p), rnd);
        ok = true;
        vector<int> used(n);
        res.clear();
        int sz = 0;
        for (int i = 0; i < n; i++) {
            if (sz <= 1) {
                res.push_back(p[i]);
                used[i] = 1;
                sz++;
            } else {
                bool k = false;
                for (int j = 0; j < n; j++) {
                    if (!used[j] && !bad(res[sz - 2], res[sz - 1], p[j])) {
                        used[j] = 1;
                        res.push_back(p[j]);
                        k = true;
                        sz++;
                        break;
                    }
                }
                if (!k) {
                    ok = false;
                    break;
                }
            }
        }
    }
    for (int i : res) cout << i + 1 << " "; cout << '\n';
}

signed main() {
    fastIo(0);
    int t = 1;
    //cin >> t;
    while (t--) solve();
}