#include <bits/stdc++.h>

using namespace std;

#define int long long
#define pii pair<int, int>
#define F first
#define S second
#define pb push_back
#define eb emplace_back
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define sz(a) int(a.size())
#define dbg(a) cout << #a << " = " << a << "\n"
#define dbg1(a) cout << #a << " = [ "; for (auto& _ : a) cout << _ << " "; cout << "]\n"
#define dbg2(a) cout << #a << " = [ "; for (auto& _ : a) cout << "(" << _.first << " " << _.second << ") "; cout << "]\n"
#define fastIo(a) ios_base::sync_with_stdio(a); cin.tie(a); cout.tie(a)

using ll = long long;
using ld = long double;
const double Pi = 3.14159265;


const int INF = 2e9;
const ll INFll = 2e18;
const double EPS = 1e-8;

mt19937 rnd(time(0));

const int p = 239, mod = 1e9 + 7;


void solve() {
    int n;
    cin >> n;
    vector<string> v(n);
    for (auto &i : v) cin >> i;
    int ln = v[0].size();
    vector<vector<int>> pref(n, vector<int>(ln + 1));
    for (int i = 0; i < n; i++) {
        for (int j = 1; j <= ln; j++) {
            pref[i][j] = (pref[i][j - 1] * p + (v[i][j - 1] - 'a' + 1)) % mod;
        }
    }
    int l = 0, r = ln + 1;
    while (l + 1 < r) {
        int m = (l + r) / 2;
        map<int, int> cnt;
        for (int i = 0; i < n; i++) {
            cnt[pref[i][m]]++;
        }
        bool fl = true;
        for (auto &[k, v] : cnt) fl &= !(v & 1);
        if (fl) l = m;
        else r = m;
    }
    cout << l << '\n';
}

signed main() {
    fastIo(0);
    int t = 1;
//    cin >> t;
    while (t--) solve();
}
