﻿#include <iostream>
#include <algorithm>
#include <math.h>
#include <vector>
#include <set>
#include <string>
#include <map>
#include <stack>
#include <deque>
using namespace std;
using ll = long long;
const ll LONGINF = 1e18 + 7;
const int INF = 1e9 + 7;
int gcd(int a, int b)
{
	if (b == 0) return a;
	return gcd(b, a % b);
}

void solve() 
{
	int n;
	cin >> n;
	ll m = 0;
	vector<int> a(n);
	for (int i = 0; i < n; i++)
	{
		cin >> a[i];
		m += a[i];
	}
	m = (m + 1) / 2;
	int l = 0, r = 0;
	ll sum = 0;
	int ans = INF;
	multiset<int> s;
	while (r < n)
	{
		if (r < n)
		{
			sum += a[r];
			s.insert(a[r]);
			r++;
		}
		while (sum - a[l] >= m)
		{
			sum -= a[l];
			s.erase(s.find(a[l]));
			l++;
		}
		if (sum >= m && r - l < ans)
		{
			ans = r - l;
		}
		//cout << *s.begin() << ' ';
		if (sum - *s.begin() >= m && r - l-1 < ans)
		{
			ans = r - l-1;
		}
		//cout << l << ' ' << r << ' ' << sum << '\n';
	}
	cout << ans << '\n';
}
int main()
{
	int t = 1;
	//cin >> t;
	while (t--) solve();
}
//confirmed by association of the best code