﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <deque>
#include <cmath>
#include <ctime>
#include <map>

typedef long long ll;
using namespace std;

string bin(ll x) {
    string ans;
    if (x == 0) {
        return "0";
    }
    while (x != 0) {
        if ((x & 1) == 1) {
            ans += '1';
        }
        else {
            ans += '0';
        }
        x = x >> 1;
    }
    reverse(ans.begin(), ans.end());
    return ans;
}

int main()
{
    cin.tie(0)->sync_with_stdio(false);
    cout.tie(0)->sync_with_stdio(false);
    int q, c; cin >> q >> c;
    map<string, pair<int, int>> color;
    while (q--) {
        int t; cin >> t;
        if (t == 1) {
            int x; cin >> x;
            string s; cin >> s;
            color[s] = { x, q + 1 };
        }
        else {
            string s; cin >> s;
            string ns = "";
            ns += s[0];
            int time = 1e9, ind = s.size(), cl = -1;
            if (color[ns].second > 0 && color[ns].second < time) {
                time = color[ns].second;
                cl = color[ns].first;
                ind = 1;
            }
            for (int i = 1; i < (int)s.size(); i++) {
                if (color[ns].second > 0 && color[ns].second < time) {
                    time = color[ns].second;
                    cl = color[ns].first;
                    ind = i;
                }
                ns += s[i];
            }
            for (; ind < s.size(); ind++) {
                if (s[ind] == 'L') cl = (cl + 1) % c;
                else cl = (cl - 1 + c) % c;
            }
            cout << cl << endl;
        }
    }
}