#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>

#include <algorithm>
#include <cmath>

#include <chrono>
#include <random>

#include <unordered_map>
#include <unordered_set>
#include <functional>
#include <vector>
#include <string>
#include <array>
#include <tuple>
#include <deque>
#include <queue>
#include <stack>
#include <list>
#include <set>
#include <map>

using namespace std;
using namespace chrono;

using ll = long long;
using ull = unsigned long long;
using ld = long double;

constexpr ll INF = 1e15;
constexpr ld EPS = 1e-9L;

mt19937 rnd(0);

ll f(ll x) {
    ll res = 0;
    for (ll i = 0; i < 63; ++i)
        if ((x >> i) & 1)
            ++res;
    return res;
}

ll g(ll x) {
    ll res = 1;
    for (; res <= x; res *= 2);
    return res;
}

void dfs(ll x, ll cnt, ll& res) {
    if (x == 0) {
        res = min(res, cnt);
        return;
    }

    if (cnt >= res)
        return;

    res = min(res, cnt + f(x));

    dfs(g(x) - x, cnt + 1, res);
}

int main() {
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr);
    cin.tie(nullptr);
    
    ll _ = 1;
    cin >> _;
    while (_--) {
        ll n, res = 65;
        cin >> n;
        n = abs(n);

        dfs(n, 0, res);
        cout << res << '\n';
    }
}