#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>

#include <algorithm>
#include <cmath>

#include <chrono>
#include <random>

#include <unordered_map>
#include <unordered_set>
#include <functional>
#include <vector>
#include <string>
#include <array>
#include <tuple>
#include <deque>
#include <queue>
#include <stack>
#include <list>
#include <set>
#include <map>

using namespace std;
using namespace chrono;

using ll = long long;
using ull = unsigned long long;
using ld = long double;

constexpr ll INF = 1e15;
constexpr ld EPS = 1e-9L;

mt19937 rnd(0);

vector<ll> a(1e7 + 1);

ll f(ll n) {
    ll d = 2, b = 10, ans = 10;
    if (n < 10) {
        return n + 1;
    }
    while (true) {
        if (b * 10 > n) {
            ans += (n - b + 1) * d;
            return ans;
        }
        ans += b * 9 * d;
        d++;
        b *= 10;
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr);
    cin.tie(nullptr);

    ll s;
    cin >> s;
    for (int i = 0; i < 1e7 + 1; ++i) {
        a[i] = f(i);
    }
    ll l = -1, r = 1e18 + 1, mid;
    while (l + 1 < r) {
        mid = (l + r) / 2;
        ll res = f(mid);
        if (res >= s) {
            r = mid;
        }
        else {
            l = mid;
        }
    }
    if (r == 1e18 + 1) {
        cout << -1;
        return 0;
    }
    if (f(r) == s) {
        cout << r + 1 << '\n';
        cout << 0 << " " << r;
        return 0;
    }
    cout << a.back() << '\n';
    while (true) {
        ll x = f(r) - s;
        int j = lower_bound(a.begin(), a.end(), x) - a.begin();
        if (j == a.size()) {
            cout << -1;
            return 0;
        }
        if (a[j] == x) {
            cout << r - j + 1 << '\n';
            cout << j << " " << r;
            return 0;
        }
        r++;
        if (r > 1e18) {
            cout << -1;
            return 0;
        }
    }
}