#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <queue>
#include <deque>
#include<stack>
#include<string>
#include<iomanip>
#include<set>

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

using namespace std;
using ll = long long;
using ld = long double;

ll gcd(ll a, ll b) {
	if (b == 0) return a;
	return gcd(b, a % b);
}

ll lcm(ll a, ll b) {
	return a / gcd(a, b) * b;
}

void cinv(vector <ll>& a) {
	for (int i = 0; i < a.size(); ++i) {
		cin >> a[i];
	}
}

// ==============================================================================

void solve() {
	/*ll n;
	cin >> n;
	if (n == 3) {
		cout << 1;
	}
	else if (n == 6) {
		cout << 4;
	}
	else {
		cout << n - 1;
	}*/
	int n;
	cin >> n;
	vector <string> a(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}
	sort(all(a));
	ll k = a[0].size();
	for (int i = 0; i < n - 1; i += 2) {
		for (int j = 0; j < a[i].size(); ++j) {
 			if (a[i][j] != a[i + 1][j]) {
				k = min(k, (ll)j);
				break;
			}
		}
	}
	cout << k;
}

// ==============================================================================

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	ll t = 1;
	//cin >> t;
	while (t--) solve();
	return 0;
}