#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

const int N = 1e5 + 7;
const int Lo = log2(N);
ll n, a[N], S, pref[N], sp[N][Lo+1];

void init() {
	for(int i = 1; i <= n; ++i) {
		pref[i] = pref[i-1] + a[i];
		sp[i][0] = a[i];
	}
	
	for(int l = 1; l <= Lo; ++l) {
		for(int i = 1; i <= n - (1 << l) + 1; ++i) {
			sp[i][l] = min(sp[i][l-1], sp[i+(1<<(l - 1))][l-1]);
		}
	}
}

ll Sum(int l, int r) {
	return pref[r] - pref[l-1];
}

ll Min(int l, int r) {
	int lo = __lg(r - l + 1);
	return min(sp[l][lo], sp[r - (1 << lo) + 1][lo]);
}

int get(int bg) {
	int L = bg, R = n, res = n;
	while(L <= R) {
		int M = (L + R) / 2;
		if (Sum(bg, M) < S) {
			L = res = M + 1;
		} else R = M - 1;
	}
//	cerr << "Bg: " << bg << " res; " << res << '\n';
	if (res == n + 1 || Sum(bg, res) < S) {
		return n + 1;
	} else {
		return res - bg + 1;
	}
}

int get_with_del(int bg) {
	int L = bg, R = n, res = n;
	while(L <= R) {
		int M = (L + R) / 2;
//		cerr << "[" << bg << ", " << M << "]: " << Sum(bg, M) << " " << Min(bg, M) << '\n';
		if (Sum(bg, M) - Min(bg, M) < S) {
			L = res = M + 1;
		} else R = M - 1;
	}
	if (res == n + 1 || Sum(bg, res) - Min(bg, res) < S) {
		return n + 1;
	} else {
		return res - bg;
	}
}

int main()  {
	ios_base::sync_with_stdio(0) , cin.tie(0) , cout.tie(0) ;
	cin >> n;
	for(int i = 1; i <= n; ++i) {
		cin >> a[i];
		S += a[i];
	}
	init();
	S = (S / 2) + (S & 1);
//	cerr <<"S: " << S << '\n';
	int res = n + 1;
	for(int i = 1; i <= n; ++i) {
		int fs = get(i), fss = get_with_del(i);
//		cout << i << " -> " << "get: " << fs << " get_with_del: " << fss << '\n';
		res = min(res, min(fs, fss));
//		exit(false);
	}
	
	cout << res << '\n';
}