#include <bits/stdc++.h>

#define ll long long
#define ld long double
#define int long long
#define pb push_back
#define debug(x) cerr << #x << " = " << x << endl;
#define x first
#define y second
using namespace std;

pair<pair<int, int>, pair<int, int> > p[105];

pair <int, int> makev(pair <int, int> a, pair <int, int> b) {
    return {b.x - a.x, b.y - a.y};
}

int scal(pair <int, int> a, pair <int, int> b) {
    return a.x * b.x + a.y * b.y;
}

int vek(pair <int, int> a, pair <int, int> b)
{
    return a.x * b.y - a.y * b.x;
}

ld get_l(pair<int, int> p1, pair<int, int> p2)
{
    return sqrtl((p1.x - p2.x) * (p1.x - p2.x) + (p1.y - p2.y) * (p1.y - p2.y));
}

ld get_dist(pair<pair<int, int>, pair<int, int> > p1, pair<pair<int, int>, pair<int, int> > p2)
{
    ld ans = get_l(p1.x, p2.x);
    ans = min(ans, get_l(p1.x, p2.y));
    ans = min(ans, get_l(p1.y, p2.x));
    ans = min(ans, get_l(p1.y, p2.y));
    if(scal(makev(p1.x, p1.y), makev(p1.x, p2.x)) >= 0 && scal(makev(p1.y, p1.x), makev(p1.y, p2.x)))
    {
        ld a = p1.x.y - p1.y.y, b = p1.y.x - p1.x.x, c = -p1.x.x * a - p1.x.y * b;
        ans = min(ans, abs(a * p2.x.x + b * p2.x.y + c) / sqrtl(a * a + b * b));
    }
    if(scal(makev(p1.x, p1.y), makev(p1.x, p2.y)) >= 0 && scal(makev(p1.y, p1.x), makev(p1.y, p2.y)))
    {
        ld a = p1.x.y - p1.y.y, b = p1.y.x - p1.x.x, c = -p1.x.x * a - p1.x.y * b;
        ans = min(ans, abs(a * p2.y.x + b * p2.y.y + c) / sqrtl(a * a + b * b));
    }

    return ans;
}

ld get_len_seg(pair<pair<int, int>, pair<int, int> > p1, pair<pair<int, int>, pair<int, int> > p2)
{
    pair<int, int> v1 = makev(p1.x, p2.x);
    pair <int, int> v2 = makev(p1.x, p1.y);
    pair<int, int> v3 = makev(p1.x, p2.y);
    pair<int, int> v11 = makev(p2.x, p1.x);
    pair<int, int> v21 = makev(p2.x, p2.y);
    pair<int, int> v31 = makev(p2.x, p1.y);


    if (vec(v1, v2) * vec(v3, v2) <= 0 && vec(v11, v21) * vec(v31, v21) <= 0) {
        return 0;
    }

    //v1 = makev(p2.x, p1.x);
    //v2 = makev(p2.x, p2.y);
    //v3 = makev(p2.x, p1.y);
    //if (scal(v1, v2) * scal(v3, v2) > 0) {
        return min(get_dist(p1, p2), get_dist(p2, p1));
    //}
    //return 0;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, ans = 0;
    cin >> n;
    for(int i = 0; i < n; ++i)
    {
        cin >> p[i].x.x >> p[i].x.y >> p[i].y.x >> p[i].y.y;
    }

    for(int i = 0; i < n; ++i)
    {
        for(int j = i + 1; j < n; ++j)
        {
            for(int k = j + 1; k < n; ++k)
            {
                if(i != j && i != k && j != k)
                {
                    if(get_len_seg(p[i], p[j]) <= get_l(p[k].x, p[k].y) || get_len_seg(p[i], p[k]) <= get_l(p[j].x, p[j].y) || get_len_seg(p[k], p[j]) <= get_l(p[i].x, p[i].y))
                    {
                        cout << "____" << get_len_seg(p[i], p[j]) << ' ' <<  get_l(p[k].x, p[k].y) << '\n';
                        cout << "____" << get_len_seg(p[i], p[k]) << ' ' <<  get_l(p[j].x, p[j].y) << '\n';
                        cout << "____" << get_len_seg(p[k], p[j]) << ' ' <<  get_l(p[i].x, p[i].y) << '\n';
                        cout << i << ' ' << j << ' ' << k << '\n';
                        ans++;
                    }
                }
            }
        }
    }
    cout << ans << '\n';
}

//460004
