#include <bits/stdc++.h>

using namespace std;

#define int long long

template <typename T>
ostream& operator<<(ostream& out, const vector<T>& v) {
    for (auto x : v) {
        out << x << ' ';
    }
    return out;
}

const long long INF = 1e18;

int ans;

void f(int x, int cnt) {
    if (x == 0) {
        ans = min(ans, cnt);
        return;
    }
    int l = __lg(x);
    int step = ((int)1 << l);
    f(x - step, cnt + 1);
    if (step < x)
        f(2 * step - x, cnt + 1);
}

map <int, int> cnt;

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t;
    cin >> t;
    while (t--) {
        int x;
        ans = INF;
        cin >> x;
        if (cnt.find(x) != cnt.end()) {
            cout << cnt[x] << '\n';
            continue;
        }
        if (x < 0)
            x *= -1;
        f(x, (int)0);
        cnt[x] = ans;
        cout << ans << '\n';
    }
    return 0;
}
