#include <bits/stdc++.h>

using namespace std;

#define int int_fast64_t
#define segl(i) ((i) * 2 + 1), l, (l + r) / 2
#define segr(i) ((i) * 2 + 2), (l + r) / 2, r

int c;
int timeline = 0;

struct Bor {
    vector<signed> path;
    int color;
    int timeline;
    Bor() {
        path.assign(2, 0);
        color = -1;
        timeline = -1;
    }
};

vector<Bor> tree;
int last = 1;

int find_color(const string& path) {
    int cur = 0;
    for(int j = 0; j<path.size(); ++j) {
        if(path[j] == 'L') {
            if(tree[cur].path[0] == 0) {
                tree[cur].path[0] = last++;
            }
            if(tree[cur].color != -1 && tree[tree[cur].path[0]].timeline < tree[cur].timeline) {
                tree[tree[cur].path[0]].color = tree[cur].color + 1;
                tree[tree[cur].path[0]].color %= c;
                tree[tree[cur].path[0]].timeline = tree[cur].timeline;
            }
            cur = tree[cur].path[0];
        }
        else {
            if(tree[cur].path[1] == 0) {
                tree[cur].path[1] = last++;
            }
            if(tree[cur].color != -1 && tree[tree[cur].path[1]].timeline < tree[cur].timeline) {
                tree[tree[cur].path[1]].color = tree[cur].color - 1;
                tree[tree[cur].path[1]].color += c;
                tree[tree[cur].path[1]].color %= c;
                tree[tree[cur].path[1]].timeline = tree[cur].timeline;
            }
            cur = tree[cur].path[1];
        }
    }
    return tree[cur].color;
}

int set_color(const string& path, int color) {
    int cur = 0;
    for(signed j = 0; j<path.size(); ++j) {
        if(path[j] == 'L') {
            if(tree[cur].path[0] == 0) {
                tree[cur].path[0] = tree.size();
                tree.emplace_back();
            }
            if(tree[cur].color != -1 && tree[tree[cur].path[0]].timeline < tree[cur].timeline) {
                tree[tree[cur].path[0]].color = tree[cur].color + 1;
                tree[tree[cur].path[0]].color %= c;
                tree[tree[cur].path[0]].timeline = tree[cur].timeline;
            }
            cur = tree[cur].path[0];
        }
        else {
            if(tree[cur].path[1] == 0) {
                tree[cur].path[1] = tree.size();
                tree.emplace_back();
            }
            if(tree[cur].color != -1 && tree[tree[cur].path[1]].timeline < tree[cur].timeline) {
                tree[tree[cur].path[1]].color = tree[cur].color - 1;
                tree[tree[cur].path[1]].color += c;
                tree[tree[cur].path[1]].color %= c;
                tree[tree[cur].path[1]].timeline = tree[cur].timeline;
            }
            cur = tree[cur].path[1];
        }
    }
    tree[cur].color = color;
    tree[cur].timeline = timeline++;
}

void solve() {
    tree.assign(500005, Bor());
    int q;
    cin >> q >> c;
    for(int i = 0; i<q; ++i) {
        int t;
        cin >> t;
        if(t == 1) {
            int x;
            cin >> x;
            string path;
            cin >> path;
            set_color(path, x);
        }
        else {
            string path;
            cin >> path;
            cout << find_color(path) << endl;
        }
    }
}

signed main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    //cin >> t;
    while(t--)
        solve();
}
