#include <bits/stdc++.h>

using namespace std;

//#define int int_fast64_t
#define segl(i) ((i) * 2 + 1), l, (l + r) / 2
#define segr(i) ((i) * 2 + 2), (l + r) / 2, r

int c;
int timeline = 0;

struct Bor {
    vector<Bor*> path;
    int color;
    int timeline;
    Bor() {
        path.assign(2, nullptr);
        color = -1;
        timeline = -1;
    }
};

 Bor* tree;

int find_color(const string& path) {
    Bor* cur = tree;
    for(signed j = 0; j<path.size(); ++j) {
        if(path[j] == 'L') {
            if(cur->path[0] == nullptr) {
                cur->path[0] = new Bor();
            }
            if(cur->color != -1 && cur->path[0]->timeline < cur->timeline) {
                cur->path[0]->color = cur->color + 1;
                cur->path[0]->color %= c;
                cur->path[0]->timeline = cur->timeline;
            }
            cur = cur->path[0];
        }
        else {
            if(cur->path[1] == nullptr) {
                cur->path[1] = new Bor();
            }
            if(cur->color != -1 && cur->path[1]->timeline < cur->timeline) {
                cur->path[1]->color = cur->color - 1;
                cur->path[1]->color += c;
                cur->path[1]->color %= c;
                cur->path[1]->timeline = cur->timeline;
            }
            cur = cur->path[1];
        }
    }
    return cur->color;
}

int set_color(const string& path, signed color) {
    Bor* cur = tree;
    for(signed j = 0; j<path.size(); ++j) {
        if(path[j] == 'L') {
            if(cur->path[0] == nullptr) {
                cur->path[0] = new Bor();
            }
            if(cur->color != -1 && cur->path[0]->timeline < cur->timeline) {
                cur->path[0]->color = cur->color++;
                cur->path[0]->color %= c;
                cur->path[0]->timeline = cur->timeline;
            }
            cur = cur->path[0];
        }
        else {
            if(cur->path[1] == nullptr) {
                cur->path[1] = new Bor();
            }
            if(cur->color != -1 && cur->path[1]->timeline < cur->timeline) {
                cur->path[1]->color = cur->color--;
                cur->path[1]->color += c;
                cur->path[1]->color %= c;
                cur->path[1]->timeline = cur->timeline;
            }
            cur = cur->path[1];
        }
    }
    cur->color = color;
    cur->timeline = timeline++;
}

void solve() {
    tree = new Bor();
    int q;
    cin >> q >> c;
    for(int i = 0; i<q; ++i) {
        int t;
        cin >> t;
        if(t == 1) {
            int x;
            cin >> x;
            string path;
            cin >> path;
            set_color(path, x);
        }
        else {
            string path;
            cin >> path;
            cout << find_color(path) << endl;
        }
    }
}

signed main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    //cin >> t;
    while(t--)
        solve();
}
