#include <bits/stdc++.h>

using namespace std;

// clang-format off
#define int long long
#define eb emplace_back
#define ef emplace_front
#define pub push_back
#define pob pop_back
#define puf push_front
#define pof pop_front
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define vi vector <int>
#define sz(a) (int)(a).size()
typedef long long ll;
typedef long double ld;
template<typename TYPE> using ve = vector<TYPE>;
// clang-format on

struct segtree {
    struct node {
        int min;
    };
    int size = 1;
    node zero = {(int)1e18};
    vector <node> tree;
    explicit segtree(int n) {
        while (size < n) {
            size *= 2;
        }
        tree.assign(size * 2 - 1, zero);
    }
    node merge(node a, node b) {
        node res = {min(a.min, b.min)};
        return res;
    }
    void build() {
        for (int i = size - 2; i >= 0; i--) {
            tree[i] = merge(tree[i * 2 + 1], tree[i * 2 + 2]);
        }
    }
    node get(int v, int tl, int tr, int l, int r) {
        if (tr <= l || tl >= r) {
            return zero;
        }
        if (l <= tl && tr <= r) {
            return tree[v];
        }
        int tm = (tl + tr) / 2;
        return merge(get(2 * v + 1, tl, tm, l, r), get(2 * v + 2, tm, tr, l, r));
    }
    int get(int l, int r) {
        return get(0, 0, size, l, r).min;
    }
};

void solve() {
    int n;
    cin >> n;
    vi a(n);
    int sum = 0;
    vi p(n + 1, 0);
    segtree t(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        sum += a[i];
        t.tree[t.size + i - 1] = {a[i]};
        p[i + 1] = p[i] + a[i];
    }
    t.build();
    int minn = 1e9;
    for (int i = 0; i < n; i++) {
        int l = i - 1, r = n - 1;
        while (r - l > 1) {
            int m = (r + l) / 2;
            if ((p[m + 1] - p[i]) * 2 >= sum) {
                r = m;
            } else {
                l = m;
            }
        }
        if ((p[r + 1] - p[i]) * 2 >= sum) {
            int res = p[r + 1] - p[i];
            res -= t.get(i, r + 1);
            if (res * 2 >= sum) {
                minn = min(minn, r - i);
            }
            minn = min(minn, r - i + 1);
        }
    }
    cout << minn;
    cout << "\n";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    //    cin >> t;
    while (t--) solve();
    return 0;
}