﻿#include "bits/stdc++.h"
#include <ext/pb_ds/detail/standard_policies.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
#define all(x) (x).begin(), (x).end()
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

#ifdef CLOWN
#include "trash.h"
#define dbg(...) cout << "[" << #__VA_ARGS__ << "]:", debug_out(__VA_ARGS__);
#else
#define dbg(...);
#endif

int test = 0;

void fastio() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
}

const int P = 239, MOD = 1e9 + 9, N = 5e5 + 5;
int mn = N;
ll pows[N];

void make() {
    pows[0] = 1;
    for (int i = 1; i < N; i++) {
        pows[i] = pows[i - 1] * P % MOD;
    }
}

struct Hash {
    vector<ll> hsh;

    void build(string &s) {
        int n = (int) s.size();
        hsh.resize(n);
        hsh[0] = s[0];
        for (int i = 1; i < n; i++) {
            hsh[i] = (hsh[i - 1] * P % MOD + s[i]) % MOD;
        }
    }

    ll get(int l, int r) {
        if (l == 0)
            return hsh[r];
        return (hsh[r] - hsh[l - 1] * pows[r - l + 1] % MOD + MOD) % MOD;
    }
};

void solve() {
    int q, c;
    cin >> q >> c;
    map<ll, pair<int, int>> query;
    int timer = 1;
    while (q--) {
        int t;
        cin >> t;
        if (t == 1) {
            int x;
            cin >> x;
            string s;
            cin >> s;
            Hash kek;
            kek.build(s);
            query[kek.get(0, s.size() - 1)] = {x, timer++};
        } else {
            int cur = -1;
            string s;
            cin >> s;
            dbg(s)
            Hash kek;
            kek.build(s);
            pair<int, int> now = {-1, -1};
            for (int i = 0; i < s.size(); i++) {
                ll hash = kek.get(0, i);
                if (now.first != -1) {
                    if (s[i] == 'L') {
                        cur = (cur + 1) % c;
                    } else {
                        cur = (cur - 1 + c) % c;
                    }
                }
                if (query.find(hash) == query.end()) continue;
                pair<int, int> tmp = query[hash];
                if (tmp.second > now.second) {
                    now = tmp;
                    cur = tmp.first;
                }
            }
            cout << cur << "\n";
        }
    }
}

int32_t main() {
    make();
#ifdef CLOWN
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t = 1;
    fastio();
    if (test) cin >> t;
    while (t--) { solve(); }
    return 0;
}
