#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long
#define vec vector
#define sz(x) (int)x.size()
#define f first
#define s second
#define all(x) (x.begin(), x.end())

using ll = long long;

const int oo = 1e9;
const ll OO = 1e18;
const int N = 1e5 + 10;
int a[N], mn[4 * N];

void build(int v, int tl, int tr)
{
    if (tl == tr)
    {
        mn[v] = a[tl];
        return;
    }
    int m = tl + tr >> 1;
    build(2 * v + 1, tl, m);
    build(2 * v + 2, m + 1, tr);
    mn[v] = min(mn[2 * v + 1], mn[2 * v + 2]);
}

int get(int l, int r, int v, int tl, int tr)
{
    if (tl > r || tr < l) return OO;
    if (tl >= l && tr <= r) return mn[v];
    int m = tl + tr >> 1;
    return min(get(l, r, 2 * v + 1, tl, m), get(l, r, 2 * v + 2, m + 1, tr));
}

int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n;
    cin >> n;
    for (int i = 1; i <= n; i++) cin >> a[i];
    build(0, 1, n);
    vec<int> p(n + 1);
    for (int i = 1; i <= n; i++) p[i] = p[i - 1] + a[i];
    int ans = OO;
    auto sum = [&](int l, int r) -> int
    {
        return p[r] - p[l - 1];
    };
    int x = (p[n] + 1) / 2;
    for (int i = 1; i <= n; i++)
    {
        int l = i, r = n + 1;
        while (l < r)
        {
            int m = l + r >> 1;
            if (sum(i, m) - get(i, m, 0, 1, n) >= x) r = m;
            else l = m + 1;
        }
        if (l != n + 1) ans = min(ans, r - i);
        l = i, r = n + 1;
        while (l < r)
        {
            int m = l + r >> 1;
            if (sum(i, m) >= x) r = m;
            else l = m + 1;
        }
        if (l != n + 1) ans = min(ans, r - i + 1);
    }
    cout << ans;
    return 0;
}
