﻿#include <iostream>
#include <vector>

using namespace std;
using ll = long long;

ll sum2(ll n) {
    return n * (n + 1) * (2 * n + 1) / 6;
}

ll sum(ll n) {
    return n * (n + 1) / 2;
}

// [l, r]
ll sum2(int l, int r) {
    return sum2(r) - sum2(l - 1);
}

ll sum(int l, int r) {
    return sum(r) - sum(l - 1);
}

int main() {
    int n, x;
    cin >> n;
    ll ans = n * (n - 1) / 2, s2;
    for (int l = 1; l <= n; ++l) {
        for (int r = l; r <= n; ++r) {
            s2 = sum2(l, r);
            x = sum(l, r) - n;
            if (x == 0) {
                ans = min(ans, (sum2(l, r) - n) / 2);
            } else if (l <= x && x <= r) {
                ans = min(ans, (sum2(l, r) - x * x - n) / 2);
            }
        }
    }
    cout << ans;
    return 0;
}
