﻿#include <iostream>
#include <vector>
#include <queue>

using namespace std;

const int ALPH = 26, MAXN = 2e6 + 3;

struct node {
    int go[ALPH];
    int flag;

    node() {
        for (int i = 0; i < ALPH; ++i) {
            go[i] = -1;
        }
        flag = 0;
    }
};

node v[MAXN];
int sz = 1;

void add_string(const string& s, int ind = 0) {
    for (auto c : s) {
        c -= 'a';
        if (v[ind].go[c] == -1) {
            v[ind].go[c] = sz;
            ++sz;
        }
        ind = v[ind].go[c];
    }
    ++v[ind].flag;
}

void dfs(int u, int h, vector<int>& a) {
    for (int i = 0; i < ALPH; ++i) {
        if (v[u].go[i] != -1) {
            dfs(v[u].go[i], h + 1, a);
            v[u].flag += v[v[u].go[i]].flag;
        }
    }
    if (v[u].flag & 1) {
        a[h] = 0;
    }
}

int main() {
    int n, l;
    cin >> n;
    vector<string> s(n);
    for (int i = 0; i < n; ++i) {
        cin >> s[i];
        add_string(s[i]);
    }
    l = s[0].size();
    vector<int> ans(l + 1, 1);
    dfs(0, 0, ans);
    for (int i = l; i >= 0; --i) {
        if (ans[i]) {
            cout << i;
            return 0;
        }
    }
    return 0;
}
