#include <bits/stdc++.h>

#define fr(i, a, b) for (int i = (a); i <= (b); ++i)
#define rf(i, a, b) for (int i = (a); i >= (b); --i)
#define fe(x, y) for (auto& x : y)

#define fi first
#define se second
#define pb push_back
#define mp make_pair
#define mt make_tuple

#define all(x) (x).begin(), (x).end()
#define sz(x) (int)(x).size()
#define pw(x) (1LL << (x))

using namespace std;

mt19937_64 rng(chrono::system_clock::now().time_since_epoch().count());

#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;
template <typename T>
using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
#define fbo find_by_order
#define ook order_of_key

template <typename T>
bool umn(T& a, T b) { return (a > b ? (a = b, 1) : 0); }
template <typename T>
bool umx(T& a, T b) { return (a < b ? (a = b, 1) : 0); }

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
template <typename T>
using ve = vector<T>;

const int N = 1e5 + 5;

int n;
int a[N];
ll pref[N];

int t[4 * N];

void build(int v = 1, int tl = 1, int tr = n) {
    if (tl == tr) {
        t[v] = a[tl];
        return;
    }
    int tm = (tl + tr) >> 1;
    build(v << 1, tl, tm);
    build(v << 1 | 1, tm + 1, tr);
    t[v] = min(t[v << 1], t[v << 1 | 1]);
}

int get(int v, int tl, int tr, int l, int r) {
    if (l > r) {
        return 1e9;
    }
    if (tl == l && tr == r) {
        return t[v];
    }
    int tm = (tl + tr) >> 1;
    return min(get(v << 1, tl, tm, l, min(r, tm)), get(v << 1 | 1, tm + 1, tr, max(tm + 1, l), r));
}

int get(int l, int r) {
    return get(1, 1, n, l, r);
}

int main() {
#ifndef LOCAL
    ios::sync_with_stdio(0);
    cin.tie(0);
#else
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    cin >> n;

    ll sum = 0;
    fr (i, 1, n) {
        cin >> a[i];
        pref[i] = a[i] + pref[i - 1];
        sum += a[i];
    }

    build();

    int best = 1e9;
    fr (i, 1, n) {
        int l = i;
        int r = n;
        while (l < r) {
            int mid = l + ((r - l) >> 1);

            ll s = pref[mid] - pref[i - 1];
            if (s * 2 >= sum) {
                r = mid;
            } else {
                l = mid + 1;
            }
        }

        if (2 * (pref[l] - pref[i - 1]) >= sum) {
            umn(best, l - i + 1);
        }
    }


    fr (i, 1, n) {
        int l = i;
        int r = n;
        while (l < r) {
            int mid = l + ((r - l) >> 1);

            ll s = pref[mid] - pref[i - 1] - get(i, mid);
            if (s * 2 >= sum) {
                r = mid;
            } else {
                l = mid + 1;
            }
        }

        if (2 * (pref[l] - pref[i - 1]) - get(i, l) >= sum) {
            umn(best, l - i);
        }
    }

    cout << best << "\n";

    return 0;
}
