#include <bits/stdc++.h>

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define fi first
#define se second
#define ft first
#define sd second

#define pb push_back
#define pob pop_back

#define sz(x) int((x).size())

#define all(x) (x).begin(), (x).end()

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef long double ld;

const int N = 2e5 + 25;

template <typename T>
using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#define fbo find_by_order
#define ook order_of_key

int n;
ll dp[N];
pair<ll, ll> a[N];

int main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    cin >> n;

    for(ll i = 1; i <= n; i++){
        a[i] = {i, (i  * (i - 1)) / 2};
        dp[i] = 1e18;
    }

    dp[0] = 0;

    for(ll i = 1; i <= n; i++){
        for(ll j = n - i; j >= 0; j--){
            dp[j + i] = min(dp[j + i], dp[j] + a[i].se);
        }
    }

    cout << dp[n] << "\n";

    return 0;
}
