#include <bits/stdc++.h>

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define fi first
#define se second
#define ft first
#define sd second

#define pb push_back
#define pob pop_back

#define sz(x) int((x).size())

#define all(x) (x).begin(), (x).end()

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef long double ld;

const ll N = 5e5 + 25;
const ll MOD = 1e9 + 7;
const ll MOD2 = 1e9 + 9;

template <typename T>
using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#define fbo find_by_order
#define ook order_of_key

ll P[N], c, q;
gp_hash_table<ll, ll> color;
gp_hash_table<ll, ll> lazy, lazy_fl;
gp_hash_table<ll, ll> was;

void push(ll Hash, ll sz){
    if(lazy_fl[Hash]){
        lazy[(Hash + 1*P[sz]) % MOD] = ((lazy[Hash] + 1) % c);
        lazy[(Hash + 2 * P[sz]) % MOD] = ((lazy[Hash] - 1 + c) % c);

        lazy_fl[(Hash + 1 * P[sz]) % MOD] = 1;
        lazy_fl[(Hash + 2 * P[sz]) % MOD] = 1;

        lazy[Hash] = 0;
        lazy_fl[Hash] = 0;

        color[(Hash + 1 * P[sz]) % MOD] = lazy[(Hash + 1 * P[sz]) % MOD];
        color[(Hash + 2 * P[sz]) % MOD] = lazy[(Hash + 2 * P[sz]) % MOD];

        was[(Hash + 1 * P[sz]) % MOD] = 1;
        was[(Hash + 2 * P[sz]) % MOD] = 1;
    }
}

int main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    P[0] = 31;

    for(int i = 1; i < N; i++){
        P[i] = (P[i - 1] * 31) % MOD;
    }

    cin >> q >> c;

    while(q--){
        int type;

        cin >> type;

        if(type == 1){
            ll x;
            string s;

            cin >> x >> s;

            ll Hash = 0;

            for(int i = 0; i < sz(s); i++){
                ll num;
                if(s[i] == 'L')num = 1;
                else num = 2;
                Hash = (Hash + num * P[i]) % MOD;
                push(Hash, i + 1);
            }

//            cout << s << " - " <<

            lazy[Hash] = x;
            lazy_fl[Hash] = 1;
            color[Hash] = x;
            was[Hash] = 1;

        } else {
            string s;

            cin >> s;

            ll Hash = 0;

            for(int i = 0; i < sz(s); i++){
                ll num;
                if(s[i] == 'L')num = 1;
                else num = 2;
                Hash = (Hash + num * P[i]) % MOD;
                push(Hash, i + 1);
            }



            if(was[Hash] == 0)cout << "-1\n";
            else cout << color[Hash] << "\n";
        }


    }

    return 0;
}
