#include <bits/stdc++.h>

#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

#define fi first
#define se second

#define pll pair <ll, ll>
#define pii pair <int, int>

#define sqr(x) (x) * (x)
#define pw(x) (1LL << x)

#define all(s) s.begin(), s.end()

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef long double ld;

const ll inf = 1e18;
const ll mxN = 2e5 + 3;
const ld pi = acos(-1);

ll binpow (ll a, ll b) {
    ll res = 1;

    while (b) {

        if (b & 1)
            res *= a;

        a *= a;
        b >>= 1;
    }

    return res;
}

ll S;

void brute(ll S) {

    for (int i = 0; i <= S; i += 1) {
        for (int j = i; j <= S; j += 1) {
            ll answer = 0;
            for (int k = i; k <= j; k += 1) {
                ll x = k;
                if (x == 0) {
                    answer += 1;
                } else {
                    while (x != 0) {
                        x /= 10;
                        answer += 1;
                    }
                }
            }
            if (answer == S) {
                cout << S << " " << answer << endl;
                cout << j - i + 1 << endl;
                cout << i << " " << j << endl;
                return;
            }
        }
    }
}

void solve() {

    cin >> S;

    ll d[19];

    for (int i = 1; i <= 18; i += 1) {
        d[i] = binpow (10, i) - binpow (10, i - 1);
    }
    d[1] += 1;

    ll l, r;

    l = 0;
    r = 1000000000000000000;

    ll sum = 0, pos = 0, sum1 = 0;

    for (int i = 1; i <= 18; i += 1) {
        if (sum + d[i] > S || sum1 + d[i] * i > S) {
            pos = i;
            break;
        }
        sum += d[i];
        sum1 += d[i] * i;
    }

    if ((S - sum1) % pos == 0) {
        cout << sum + ((S - sum1) / pos) << endl;
        cout << 0 << " " << sum + ((S - sum1) / pos) - 1 << endl;
    }
    else{
        cout << sum + ((S - sum1) / pos) - ((S - sum1) % pos) + 1 << endl;
        cout << ((S - sum1) % pos) << " " << sum + ((S - sum1) / pos) << endl;
    }
}

int main() {

#ifdef local
    freopen ("input.txt", "r", stdin);
    freopen ("output.txt", "w", stdout);
#endif // local

    solve();


    return 0;
}
