#include <bits/stdc++.h>
#define ll long long
#define pb push_back
using namespace std;
struct sgtree{
    vector <ll> tree;
    int size;
    void init(int n){
      size = 1;
      while(size < n) size *= 2;
      tree.assign(2*size - 1, 0);
    }
    void set(int i, int v, int x, int lx, int rx){
        if(rx - lx == 1){
            tree[x]=v;
            return;
        }
        ll m = (rx+lx)/2;
        if (i < m){
            set(i, v, 2*x+1, lx, m);
        }else{
            set(i, v, 2*x+2, m, rx);
        }
        tree[x] = tree[2*x+1] + tree[2*x+2];
       
    }
    void set(int i, int v){
        set(i, v, 0, 0, size);  
    }
    ll sum (int l, int r, int x, int lx, int rx){
        if(l >= rx || lx >= r) return 0;
        if(lx >= l && rx <= r) return tree[x];
        ll m = (rx+lx)/2;
        long long s1 = sum(l, r, 2*x+1, lx, m);
        long long s2 = sum(l, r, 2*x+2, m, rx);
        return s1+s2;
    }
    ll sum(int l, int r){
        return sum(l, r, 0, 0, size);
    }  
    ll minimum (int l, int r, int x, int lx, int rx){
        if(l >= rx || lx >= r) return INT_MAX;
        if(lx >= l && rx <= r) return tree[x];
        ll m = (rx+lx)/2;
        long long s1 = minimum(l, r, 2*x+1, lx, m);
        long long s2 = minimum(l, r, 2*x+2, m, rx);
        return min(s1, s2);
    }
    ll minimum (int l, int r){
        return minimum(l, r, 0, 0, size);
    }  
};
int main() {
    int n;
    cin>>n;
    sgtree st;
    st.init(n);
    ll sum=0;
    for(int i=0; i<n;i++) {
        int v;
        cin >> v;
        st.set(i,v);
        sum=sum+v;
    }
    int half;
    if (sum%2==0) half=sum/2;
    else half = sum/2+1;
    int l = 0, r = n;
    while(r>l+1){
        int m = (l+r)/2;
        int c=0;
        for (int i=0;i<m+1;i++){
            if (st.sum(i, i+m+1)-st.minimum(i-1, i+m+1)>=half){
                c = 1;
                break;
            }
        }
        if (c==1) r=m;
        else l=m;
    }
    cout << r;
}
