#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <unordered_map>
#include <map>
#include <unordered_set>
#include <set>
#include <bitset>
#include <queue>
#include <stack>
#include <iomanip>
#include <fstream>
#include <ctime>
#include <random>
#include <cassert>

#define int long long
#define fi first
#define se second
#define pii pair<int,int>
#define p_b push_back
#define m_p make_pair
#define all(x) x.begin(),x.end()
#define rall(x) x.rbegin(),x.rend()
#define sqr(x) ((x)*(x))
#define pw(x) (1LL << x)
#define sz(x) (int)x.size()

using namespace std;

int n, m;
int a[1505][1505];

int rev(int x)
{
    return (x > 4 ? x - 4 : x + 4);
}

int find_row()
{
    for(int i = 0; i < n; i++)
    {
        int cnt = 0;
        for(int j = 0; j < m; j++)
            cnt += (a[i][j] != 3 && a[i][j] != 7);
        if(cnt <= 1)
            return i;
    }
}

int find_col()
{
    for(int j = 0; j < m; j++)
    {
        int cnt = 0;
        for(int i = 0; i < n; i++)
            cnt += (a[i][j] != 1 && a[i][j] != 5);
        if(cnt <= 1)
            return j;
    }
}

void check1(int r, int c)
{
    for(int i = 0; i < r; i++)
        if(a[i][c] != 1)
            return;
    for(int i = r + 1; i < n; i++)
        if(a[i][c] != 5)
            return;
    for(int j = 0; j < c; j++)
        if(a[r][j] != 7)
            return;
    for(int j = c + 1; j < m; j++)
        if(a[r][j] != 3)
            return;
    cout << r + 1 << " " << c + 1 << '\n';
    exit(0);
}

void check2(int r, int c)
{
    for(int i = 0; i < r; i++)
        if(a[i][c] != 1)
            return;
    for(int i = r + 1; i < n; i++)
        if(a[i][c] != 5)
            return;
    for(int i = 0; i < r; i++)
        if(c && a[i][0] != 3 && a[i][0] != 4 && a[i][0] != 5 ||  !c && a[i][1] != 5 && a[i][1] != 6 && a[i][1] != 7)
        {
            cout << i + 1 << " " << c + 1 << '\n';
            exit(0);
        }
    for(int i = r + 1; i < n; i++)
        if(c && a[i][0] != 1 && a[i][0] != 2 && a[i][0] != 3 ||  !c && a[i][1] != 7 && a[i][1] != 8 && a[i][1] != 1)
        {
            cout << i + 1 << " " << c + 1 << '\n';
            exit(0);
        }
}

void check3(int r, int c)
{
    for(int j = 0; j < c; j++)
        if(a[r][j] != 7)
            return;
    for(int j = c + 1; j < m; j++)
        if(a[r][j] != 3)
            return;
    for(int j = 0; j < c; j++)
        if(r && a[0][j] != 3 && a[0][j] != 4 && a[0][j] != 5 ||  !r && a[1][j] != 1 && a[1][j] != 2 && a[1][j] != 3)
        {
            cout << r + 1 << " " << j + 1 << '\n';
            exit(0);
        }
    for(int j = c + 1; j < m; j++)
        if(r && a[0][j] != 5 && a[0][j] != 6 && a[0][j] != 7 ||  !r && a[1][j] != 7 && a[1][j] != 8 && a[1][j] != 1)
        {
            cout << r + 1 << " " << j + 1 << '\n';
            exit(0);
        }
}

void check4(int r, int c)
{
    int _r, _c;
    for(int i = 0; i < r; i++)
        if(a[i][c] == 1)
            _r = i;
    for(int i = r + 1; i < n; i++)
        if(a[i][c] == 5)
            _r = i;
    for(int j = 0; j < c; j++)
        if(a[r][j] == 7)
            _c = j;
    for(int j = c + 1; j < m; j++)
        if(a[r][j] == 3)
            _c = j;
    cout << _r + 1 << " " << _c + 1;
    exit(0);
}

main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin >> n >> m;
    for(int i = 0; i < n; i++)
        for(int j = 0; j < m; j++)
            cin >> a[i][j];
    int r = find_row();
    int c = find_col();
    cout << r + 1 << " " << c + 1 << '\n';
    check1(r, c);
    check2(r, c);
    check3(r, c);
    check4(r, c);
    return 42;
}

/*
3 4
1 6 7 7
7 3 3 3
5 8 7 7
*/

//3 4
//5 6 3 7
//7 3 3 3
//1 8 3 7
