#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <unordered_map>
#include <map>
#include <unordered_set>
#include <set>
#include <bitset>
#include <queue>
#include <stack>
#include <iomanip>
#include <fstream>
#include <ctime>
#include <random>
#include <cassert>

#define int long long
#define fi first
#define se second
#define pii pair<int,int>
#define p_b push_back
#define m_p make_pair
#define all(x) x.begin(),x.end()
#define rall(x) x.rbegin(),x.rend()
#define sqr(x) ((x)*(x))
#define pw(x) (1LL << x)
#define sz(x) (int)x.size()

using namespace std;

struct minq
{
    queue < int > q;
    deque < int > d;
    void push(int x)
    {
        q.push(x);
        while(sz(d) && d.back() > x)
            d.pop_back();
        d.p_b(x);
    }
    void pop()
    {
        if(d.front() == q.front())
            d.pop_front();
        q.pop();
    }
    int find_min()
    {
        return d.front();
    }
};

int n, a[100005], sum = 0;

bool check(int k)
{
    minq mq;
    int seg = 0;
    for(int i = 0; i < k; i++)
    {
        mq.push(a[i]);
        seg += a[i];
    }
    for(int i = 0; i + k <= n; i++)
    {
        if(seg * 2 >= sum)
            return true;
        if(i + k == n)
            break;
        seg += a[i + k];
        if((seg - mq.find_min()) * 2 >= sum)
            return true;
        seg -= a[i];
        mq.push(a[i + k]);
        mq.pop();
    }
    return false;
}

main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin >> n;
    for(int i = 0; i < n; i++)
    {
        cin >> a[i];
        sum += a[i];
    }
    int l = 0;
    int r = n;
    while(l < r - 1)
    {
        int m = (l + r) / 2;
        (check(m) ? r : l) = m;
    }
    cout << r;
    return 0;
}
