#include <iostream>
#include <algorithm>
#include <cmath>
#include <cstring>
#include <cstdlib>
#include <iomanip>
#include <stack>
#include <queue>
#include <set>
#include <map>
#include <unordered_map>
#include <fstream>

using namespace std;

#define int long long
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define sz(x) (int)x.size()

const int inf = 1e18;
const int mod = 1e9 + 7;


int fastPow(int a, int b){
    if (b == 0)
        return 1;
    int x = fastPow(a, b / 2);
    if (b % 2 == 0)
        return x * x;
    return x * x * a;
}

int check(int l, int r){
    int ans = 0;
    for(int len = 1; len <= 18; len ++){
        int left = fastPow(10, len - 1);
        int right = fastPow(10, len) - 1;
        if (len == 1)
            left = 0;

        int here = max(min(right, r) - max(left, l) + 1, 0LL);
        ans += here * len;
    }

    return ans;
}

main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int N;
    cin >> N;
//for(N = 100000000000000000; N <= 100000000000000000; N ++){
    int n = N;
    if (n <= 10)
        return cout << n << '\n' << 0 << ' ' << n - 1, 0;

    n -= 10;

    int len = 2;
    int now = 90;
    while(n > now * len){
        n -= now * len;
        now *= 10;
        len ++;
    }

    int k = n / len;
    int rest = (n % len);
    int l = 0, r = fastPow(10, len - 1) + k - 1;

    if (rest > 0){
        r ++;
        l += (len - rest);
    }


    bool was = false;
    for(int left = max(l - 1000, 0LL); left <= l + 1000; left ++){
        for(int right = max(r - 1000, 0LL); right <= r + 1000; right ++){
            int ans = check(left, right);
            if (ans == N){
                was = true;
                l = left; r = right;
                break;
            }
        }
        if (was)
            break;
    }

    int ans = check(l, r);
    cout << (r - l) + 1 << endl;
    cout << l << ' ' << r << endl;
//    cout << ans;
//    cout << "HUSDUFISDOFIJO: " << ans;
//    if (ans != N){
//        cout << "HALT:" << N << ' ' << ans << " | " << l << ' ' << r << endl;
//    } else
//        cout << "GOOD: " << N << endl;
//    }
}

/*
1000000000000000000
100000000000000004
100000000000000003
1000000000008
*/
