#include <iostream>
#include <algorithm>
#include <cmath>
#include <cstring>
#include <cstdlib>
#include <iomanip>
#include <stack>
#include <queue>
#include <set>
#include <map>
#include <unordered_map>
#include <fstream>

using namespace std;

#define int long long
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define sz(x) (int)x.size()

const int inf = 1e18;
const int mod = 1e9 + 7;

const int x1 = 29, x2 = 31, y1 = 1e9+7, y2 = 1e9+9;

int n, l;
vector<string> s;
vector<vector<int> > h1, h2;
vector<int> p1, p2;

bool check(int len){
    if (len == 0)
        return true;

    map<pair<int, int> , int> pref;
    for(int i = 0; i < n; i ++)
        pref[{h1[i][len - 1], h2[i][len - 1]}] ++;
    for(auto i : pref)
        if (i.second % 2 != 0)
            return false;
//    cout << "Here";
    return true;
}

main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    cin >> n;
    s.resize(n);
    h1.resize(n);
    h2.resize(n);
    for(int i = 0; i < n; i ++)
        cin >> s[i];
    l = sz(s[0]);
    p1.resize(l + 10);
    p2.resize(l + 10);
    p1[0] = p2[0] = 1;
    for(int i = 1; i < l + 10; i ++){
        p1[i] = p1[i - 1] * x1 % y1;
        p2[i] = p2[i - 1] * x2 % y2;
    }

    for(int i = 0; i < n; i ++){
        h1[i].resize(l);
        h2[i].resize(l);
        h1[i][0] = h2[i][0] = s[i][0] - 'a';
        for(int j = 1; j < l; j ++){
            h1[i][j] = ((s[i][j] - 'a' + 1) * p1[j] + h1[i][j - 1]) % y1;
            h2[i][j] = ((s[i][j] - 'a' + 1) * p2[j] + h2[i][j - 1]) % y2;
        }

//        for(int j = 0; j < l; j ++)
//            cout << h1[i][j] << ' ';
//        cout << endl;
//        for(int j = 0; j < l; j ++)
//            cout << h2[i][j] << ' ';
//        cout << "\n=====\n";
    }

    int lef = 0, r = l + 1;
    while(lef < r - 1){
        int m = (lef + r) / 2;
        bool now = check(m);
        if (now)
            lef = m;
        else
            r = m;
    }
    while(check(lef + 1))
        lef ++;

    cout << lef;
}

/*
4
aabc
aacc
bbbb
bbbd

2
a
b

4
adcc
bbad
adad
bdad
*/
