#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>
#include <set>
#include <cmath>
#include <map>
using namespace std;
vector <pair<pair <int, int>, int>> dp(1000001);
vector <string> a;
int n;

bool check(int mid) {
	vector<string>sp;
	for (int i = 0; i < n; i++) {
		sp.push_back(a[i].substr(0, mid));
	}
	map <string, int> url;
	
	for (int i = 0; i < n; i++) {
		url[sp[i]]++;
	}

	for (int i = 0; i < n; i++) {
		if (url[sp[i]] < 2) {
			return 0;
		}
	}
	
	return 1;
}


void solution() {
	cin >> n;
	for (int i = 0; i < n; i++) {
		string c;
		cin >> c;
		a.push_back(c);
	}

	int l = 0, r = a[0].size(), mid;
	int ans = 0;
	while (l <= r) {
		mid = (l + r) / 2;
		if (check(mid)) {
			l = mid + 1;
			ans = mid;
		}
		else {
			r = mid - 1;
		}
	}

	cout << ans;
}


int main() {
	solution();
}
