#include <bits/stdc++.h>
#define forn(i, n) for(int i = 0; i < n; i++)
#define se second
#define fi first
#define forup(i, x, n) for (int i = x; i < n; i++)
#define fordown(i, n) for (int i = n; i >= 0; i--)
#define top back
#define int long long
typedef long long ll;
typedef unsigned long long ull;

using namespace std;

queue<pair<int, int> > lt, rt;

void push(int x) {
    int mn = x;
    if (rt.size())
        mn = min(rt.back().se, mn);
    rt.push(make_pair(x, mn));
}

int get() {
    if (rt.size() && lt.size())
        return min(rt.back().se, lt.back().se);
    else if (rt.size())
        return rt.back().se;
    else
        return lt.back().se;
}

void pop() {
    if (lt.size() == 0) {
        while (rt.size()) {
            int x = rt.back().fi;
            int mn = x;
            if (lt.size())
                mn = min(mn, lt.back().se);
            lt.push(make_pair(x, mn));
            rt.pop();
        }
        lt.pop();
    }
}

int sum = 0;
vector <int> a;
vector <int> b;

bool check (int m) {
    bool flag = false;
    for (int i = 0; i < m; i++) {
        push(a[i]);
    }
    for (int i = m; i <= a.size(); i++) {
        //cout << i << " " << m << " " << b[i] - b[i - m] << " " << get() << "\n";
        if (b[i] - b[i - m] - get() >= sum) {
            flag = true;
            break;
        }
        pop();
        push(a[i - 1]);
    }

    return flag;
}

signed main()
{
    int n;
    cin >> n;
    a.resize(n);
    b.resize(n + 1, 0);

    for (int i = 0; i < n; i++) {
        cin >> a[i];
        sum += a[i];
        b[i + 1] = b[i] + a[i];
    }
    sum = sum / 2 + sum % 2;


    int l = -1, r = a.size() + 1, m;
    while (r - l > 1) {
        m = (r + l) / 2;

        if (check(m))
            r = m;
        else
            l = m;

        for (int i = 0; i < m; i++)
            pop();

    }

    cout << r - 1;
    return 0;
}
