#pragma GCC optimize("Ofast,O2,O3")
#pragma GCC target("avx,avx2")

#include <bits/stdc++.h>

typedef long long ll;
using namespace std;

#define MP make_pair
#define x first
#define y second
#define point pair<ll,ll>
#define line pair<point,point>

ll dist2(point a, point b){
    return (a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y);
}

ll dist2(line a){
    return dist2(a.first, a.second);
}

ll dist2_between_lines(line a, line b){
    ll res = 1e18;
    res = min(res, dist2(a.first, b.first));
    res = min(res, dist2(a.first, b.second));
    res = min(res, dist2(a.second, b.first));
    res = min(res, dist2(a.second, b.second));
    return res;
}

void solve(){
    int n;
    cin >> n;

    vector<line> v;
    for (int i = 0; i < n; i++){
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        v.emplace_back(MP(a, b), MP(c, d));
    }

    int ans = 0;
    for (int i = 0; i < n; i++){
        for (int j = i + 1; j < n; j++){
            for (int k = j + 1; k < n; k++){
                bool ok = false;

                if (dist2(v[i]) >= dist2_between_lines(v[j], v[k])) ok = true;
                if (dist2(v[j]) >= dist2_between_lines(v[i], v[k])) ok = true;
                if (dist2(v[k]) >= dist2_between_lines(v[i], v[j])) ok = true;

                if (ok) ans++;
            }
        }
    }

    cout << ans << endl;

}

int main(){
    ios_base::sync_with_stdio(false);
    //freopen("input.txt", "r", stdin);
    int tc = 1;
    //cin >> tc;

    while (tc--) solve();

    return 0;
}
