﻿//#pragma clang diagnostic push
//#pragma ide diagnostic ignored "modernize-use-emplace"

#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef vector<int> vi;
typedef vector<vector<int>> vvi;
typedef pair<int, int> pi;
typedef long double ld;

struct seg_tree {
    int sz;
    vi a, tree;

    void build(int v, int tl, int tr) {
        if (tr - tl == 1) tree[v] = a[tl];
        else {
            int tm = (tl + tr) / 2;

            build(2 * v + 0, tl, tm);
            build(2 * v + 1, tm, tr);

            tree[v] = tree[2 * v] + tree[2 * v + 1];
        }
    }

    seg_tree(vi &s) {
        a = s;
        sz = a.size();
        tree.resize(4 * sz);
        build(1, 0, sz);
    }

};

int sum(ll a, ll b) {
    if (b == 0) {
        return a;
    }
    if (b < 0) {
        return sum(a - 1, b + 1);
    } else {
        return sum(a + 1, b - 1);
    }
}

ll findpow(ll n) {
    int l = 0, r = 63;
    while (r - l > 1) {
        int m = (l + r) / 2;
        if ((ll) (1ll << m) > n) {
            r = m;
        } else {
            l = m;
        }
    }
    return (ll) (1ll << r);
}

int getans(ll n) {
    int ans = 0;
    while (n) {
        ans += n % 2;
        n /= 2;
    }
    return ans;
}


signed main() {
//    ifstream cin("C:\\Users\\nasvv\\CLionProjects\\ternarniy\\aboba.in");
//    ofstream cout("C:\\Users\\nasvv\\CLionProjects\\ternarniy\\aboba.out");
    int n;
    cin >> n;
    vector<vector<int>> dp(n + 1, vector<int>(n + 1, 2e9));
    dp[0][0] = 0;
    vector<vector<int>> prefs(n + 1, vector<int>(n + 1, 2e9));
//    for (int i = 1; i <= n; ++i) {
//        dp[i][i] = i * (i - 1) / 2;
//    }
    prefs[0][0] = 0;
    for (int i = 1; i <= n; ++i) {
        prefs[0][i] = 0;
    }
    for (int get = 1; get <= n; ++get) {
        for (int last = 1; last <= n; ++last) {
            if (last > get){
                prefs[get][last] = min(prefs[get][last - 1], dp[get][last]);
                continue;
            }
            if (get == last) {
                dp[get][last] = last * (last - 1) / 2;
            } else {
                dp[get][last] = min(dp[get][last], prefs[get - last][last - 1] + last * (last - 1) / 2);
            }
            if (last != 0) {
                prefs[get][last] = min(prefs[get][last - 1], dp[get][last]);
            }
        }
    }
    int ans = 2e9;
    for (int i = 0; i <= n; ++i) {
        ans = min(ans, dp[n][i]);
    }
    cout << ans;

//        int t;
//        cin >> t;
//        while (t--) {
//            ll n;
//            cin >> n;
//
//            n = abs(n);
//            ll negn = findpow(n) - n;
//
//            cout << min(getans(n), 1 + getans(negn)) << '\n';
//        }
}


//#pragma clang diagnostic pop