﻿#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
using namespace std;


using vi = vector<int>;

vector<string> a;


bool ok(int k) {
	bool good = true;
	for (int i = 0; i < a.size() - 1; i += 2) {
		for (int j = 0; j < k; ++j) {
			if (a[i][j] != a[i + 1][j]) {
				good = false; break;
			}
		}
	}
	return good;
}


int solve() {
	int l = 0, r = a.back().length() + 1;
	while (r - l > 1) {
		int med = l + (r - l) / 2;
		if (ok(med)) {
			l = med;
		} else r = med;
	}
	return l;
}


int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	int n; cin >> n;
	a.assign(n, "");
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}
	sort(a.begin(), a.end());
	cout << solve() << "\n";
	return 0;
}