﻿#include <iostream>
#include <deque>
#include <vector>
#define ll long long
using namespace std;
vector<ll> a;
int n;
ll s = 0;
bool check(int k) {
    if (k == n)
        return true;
    ll sum = 0; 
    deque <int> mn;
    for (int i = 0; i <= k; i++) {
        sum += a[i];
        while (!mn.empty() and mn.front() > a[i])
            mn.pop_front();
        while (!mn.empty() and mn.back() > a[i])
            mn.pop_back();
        mn.push_back(a[i]);
    }
    int st = 0;
    while (st + k < n) {
        if (st > 0) {
            int i = st + k;
            sum -= a[st - 1]; sum += a[i];
            while (!mn.empty() and mn.front() > a[i])
                mn.pop_front();
            while (!mn.empty() and mn.back() > a[i])
                mn.pop_back();
            mn.push_back(a[i]);
        }
        if (sum - mn.front() >= (s + 1) / 2) {
            return true;
        }
        st++;
    }
    return false;
}
int bisearch() {
    int l = 0, r = n;
    while (r - l > 1) {
        int m = (r + l) / 2;
        if (check(m))
            r = m;
        else
            l = m;
    }
    return r;
}
int main() {
    cin >> n;
    a.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        s += a[i];
    }
    cout << bisearch();
}
