#include<bits/stdc++.h>

typedef unsigned long long ll;

using namespace std;

ll pw[ 19 ];

ll log10(ll n) {
    ll cnt = 0;
    if(!n) return 0;
    while(n) {
        cnt++;
        n /= 10;
    }
    return cnt - 1;
}

ll sum(ll l, ll r) {
    ll l1 = log10(l), r1 = log10(r);
    if(l1 == r1) {
        return (r - l + 1) * (l1 + 1);
    }
    ll ans = 0;
    ans += (l1 + 1) * (pw[l1 + 1] - l);
    ans += (r1 + 1) * (r - pw[r1] + 1);
    for(ll i = l1 + 1; i < r1; i++) 
        ans += 9 * pw[i];
    return ans;
}

main() {
    ios::sync_with_stdio(0);
    cin.tie(0);cout.tie(0);
    pw[0] = 1; 
    for(ll i = 1; i <= 18; i++) 
            pw[i] = (pw[i - 1] * 10);
    ll S;
    cin >> S;
    for(ll i = 0; i <= 17; i++) {
        ll num = pw[i];
        if(!i) num = 0;
        ll l = num - 1, r = 1e18;
        while(r - l > 1) {
            ll m = (l + r) / 2;
            if(sum(num, m) >= S) r = m;
            else l = m;
        }
        l = num;
        // cout << l << ' ' << r << '\n';
        ll ss = sum(l, r);
        if(ss == S) {
            cout << r - l + 1 << '\n';
            cout << l << ' ' << r;
            return 0;
        }
        ll r0 = r;
        while(ss % (i + 1) && r0 < pw[i + 1] - 1 && (r0 - r + 1) <= i) 
            ss += log10(++r0);
        while(ss % (i + 1) && (r0 - r + 1) <= 2 * i) {
            ss += log10(++r0);
        }
        if((ss % (i + 1))) continue;
        if((ss - S) / (i + 1) <= 9 * pw[i]) {
            l += (ss - S) / (i + 1);
            cout << r - l + 1 << '\n';
            cout << l << ' ' << r << '\n';
            return 0;
        }
    }    
    cout << -1;
}