#include <bits/stdc++.h>
using namespace std;
#define pb push_back
#define mp make_pair
#define F first
#define S second
#define ll long long
#define ld long double
#define all(_v) _v.begin(), _v.end()
#define sz(_v) (int)_v.size()
#define pii pair <int, int>
#define pll pair <ll, ll>
#define veci vector <int>
#define vecll vector <ll>

const int dx[4] = {1, -1, 0, 0};
const int dy[4] = {0, 0, -1, 1};
const double PI = 3.141592653589793;
const double eps = 1e-9;
const int MOD1 = 1e9 + 7;
const int MOD2 = 998244353;
const int N = 105;

struct pt{
	int x,y;
};

pair<pt,pt> otr[N];
ld dist(pt A , pt B) {
	return sqrt((A.x-B.x)*(A.x-B.x) + (A.y-B.y)*(A.y-B.y));
}
ld dist (ld x1, ld y1, ld x2, ld y2){
	return sqrt ((x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2));
}
ld ds (pt A, pair <pt, pt> l){
	ld X = A.x, Y = A.y, x0 = l.F.x, y0 = l.F.y, x1 = l.S.x, y1 = l.S.y;
	ld k = (y1 - y0) / (x1 - x0), b = (y1 * x0 - x1 * y0) / (x0 - x1);
	ld xx = (X + Y * k - b * k) / (k * k + 1);
	ld yy = (k * X + k * k * Y + b) / (k * k + 1);
	if (xx > min (x0, x1) - eps && xx < max (x0, x1) + eps) return dist (X, Y, xx, yy);
	return min (dist (X, Y, x0, y0), dist (X, Y, x1, y1));
}
bool inter (ld x0, ld y0, ld x1, ld y1, ld x2, ld y2, ld x3, ld y3){
	ld k0 = (y1 - y0) / (x1 - x0), b0 = (y1 * x0 - x1 * y0) / (x0 - x1);
	ld k2 = (y3 - y2) / (x3 - x2), b2 = (y3 * x2 - x3 * y2) / (x2 - x3);
	if (fabs(k0 - k2) < eps) return 0;
	ld xx = (b2 - b0) / (k0 - k2);
	if (xx > min (x0, x1) - eps && xx < max (x0, x1) + eps && xx > min (x2, x3) - eps && xx < max (x2, x3) + eps) return 1;
	return 0;
}
bool ch(int i , int j , int k) {
	if (inter (otr[i].F.x, otr[i].F.y, otr[i].S.x, otr[i].S.y, otr[j].F.x, otr[j].F.y, otr[j].S.x, otr[j].S.y)) return 1;
	ld t1 = ds(otr[i].F , otr[j]);
	ld t2 = ds(otr[i].S , otr[j]);
	ld t3 = ds(otr[j].F , otr[i]);
	ld t4 = ds(otr[j].S , otr[i]);
	ld mn = min({t1,t2,t3,t4});
	if(mn < dist(otr[k].F,otr[k].S)+eps) return 1;
	return 0;
}

void solve() {
	int n;
	cin >> n;
	for(int i = 1; i <= n; i ++) {
		cin >> otr[i].F.x >> otr[i].F.y >> otr[i].S.x >> otr[i].S.y;
	}
	int ans = 0;
	for(int i = 1; i <= n; i ++) {
		for(int j = i+1; j <= n; j ++) {
			for(int k = j+1; k <= n; k ++) {
				if(ch(i,j,k)) ans ++;
				else if(ch(i,k,j)) ans ++;
				else if(ch(j,k,i)) ans ++;
			}
		}
	}
	cout << ans;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int CNT_TESTS = 1;
    ///cin >> CNT_TESTS;
    for(int NUMCASE = 1; NUMCASE <= CNT_TESTS; ++NUMCASE) {
        solve();
        if(NUMCASE != CNT_TESTS) cout << '\n';
    }
    return 0;
}
/*
3
0 0 1 1
2 0 3 1
50 0 51 1

3
0 0 0 3
5 0 5 -3
50 0 54 2
*/

