/// @author Camillus
#include <bits/stdc++.h>
#ifdef LOCAL
#   include "debug.h"
#else
#   define debug(...)
#endif
#define int long long
using namespace std;

int ten_pow[19];

int get(int x) {
    if (x < 0) return 0;
    int sum = 1;
    for (int i = 0; ten_pow[i] <= x; i++) {
        int l = ten_pow[i];
        int r = min(ten_pow[i + 1] - 1, x);
        sum += (r - l + 1) * (i + 1);
    }
    return sum;
}

int get(int l, int r) {
    return get(r) - get(l - 1);
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    ten_pow[0] = 1;
    for (int i = 1; i < 19; i++) {
        ten_pow[i] = ten_pow[i - 1] * 10;
    }
    int s; cin >> s;
    for (int st = 0; ; st++) {
        int l = st - 1;
        int r = s;
        while (r - l > 1) {
            int m = (l + r) / 2;
            if (get(st, m) >= s) r = m;
            else l = m;
        }
        int c = get(st, r);
        if (c == s) {
            cout << r - st + 1 << "\n";
            cout << st << " " << r << "\n";
            return 0;
        }
    }
    return 0;
}
