#include<iostream>
#include<string>
#include<vector>
#define ll long long
using namespace std;

void solve1() {
        ll n;
        cin >> n;
        if (n < 0) n = -n;
        ll ans = 0;
        unsigned ll st = 1;
        while (n > st) st *= 2;
        if (st == n) {
            cout << 1 << "\n"; return;
        }
        st = st - n;
        while (n > 0) {
            if (n & 1) ans++;
            n=n>>1;
        }
        ll ans2 = 1;
        while (st > 0) {
            if (st & 1) ans2++;
            st = st >> 1;
        }
        cout << min(ans,ans2) << "\n";
}

struct Tree {
    struct Node {
        int l = -1,
            r = -1,
            color = -1;
        Node() { }
    };

    vector<Node> arr;
    int c = 0;

    Tree(int _c) { 
        c = _c;
        arr.emplace_back();
    }

    void set(string& str, int x, int i = 0, int t = 0) {
        if (i == str.size()) {
            arr[t].color = x;
            if (arr[t].l != -1) {
                arr[arr[t].l].color = (x + 1) % c;
            }
            else {
                arr[t].l = arr.size();
                arr.emplace_back();
                arr[arr[t].l].color = (x + 1) % c;
            }
            if (arr[t].r != -1) {
                arr[arr[t].r].color = (x + c - 1) % c;
            }
            else {
                arr[t].r = arr.size();
                arr.emplace_back();
                arr[arr[t].r].color = (x + c - 1) % c;
            }
            return;
        }
        if (str[i] == 'L') {
            if (arr[t].l != -1) {
                set(str, x, i + 1, arr[t].l);
            }
            else {
                arr[t].l = arr.size();
                arr.emplace_back();
                set(str, x, i + 1, arr[t].l);
            }
        }
        else {
            if (arr[t].r != -1) {
                set(str, x, i + 1, arr[t].r);
            }
            else {
                arr[t].r = arr.size();
                arr.emplace_back();
                set(str, x, i + 1, arr[t].r);
            }
        }
    }

    int find(string& str, int i = 0, int t = 0) {
        if (i == str.size()) {
            return arr[t].color;
        }
        if (str[i] == 'L') {
            if (arr[t].l != -1) {
                find(str, i + 1, arr[t].l);
            }
            else {
                arr[t].l = arr.size();
                arr.emplace_back();
                find(str, i + 1, arr[t].l);
            }
        }
        else {
            if (arr[t].r != -1) {
                find(str, i + 1, arr[t].r);
            }
            else {
                arr[t].r = arr.size();
                arr.emplace_back();
                find(str, i + 1, arr[t].r);
            }
        }
    }
};

void solve() {
    int q, c;
    cin >> q >> c;
    Tree arr(c);
    for (int i = 0; i < q; ++i) {
        int t;
        string str;
        cin >> t;
        if (t == 1) {
            int x;
            cin >> x;
            cin >> str;
            arr.set(str, x);
        }
        else {
            cin >> str;
            cout << arr.find(str) << "\n";
        }
    }
}

signed main() {
    //freopen("vikings.in", "rt", stdin);
    //freopen("vikings.out", "wt", stdout);
    ios_base::sync_with_stdio(false);
    //srand((unsigned int)time(nullptr));
    cout.setf(ios::fixed);
    cout.precision(9);
    cout.tie(nullptr);
    cin.tie(nullptr);

    int T = 1;
    //cin >> T;
    while (T--) solve();
    return 0x0;
}