#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <cmath>
using namespace std;
const long long P = 9999990017, Q = 1000000007;
int b[62];
long long binpow(long long a, long long b) {
    if (b == 0)
        return 1;
    long long res = binpow(a, b / 2);
    if (b % 2)
        return (res * res * a) % Q;
    else
        return (res * res) % Q;
}
long long hashh(string s) {
    long long k = 0;
    for (long long i = 0; i < s.size(); i++) {
        if (s[i] == 'L') k = (k + binpow(P, i)) % Q;
        else k = (k + 2 * binpow(P, i)) % Q;
    }
    return k;
}
void solve() {
    int q, c;
    cin >> q >> c;
    vector <pair<string, int>> nerkel;
    map <long long, int> mp;
    while (q--) {
        int t;
        cin >> t;
        if (t == 1) {
            int x;
            cin >> x;
            string s;
            cin >> s;
            mp[hashh(s)] = (int)nerkel.size();
            nerkel.push_back({ s, x });
        }
        else {
            int ind = -1;
            string s, k = "";
            cin >> s;
            long long val = 0;
            for (int i = 0; i < (int)s.size(); i++) {
                if (s[i] == 'L') val = (val + binpow(P, i)) % Q;
                else val = (val + 2 * binpow(P, i)) % Q;
                if (mp.find(val) != mp.end()) {
                    ind = max(ind, mp[val]);
                }
            }
            if (ind == -1) {
                cout << "-1\n";
                continue;
            }
            int col = nerkel[ind].second, v = (int)s.size() - (int)nerkel[ind].first.size();
            for (int i = (int)s.size() - v; i < (int)s.size(); i++) {
                if (s[i] == 'L') col = (col + 1) % c;
                else col = (col - 1 + c) % c;
            }
            cout << col << "\n";
        }
    }
}
int main()
{
    int t = 1;
    while (t--) {
        solve();
    }
}