#include "bits/stdc++.h"

#define speedIO  ios_base::sync_with_stdio(false);cin.tie(nullptr);cout.tie(nullptr);
#define fileIO freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#define vecout(vec, sep, end) for (auto i: vec) { cout << i << sep; } cout << end;
#define forn(n) for (int i = 0; i < n; i++)
#define i128 __int128
#define int unsigned long long
const int inf = 1e9;
typedef long long ll;
typedef long double ld;

using namespace std;

bool fullSubtractor(bool b1, bool b2, bool& borrow)
{
    bool diff;
    if (borrow) {
        diff = !(b1 ^ b2);
        borrow = !b1 || (b1 && b2);
    }
    else {
        diff = b1 ^ b2;
        borrow = !b1 && b2;
    }
    return diff;
}
// Function to calculate difference between two bitsets
bitset<33> bitsetSubtract(bitset<32> x, bitset<32> y)
{
    bool borrow = false;
    // bitset to store the sum of the two bitsets
    bitset<33> ans;
    for (int i = 0; i < 32; i++) {
        ans[i] = fullSubtractor(x[i], y[i], borrow);
    }
    return ans;
}
signed main() {
    speedIO
#ifdef LOCAL
//    fileIO
#endif

    int t;
    cin >> t;

    for (int i = 0; i < t; ++i) {
        long long num;
        cin >> num;

        if (num == 0){
            cout << 0 << "\n";
            continue;
        }

        num = abs(num);
        int bpow = (int)log2(num) + 1;
        bitset<32> n(num);
        bitset<32> b;
        b[bpow] = true;

        int res1 = 0;
        while (num){
            res1 += num % 2;
            num /= 2;
        }

        int res2 = 1;
        bitset<33> bb = bitsetSubtract(b, n);
        for (int j = 0; j < 32; ++j) {
            res2 += bb[j];
        }
        cout <<  min(res1, res2) << "\n";
    }
}
