#include <algorithm>
#include <iostream>
#include <iomanip>
#include <cmath>
#include <queue>
#include <map>
#include <set>

#define ent '\n';
#define f first
#define s second
  
using namespace std;
typedef long long ll;
    
const int maxn = 2e6 + 100;
const int mod = 1e9 + 7;
const int INF = 1e9;
const int K = 400;
const int P = 31;
  
ll n , m;
ll a[maxn] , pref[maxn];

void solve(){
    cin >> n;
    for(int i = 1;i <= n;i++){
        cin >> a[i];
        pref[i] = pref[i- 1] + a[i];
        m += a[i];
    }
    m = (m / 2) + m % 2;
    ll cal = m;
    for(int i = 1;i <= n;i++){
        int l = i , r = n;
        int res = -1;
        while(l <= r){
            int mid = (l + r) >> 1;
            if(pref[mid] - pref[i - 1] < m)l = mid + 1;
            else res = mid , r = mid - 1;
        }
        if(res != -1){
            if(res - i + 1 <= cal){
                cal = res - i + 1;
                for(int j = i;j <= res;j++){
                    if(pref[res] - pref[i - 1] - a[j] >= m){
                        cal = res - i;
                        break;
                    }
                }
            }
        }
    }
    cout << cal << ent;
}
 
int main(){
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int T = 1;
    // cin >> T;
    for(int i = 1;i <= T;i++){
        solve();
    }
}