// #pragma GCC optimize ("Ofast")
// #pragma GCC optimize ("unroll-loops")
// #pragma GCC optimize ("03")
// #pragma GCC target ("sse,sse2,sse3,ssse3,sse4,popcnt,abm,avx2,mmx,fma,avx,tune=native")
// #pragma comment(linker, "/stack:200000000")
#include <algorithm>
#include <iostream>
#include <iomanip>
#include <cmath>
#include <queue>
#include <map>
#include <set>

using namespace std;
typedef long long ll;
struct segment{int l, r;
int size(){return r-l+1;}};
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
#define ent "\n"

const int maxn = 2e5 + 100;
const ll INF = (1ll<<61);
const int MOD = 1e9 + 123;
const int inf = (1<<30);
const int maxl = 101;
const int P = 31;

int q, c;

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
    cin >> q >> c; map<int, pii> upd;
    for(int i = 1; i <= q; i++){
        int tp, x;
        string s;
        cin >> tp;
        if(tp == 1){
            cin >> x >> s;
            ll h = 0;
            for(char c: s){
                if(c == 'L') h = (h * P + 1) % MOD;
                else h = (h * P + 2) % MOD;
            }
            upd[h] = {i, x};
        } else{
            cin >> s;
            ll h = 0;
            int pos = -1, mx = 0, ans = -1;
            for(int i = 0; i < s.size(); i++){
                if(s[i] == 'L') h = (h * P + 1) % MOD;
                else h = (h * P + 2) % MOD;
                if(upd.count(h)){
                    pii x = upd[h];
                    if(pos == -1 || x.first > mx){
                        mx = x.first;
                        pos = i; ans = x.second;
                    }
                }
            }
            if(pos == -1){
                cout << -1 << ent;
                continue;
            }
            for(int i = pos + 1; i < s.size(); i++){
                if(s[i] == 'L') ans = (ans + 1) % c;
                else ans = (ans - 1 + c) % c;
            }
            cout << ans << ent;
        }
    }
}
