// #pragma GCC optimize ("Ofast")
// #pragma GCC optimize ("unroll-loops")
// #pragma GCC optimize ("03")
// #pragma GCC target ("sse,sse2,sse3,ssse3,sse4,popcnt,abm,avx2,mmx,fma,avx,tune=native")
// #pragma comment(linker, "/stack:200000000")
#include <algorithm>
#include <iostream>
#include <iomanip>
#include <cmath>
#include <queue>
#include <map>
#include <set>

using namespace std;
typedef long long ll;
struct segment{int l, r;
int size(){return r-l+1;}};
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
#define ent "\n"

const int maxn = 2e5 + 100;
const ll INF = (1ll<<61);
const int MOD = 1e9 + 123;
const int inf = (1<<30);
const int maxl = 101;
const int P = 31;

int n;
int a[maxn];
int mn[20][maxn];
int lg[maxn];
ll pref[maxn];

ll get(int l, int r){
    int k = lg[r - l + 1];
    return pref[r] - pref[l-1] - min(mn[k][l], mn[k][r-(1<<k)+1]);
}

void test(){
    cin >> n;
    for(int i=1; i<=n; i++){
        cin >> a[i];
        pref[i] = pref[i-1] + a[i];
        mn[0][i] = a[i];
        if(i > 1) lg[i] = lg[i/2] + 1;
    }
    for(int k=1; (1<<k) <= n; k++){
        for(int i = 1; i + (1<<k) - 1 <= n; i++){
            mn[k][i] = min(mn[k-1][i], mn[k-1][i+(1<<(k-1))]);
        }
    }
    ll x = (pref[n] + 1) / 2;
    int ans = n;
    for(int i = 1; i <= n; i++){
        int pos = i;
        for(int l=i,r=n; l <= r;){
            int mid = (l + r) >> 1;
            if(pref[mid] - pref[i-1] >= x){
                r = mid - 1;
                pos = mid;
            } else l = mid + 1;
        }
        if(pref[pos] - pref[i-1] < x) break;
        ans = min(ans, pos-i+1);
        if(get(i, pos) >= x) ans = min(ans, pos-i);
    }
    cout << ans;
}

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
    int t; t = 1;
    while(t--) test();
}
