#include <bits/stdc++.h>
using namespace std;
#define int long long
#define forn(i,n) for (int i=0; i<n; ++i)

struct node {
	
	node *l, *r;
	int c;

	node() {
		l = nullptr;
		r = nullptr;
		c = -1;
	}

	node(int _c) {
		l = nullptr;
		r = nullptr;
		c = _c;
	}

};

void solve() {
	
	int q, c;
	cin >> q >> c;

	node *head = new node;

	while(q--) {
		int t = 0;
		cin >> t;

		if(t == 1) {
			int x;
			string s;
			cin >> x >> s;

			node *curr = head;

			for(int i = 0; i < s.size(); i++) {
				if(s[i] == 'L') {
					if(curr->l == nullptr) {
						curr->l = new node;
					}
					curr = curr->l;
				}
				if(s[i] == 'R') {
					if(curr->r == nullptr) {
						curr->r = new node;
					}
					curr = curr->r;
				}
			}

			curr->c = x;
			curr->l = nullptr;
			curr->r = nullptr;
		}
		else if (t == 2) {
			string s;
			cin >> s;

			int color = -1;
			node *curr = head;

			int ex = s.size();
			for(int i = 0; i < s.size(); i++) {
				if(curr->c != -1) {
					color = curr->c;
				}
				if(s[i] == 'L') {
					if(curr->l == nullptr) {
						ex = i;
						break;
					}
					if(color != -1) {color = (color + 1) % c;}
					curr = curr->l;
				}
				if(s[i] == 'R') {
					if(curr->r == nullptr) {
						ex = i;
						break;
					}
					if(color != -1) {color = (color - 1 + c) % c;}
					curr = curr->r;
				}
			}

			for(int i = ex; i < s.size(); i++) {
				if(s[i] == 'L') {
					if(color != -1) {color = (color + 1) % c;}
				}
				if(s[i] == 'R') {
					if(color != -1) {color = (color - 1 + c) % c;}
				}
			}

			cout << color << '\n';
		}
	}
	
}

int32_t main() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	solve();
	return 0;
}