#include <stack>
#include <numeric>
#include <unordered_map>
#include <unordered_set>
#include <iomanip>
#include <map>
#include <iterator>
#include <deque>
#include <queue>
#include <sstream>
#include <string>
#include <chrono>
#include <cassert>
#include <set>
#include <cstdio>
#include <cstring>
#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <bitset>

using namespace std;

#define ll long long
#define pii pair<int, int>
#define pll pair<long long, long long>

#define vi vector<int>
#define vii vector<pair<int, int> >

#define lol cout << '\n'

#define all(v) v.begin(), v.end()

#define riter(ds) for (auto it = (ds.rbegin()); it != (ds.rend()); it++)
#define iter(ds) for (auto it = (ds.begin()); it != (ds.end()); it++)

#define rgo(i, n) for (int i = (n)-1; i >= 0; i--)
#define rgo1(i, n) for (int i = (n); i >= 1; i--)
#define go(i, n) for (int i = 0; i < (n); i++)
#define go1(i, n) for (int i = 1; i <= (n); i++)

#define YES cout << "YES\n"
#define Yes cout << "Yes\n"
#define NO cout << "NO\n"
#define No cout << "No\n"

#define endl '\n'
#define endll endl

#define out(x) cout << (x) << '\n'
#define in(x) cin >> x

struct custom_hash
{
    static uint64_t splitmix64(uint64_t x)
    {
        // http://xorshift.di.unimi.it/splitmix64.c
        x += 11400714819323198485ULL;
        x = (x ^ (x >> 30)) * 13787848793156543929ULL;
        x = (x ^ (x >> 27)) * 10723151780598845931ULL;
        return x ^ (x >> 31);
    }

    size_t operator()(uint64_t x) const
    {
        static const uint64_t FIXED_RANDOM = chrono::steady_clock::now()
                                                 .time_since_epoch()
                                                 .count();

        return splitmix64(x + FIXED_RANDOM);
    }
};

long long binpow(long long base, long long power, long long SELFmod = 0LL)
{
    if (!power)
        return 1;

    long long ans = binpow(base, (power >> 1), SELFmod);

    if (SELFmod)
        ans %= SELFmod;

    ans *= ans;

    if (SELFmod)
        ans %= SELFmod;

    if (power & 1) // % 2
    {
        ans *= base;

        if (SELFmod)
            ans %= SELFmod;
    }

    return ans;
}

long long sqrti(long long x) // round down
{
    long long a = x, b = ((x + 1) >> 1);
    while (a > b)
    {
        a = b;
        b = ((b + x / b) >> 1);
    }

    return a;
}

long long gcd(long long a, long long b)
{
    if (!b)
        return a;
    return gcd(b, a % b);
}

inline long long lcm(long long a, long long b)
{
    return (a / gcd(a, b)) * b;
}

long long _stoi(string s)
{
    long long n = 0, id = 1;

    while (!s.empty())
    {
        n += (id * (s.back() - 48));
        id *= 10;
        s.pop_back();
    }

    return n;
}

string _itos(long long n)
{
    string s;

    while (n > 0)
    {
        s.push_back(char((n % 10) + 48));
        n /= 10;
    }

    reverse(s.begin(), s.end());

    return s;
}

const int maxN = 1;
const long long MOD = 1;
int fac[maxN + 2], ifac[maxN + 2];

void Factorials()
{
    assert(maxN > 1);
    assert(MOD > 1);

    fac[0] = ifac[0] = 1;
    for (long long i = 1; i <= maxN; i++) // go1(i, maxN)
    {
        fac[i] = ((long long)(fac[i - 1]) * (long long)(i)) % MOD;
        ifac[i] = ((long long)(ifac[i - 1]) * (long long)(binpow(i, MOD - 2, MOD))) % MOD;
    }
}

// nCr Combination (order doesnt differ)
inline long long C(int n, int r)
{
    if (r < 0 or r > n)
        return 0;

    // long long facn = fac[n], ifacr = ifac[r], ifacn_r = ifac[n - r], ans = facn * ifacr % MOD * ifacn_r % MOD;
    // return ans;

    return ((long long)(((long long)(fac[n]) * (long long)(ifac[r])) % MOD) * (long long)(ifac[n - r])) % MOD;
}

// nPr Permutation (order differs)
inline long long P(int n, int r)
{
    if (r < 0 or r > n)
        return 0;

    // long long facn = fac[n], ifacn_r = ifac[n - r], ans = (facn * ifacn_r) % MOD;
    // return ans;

    return ((long long)(fac[n]) * (long long)(ifac[n - r])) % MOD;
}

int32_t main()
{
    ios::sync_with_stdio(false);
    cin.tie();
    cout.tie();

    /*
        Dont lose your hope

        two options:
            think twice, code once
            think once, debug forever

        Don't code Random idea
    */

    // One -> One case
    // Zero -> Several cases
    bool lonelyCase = 0;

    int tests = 1;
    if (!lonelyCase)
        cin >> tests;
    for (int test = 1; test <= tests; test++)
    {
        cout << fixed;

        ll n, _1=0, vbit=1ll<<60, _0=2;
        cin >> n;
        n=abs(n);

        for(int i=60; i>=0; i--)
        {
            if((n&vbit))
            {
                _1++;
            }
            if (_1 and (n & vbit) == 0)
            {
                _0++;
            }
            vbit>>=1;
        }

        out(min(_1, _0));

        nextCase:;

    } // BEEG FOOR

    cout.flush();

    return 0;
}
/*


5
1
-4
0
7
239

*/