MAX = 1000000
prime = [True] * (MAX + 1)
sum = [0] * (MAX + 1)

def SieveOfEratosthenes():

	prime[1] = False

	p = 2
	while p * p <= MAX:

		if (prime[p]):

			i = p * 2
			while i <= MAX:
				prime[i] = False
				i += p
				
		p += 1
		
	for i in range(1, MAX + 1):
		if (prime[i] == True):
			sum[i] = 1

		sum[i] += sum[i - 1]

if __name__ == "__main__":
	
	SieveOfEratosthenes()

	l = 3
	r = 9

	c = (sum[r] - sum[l - 1])

	print("Count:", c)
