#include <bits/stdc++.h>
using namespace std;
#define fir first
#define sec second
#define sz size
#define mp make_pair
#define ll long long
#define ld long double
#define pb push_back
#define en "\n"
ll t[1000000], ts[1000000], n;
vector<ll> a;
void build(int l, int r, int v)
{
    if (l == r)
    {
        t[v] = a[l];
        ts[v] = a[l];
    }
    else
    {
        build(l, (l+r) / 2, v*2+1);
        build((l+r) / 2+1, r, v*2+2);
        t[v] = min(t[v*2+1], t[v*2+2]);
        ts[v] = ts[v*2+1]+ts[v*2+2];
    }
}
pair<ll, ll> get(int l, int r, int lx, int rx, int v)
{
    if (l > rx || r < lx)
        return mp(2e9, 0);
    if (l >= lx && r <= rx)
        return mp(t[v], ts[v]);
    pair<ll, ll> x = get(l, (l+r) / 2, lx, rx, v*2+1), y = get((l+r) / 2+1, r, lx, rx, v*2+2);
    x.fir = min(x.fir, y.fir);
    x.sec += y.sec;
    return x;
}
bool check(int x, ll s)
{
    if (x == n)
        return true;
    if (x == 0)
        return false;
    for (int i = 0; i+x <= n; i++)
    {
        pair<ll, ll> t = get(0, n-1, i, i+x-1, 0);
        if (t.sec >= s)
            return true;
    }
    for (int i = 0; i+x < n; i++)
    {
        pair<ll, ll> t = get(0, n-1, i, i+x, 0);
        if (t.sec-t.fir >= s)
            return true;
    }
    return false;
}
int main()
{
    ios::sync_with_stdio(0);
    cin >> n;
    a.resize(n);
    ll s = 0;
    for (int i = 0; i < n; i++)
    {
        cin >> a[i];
        s += a[i];
    }
    s = (s+1) / 2;
    build(0, n-1, 0);
    int l = 0, r = n;
    while (l < r)
    {
        int mid = (l+r) / 2;
        if (check(mid, s))
            r = mid;
        else
            l = mid+1;
    }
    cout << l << en;
    return 0;
}
