#include <bits/stdc++.h>
#define int long long
using namespace std;
struct segment_tree {
    int len = 1;
    vector < int > tree;
    void init(int x)
    {
        while(len < x) len *= 2;
        tree.resize(2 * len - 1, INT_MAX);
    }
    void changeFunc(int l, int r, int cur, int pos, int v)
    {
        if(r - l == 1)
        {
            tree[cur] = v;
            return;
        }
        int m = (r + l) / 2;
        if(pos < m)
            changeFunc(l, m, 2 * cur + 1, pos, v);
        else
            changeFunc(m, r, 2 * cur + 2, pos, v);
        tree[cur] = min(tree[2 * cur + 1], tree[2 * cur + 2]);
    }
    void change(int pos, int v)
    {
        changeFunc(0, len, 0, pos, v);
    }
    int minFunc(int lx, int rx, int l, int r, int cur)
    {
        if(lx >= r or rx <= l)
            return INT_MAX;
        if(lx >= l and rx <= r)
            return tree[cur];
        int m = (rx + lx) / 2;
        return min(minFunc(lx, m, l, r, 2 * cur + 1), minFunc(m, rx, l, r, 2 * cur + 2));
    }
    int Min(int l, int r)
    {
        return minFunc(0, len, l - 1, r, 0);
    }
};
int mn = INT_MAX;
segment_tree sg;
void Rec(int l, int r, vector < int > &pref)
{
    int m = (r + l) / 2;
    int sum = pref[r + 1] - pref[l];
//    cout << l << " " << r << " " << sum << " " << sum - sg.Min(l, r) << "\n";
    if(abs(r - l) < 2)
    {
        if(sum >= (pref.back() + 1) / 2)
        {
            mn = min(mn, r - l + 1);
            if(sum - sg.Min(l, r) >= (pref.back() + 1) / 2)
                mn = min(mn, r - l);
        }
        return;
    }
    if(sum >= (pref.back() + 1) / 2)
    {
        mn = min(mn, 1 + r - l);
        if(sum - sg.Min(l, r) >= (pref.back() + 1) / 2)
            mn = min(mn, r - l);
    }
    Rec(l, m, pref);
    Rec(m, r, pref);
}
void solve()
{
    int n;
    cin >> n;
    vector < int > a(n), pref(n + 1);
    sg.init(n);
    for(int i = 0; i < n; ++i)
    {
        cin >> a[i];
        sg.change(i, a[i]);
    }
    for(int i = 0; i < n; ++i)
        pref[i + 1] = pref[i] + a[i];
    Rec(0, n - 1, pref);
    cout << mn;
}

signed main()
{
    int t = 1;
    //cin >> t;
    while(t--)
    solve(), cout << "\n";
    return 0;
}
