import os
import sys
from io import BytesIO, IOBase

_str = str
str = lambda x=b"": x if type(x) is bytes else _str(x).encode()

BUFSIZE = 8192


class FastIO(IOBase):
    newlines = 0

    def __init__(self, file):
        self._fd = file.fileno()
        self.buffer = BytesIO()
        self.writable = "x" in file.mode or "r" not in file.mode
        self.write = self.buffer.write if self.writable else None

    def read(self):
        while True:
            b = os.read(self._fd, max(os.fstat(self._fd).st_size, BUFSIZE))
            if not b:
                break
            ptr = self.buffer.tell()
            self.buffer.seek(0, 2), self.buffer.write(b), self.buffer.seek(ptr)
        self.newlines = 0
        return self.buffer.read()

    def readline(self):
        while self.newlines == 0:
            b = os.read(self._fd, max(os.fstat(self._fd).st_size, BUFSIZE))
            self.newlines = b.count(b"\n") + (not b)
            ptr = self.buffer.tell()
            self.buffer.seek(0, 2), self.buffer.write(b), self.buffer.seek(ptr)
        self.newlines -= 1
        return self.buffer.readline()

    def flush(self):
        if self.writable:
            os.write(self._fd, self.buffer.getvalue())
            self.buffer.truncate(0), self.buffer.seek(0)


class IOWrapper(IOBase):
    def __init__(self, file):
        self.buffer = FastIO(file)
        self.flush = self.buffer.flush
        self.writable = self.buffer.writable
        self.write = lambda s: self.buffer.write(s.encode("ascii"))
        self.read = lambda: self.buffer.read().decode("ascii")
        self.readline = lambda: self.buffer.readline().decode("ascii")


sys.stdin, sys.stdout = IOWrapper(sys.stdin), IOWrapper(sys.stdout)
input = lambda: sys.stdin.readline().rstrip("\r\n")
output = lambda x: sys.stdout.write(x)

n = int(input())
arr = list(map(int, input().split()))

sum = 0
for i in range(n):
    sum += arr[i]

ans = []
csum = 0
start = 0
end = 0
for i in range(n):
    end = i
    csum += arr[i]
    if csum >= (sum / 2):
        while csum >= (sum / 2):
            if csum - arr[start] >= (sum / 2):
                csum = csum - arr[start]
                start += 1
            else:
                break
        cmin = arr[start]
        for j in range(start, end + 1):
            if arr[j] < cmin:
                cmin = arr[j]
        if csum - cmin >= (sum / 2):
            ans.append(end - start)
        else:
            ans.append(end - start + 1)

num = ans[0]
for i in range(len(ans)):
    if ans[i] < num:
        num = ans[i]

print(num)