#include <iostream>
#include <string>
#include <map>
#include <vector>
#include <algorithm>
#include <cmath>
using namespace std;

#define ll long long
#define vi vector<int>
#define oo 1000000000

const int N = 5005;

ll to2(ll a) {
    ll num = 0;
    while (a) {
        if (a & 1) {
            ++num;
        }
        a >>= 1;
    }
    return num;
}

void solve() {
    ll x;
    cin >> x;
    if (x == 0) {
        cout << 0 << "\n";
        return;
    }
    if (x < 0) {
        x = -x;
    }
    ll ans = to2(x);
    ll k = log2(x);
    if ((1LL << k) != x) ++k;
    ll num = (1LL << k) - x;
    ans = min(ans, to2(num) + 1LL);
    cout << ans << "\n";
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    //int t = 1;
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}