#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <string>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <cmath>
#include <bitset>
#include <unordered_map>
#include <stack>
#include <random>

using namespace std;

const int N = 200003, mod = 998244353;

int n;
string a[N];

bool check(int k)
{
    //cout << k << endl;
    map<int, int> mp;
    for (int i = 0; i < n; i++)
    {
        long long hash = 0;
        long long p = 1;
        for (int j = 0; j < k; j++)
        {
            hash += (a[i][j] - 'a') * p;
            p *= 31;
            hash %= mod;
            p %= mod;
        }
        mp[hash]++;
    }
    bool res = true;
    for (auto x : mp)
    {
        //cout << x.first << ' ' << x.second << endl;
        res &= x.second % 2 == 0;
    }
    //cout << endl;
    return res;
}

void solve()
{
    cin >> n;
    for (int i = 0; i < n; i++)
    {
        cin >> a[i];
    }
    int l = 0, r = a[0].size();
    while (l < r)
    {
        int m = (l + r + 1) / 2;
        if (check(m))
        {
            l = m;
        }
        else
        {
            r = m - 1;
        }
    }
    cout << l;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie();
    cout.tie();
    int t = 1;
    //cin >> t;
    while (t--)
        solve();
    return 0;
}