#include <bits/stdc++.h>
using namespace std;

#define pll pair<long long, long long>
#define all(a) (a).begin(), (a).end()
#define len(a) ((int)(a).size())
#define add push_back
#define mkp make_pair
#define ll long long
#define fr first
#define sc second

const long long INF = 1000000000ll * 1000000003ll;
const long long MOD = 1000000007ll;
const int N = 2e5 + 5;

ll n, sum = 0;
ll a[N], pref[N];
ll t[4 * N];

void build(int v, int tl, int tr){
	if(tl == tr){
		t[v] = a[tl];
		return;
	}
	int tm = (tl + tr) / 2;
	build(2 * v, tl, tm);
	build(2 * v + 1, tm + 1, tr);
	t[v] = min(t[2 * v], t[2 * v + 1]);
}

ll get(int v, int tl, int tr, int l, int r){
	if(tl == l && tr == r) return t[v];
	int tm = (tl + tr) / 2;
	if(r <= tm) return get(2 * v, tl, tm, l, r);
	if(l >  tm) return get(2 * v + 1, tm + 1, tr, l, r);
	return min( get(2 * v, tl, tm, l, tm),
				get(2 * v + 1, tm + 1, tr, tm + 1, r));
}

void solve(){
	cin >> n;
	for(int i = 1; i <= n; i++){
		cin >> a[i]; sum += a[i];
		pref[i] = pref[i - 1] + a[i];
	}
	build(1, 1, n);
	sum = (sum + 1) / 2;
//	cout << sum << endl;
	int ans = n;
	for(int i = 1; i <= n; i++){
		if(pref[i] < sum) continue;
		int ind = upper_bound(pref, pref + n + 1, pref[i] - sum) - pref; ind--;
		ans = min(ans, i - ind);
//		cout << i << " " << ind << " - " << ans << endl;
		if(pref[i] - pref[ind] - get(1, 1, n, ind + 1, i) >= sum) ans = min(ans, i - ind - 1);
//		cout << get(1, 1, n, ind + 1, ) << " - " << ans << endl;
	}
	cout << ans << "\n";
}

int main(){
	ios_base::sync_with_stdio(false); cin.tie(0);
	int _ = 1;
	// cout << fixed;
	// cout.precision(9);

	// cin >> _ ;
	while(_--) solve();
	return 0;
}
