#include <bits/stdc++.h>

using namespace std;

typedef long double ld;
typedef long long ll;

#define int long long
#define endl '\n'

int cnt(int x) {
    int res = 0;
    while (x > 0) {
        res += x % 2;
        x >>= 1;
    }
    return res;
}

int full(int x) {
    int res = 0;
    while (x > 0) {
        res++;
        x >>= 1;
    }
    return res;
}

map<int, int> dp;

int minDegAfter(int n) {
    int res = 1;
    while (res < n) {
        res *= 2;
    }
    return res;
}

int maxDegBefore(int n) {
    return minDegAfter(n) / 2;
}

int solve(int n, int rec = 0) {
    if (dp.find(n) != dp.end())
        return dp[n];
    if (rec == 7) {
        return dp[n] = min(cnt(n), full(n) - cnt(n) + 2);
    }
    dp[n] = cnt(n);
    int after = minDegAfter(n);
    int before = after / 2;
    if (after - n != n) {
        dp[n] = min(dp[n], 1 + solve(after - n, rec + 1));
    }

    if (n - before != n) {
        dp[n] = min(dp[n], 1 + solve(n - before, rec + 1));
    }
    return dp[n];
}

void solve() {
    int n;
    cin >> n;
    n = abs(n);
//    int c1 = cnt(n);
//    int c0 = full(n) - c1;
//    cout << min(c0 + 2, c1) << endl;
    dp[0] = 0;
    for (int i = 0; i < 62; i++) {
        dp[2ll << i] = 1;
    }
    cout << solve(n) << '\n';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int T;
    cin >> T;
    while (T--)
        solve();
    return 0;
}