#include "bits/stdc++.h"
#define int long long
#define M7 1'000'000'007LL
#define INF 1e9
#define ALL(x) x.begin(), x.end()
using namespace std;

void solve ();
int32_t main () {
    ios_base::sync_with_stdio(false); cout.tie (0);
#ifdef tulizh
    freopen ("input.txt", "r", stdin);
    freopen ("output.txt", "w", stdout);
#endif
    int t=1; //cin >> t;
    while (t--) solve ();
#ifdef tulizh
    cout << '\n' << clock () / 1000.0 << " s.\n";
#endif
}

vector<int> make_p(int n){
    vector<int> a(n);
    a[0] = 1;
    for(int i = 1; i < n; i++){
        a[i] = (a[i - 1] * 31);
        a[i] %= M7;
    }
    return a;
}
vector<int> make_hash(string &a, vector<int> &p){
    int n = a.size();
    vector<int> hash(n);
    for(int i = 0; i < n; i++){
        hash[i] = (a[i] - 'a' + 1) * p[i];
        hash[i] %= M7;
        if(i) (hash[i] += hash[i-1]) %= M7;
        hash[i] %= M7;
    }
    return hash;
}

unordered_map<int, pair<int, int>> mp;

void solve () {
    string path;
    int t, q, c, x;
    cin >> q >> c;
    auto p = make_p(2e5 + 5);
    for (int it = 0; it < q; it++) {
        cin >> t;
        if (t == 1) {
            cin >> x >> path;
            int h = make_hash(path, p).back();
            mp[h] = {it, x};
        } else {
            cin >> path;
            pair<int, int> cur = {-1, 0};
            int pref = -1;
            auto h = make_hash(path, p);
            for (int i = 0; i < path.length(); i++) {
                auto e = mp.find(h[i]);
                if (e != mp.end()) {
                    if (cur.first < e->second.first) {
                        cur = e->second;
                        pref = i + 1;
                    }
                }
            }
            if (cur.first == -1) cout << -1 << endl;
            else {
                int color = cur.second;
                for (int i = pref; i < path.length(); i++) {
                    if (path[i] == 'R') color--;
                    else color++;
                }
                cout << (color % c + c) % c << endl;
            }
        }
    }
}
