#include "bits/stdc++.h"
#define int long long
#define M7 1'000'000'007LL
#define INF 1e9
#define ALL(x) x.begin(), x.end()
using namespace std;

void solve ();
int32_t main () {
    ios_base::sync_with_stdio(false); cout.tie (0);
#ifdef tulizh
    freopen ("input.txt", "r", stdin);
    freopen ("output.txt", "w", stdout);
#endif
    int t=1; //cin >> t;
    while (t--) solve ();
#ifdef tulizh
    cout << '\n' << clock () / 1000.0 << " s.\n";
#endif
}

vector<int> make_p(int n){
    vector<int> a(n);
    a[0] = 1;
    for(int i = 1; i < n; i++){
        a[i] = (a[i - 1] * 31);
        a[i] %= M7;
    }
    return a;
}
vector<int> make_hash(string &a, vector<int> &p){
    int n = a.size();
    vector<int> hash(n);
    for(int i = 0; i < n; i++){
        hash[i] = (a[i] - 'a' + 1) * p[i];
        hash[i] %= M7;
        if(i) (hash[i] += hash[i-1]) %= M7;
        hash[i] %= M7;
    }
    return hash;
}

void solve () {

    int n; cin >> n;
    vector<int> p = make_p(2000000);
    vector<vector<int>> a(n, vector<int>());
    for(int i = 0; i < n; i++){
        string s; cin >> s;
        a[i] = make_hash(s, p);
    }
    int l = 0, r = a[0].size() + 1;
    while(r - l > 1){
        int m = (l + r) / 2;
        map<int, int> cnt;
        for(int i = 0; i < n; i++) cnt[a[i][m - 1]]++;
        bool f = false;
        for(auto &[x, y] : cnt){
            if(y % 2 == 1){
                f = true;
                break;
            }
        }
        if(f) r = m;
        else l = m;
    }
    cout << l;

}
