#include <iostream>
#include <string>       
#include <Windows.h>    
#include <time.h>
#include <conio.h>    
#include "Win10.h"
using namespace std;
#define RND(min, max)  (rand()%((max)-(min)+1)+(min))

struct Coord {
    int row, col;
};

string pole[]{
  "############################",
  "#............##............#",
  "#$####.#####.##.#####.####$#",
  "#..........................#",
  "#.####.##.########.##.####.#",
  "#......##....##....##......#",
  "######.##### ## #####.######",
  "     #.#     1      #.#     ",
  "######.# #        # #.######",
  "      .  #  1 1 1 #  .      ",
  "######.# ########## #.######",
  "     #.#            #.#     ",
  "######.# ########## #.######",
  "#............##............#",
  "#.####.#####.##.#####.####.#",
  "#$..##.......&........##..$#",
  "###.##.##.########.##.##.###",
  "#......##....##....##......#",
  "#.########## ## ##########.#",
  "#..........................#",
  "############################"
};

string pole2[]{
  "############################",
  "#............##............#",
  "#$####.#####.##.#####.####$#",
  "#..........................#",
  "#.####.##.########.##.####.#",
  "#......##....##....##......#",
  "######.##### ## #####.######",
  "     #.#     1      #.#     ",
  "######.# #        # #.######",
  "      .  #  1 1 1 #  .      ",
  "######.# ########## #.######",
  "     #.#            #.#     ",
  "######.# ########## #.######",
  "#............##............#",
  "#.####.#####.##.#####.####.#",
  "#$..##.......&........##..$#",
  "###.##.##.########.##.##.###",
  "#......##....##....##......#",
  "#.##########.##.##########.#",
  "#..........................#",
  "############################"
};

int PoleHeight;
int PoleWidth;

int PoleRow = 3;
int PoleCol = 8;

int Live = 3;
int Score = 0;
int High_score = 0;
int Up = 1;
int MenuRow = 4, MenuCol = 20;

int Select = 0;
int colSelFon = COLOR::white;
int colSelSym = COLOR::red;

int colUnSelFon = COLOR::black;
int colUnSelSym = COLOR::light_red;

int colDefFon = COLOR::black;
int colDefSym = COLOR::white;

int chetRow = PoleRow + PoleHeight - 22;
int chetCol = PoleCol;

int UpRow = PoleRow + PoleHeight - 23;
int UpCol = PoleCol;

void StartGame();
Coord GetHero(char Sym = '&', int Index = 0);
void DrawPole();
void ShowGameInfo();

int main()
{
    PoleHeight = sizeof(pole) / sizeof(pole[0]);
    PoleWidth = pole[0].size();
    bool isExit = false;
    int chetRow = PoleRow + PoleHeight - 22;
    int chetCol = PoleCol;

    int UpRow = PoleRow + PoleHeight - 23;
    int UpCol = PoleCol;


    while (!isExit)
    {
        CursorHide();
        setlocale(LC_ALL, "C");

        SetPos(UpRow, UpCol + 16);
        SetColor(COLOR::black, COLOR::bright_white);
        cout << "HIGH SCORE";

        High_score = Score;
        SetPos(chetRow, chetCol + 20);
        SetColor(COLOR::black, COLOR::bright_white);
        cout << High_score;

        SetPos(MenuRow - 1, MenuCol - 1);
        cout << char(201) << char(205) << char(205) << char(205) << char(205) << char(205) << char(205) << char(205) << char(205)
            << char(205) << char(205) << char(205) << char(205) << char(205) << char(205) << char(205) << char(205) << char(205) << char(187);

        SetPos(MenuRow + 0, MenuCol - 1);
        cout << char(186);

        SetPos(MenuRow + 0, MenuCol);

        if (Select == 0) { SetColor(colSelFon, colSelSym); }
        else { SetColor(colUnSelFon, colUnSelSym); }
        cout << "    1 PLAYER     ";


        SetColor(colDefFon, colDefSym);
        SetPos(MenuRow + 0, MenuCol - 25);
        cout << char(186);

        SetPos(MenuRow + 1, MenuCol - 1);
        cout << char(186);

        SetPos(MenuRow + 1, MenuCol);
        if (Select == 1) { SetColor(colSelFon, colSelSym); }
        else { SetColor(colUnSelFon, colUnSelSym); }
        cout << "      EXIT       ";

        SetColor(colDefFon, colDefSym);
        SetPos(MenuRow + 2, MenuCol - 25);
        cout << char(186);

        SetPos(MenuRow + 2, MenuCol - 1);
        cout << char(200) << char(205) << char(205) << char(205) << char(205) << char(205) << char(205) << char(205) << char(205)
            << char(205) << char(205) << char(205) << char(205) << char(205) << char(205) << char(205) << char(205) << char(205) << char(188);
       
        SetColor(COLOR::black, COLOR::light_yellow);
        SetPos(MenuRow + 4, MenuCol + 4);
        cout << "PAC - MAN" << endl;

        SetColor(colDefFon, colDefSym);
        SetPos(MenuRow + 6, MenuCol + 3);
        cout << "TM & c 2022 " << endl;
        SetPos(MenuRow + 7, MenuCol - 2);
        cout << "A.R.A Company Service";

        {
            int key = _getch();
            switch (key)
            {
            case _KEY::UP:
                if (Select > 0) { Select--; }
                break;
            case _KEY::DOWN:
                if (Select < 1) { Select++; }
                break;
            case _KEY::ENTER:
                switch (Select) {
                case 0:
                    StartGame();
                    break;
                case 1:
                    isExit = true;
                    break;
                }
                break;
            case _KEY::ESC:
                isExit = true;
                break;
            }
        }
    }
    SetPos(MenuRow + 6, MenuCol - 2);
    cout << "                                ";
    SetPos(MenuRow + 7, MenuCol - 2);
    cout << "     GOOD BYE !";

    cin.get(); cin.get();
}

Coord* GetHeroEx(char Sym, int& SizeCoord)
{
    SizeCoord = 0;

    for (int i = 0; i < PoleHeight; i++) {
        for (int j = 0; j < PoleWidth; j++) {
            if (pole[i][j] == Sym) { SizeCoord++; }
        }
    }

    Coord* mas = new Coord[SizeCoord];
    int k = 0;
    for (int i = 0; i < PoleHeight; i++) {
        for (int j = 0; j < PoleWidth; j++) {
            if (pole[i][j] == Sym) {
                mas[k].row = i;
                mas[k].col = j;
                k++;
            }
        }
    }
    return mas;
}

Coord GetHero(char Sym, int Index)
{
    Coord hero{ 0,0 };
    int count = 0;
    for (int i = 0; i < PoleHeight; i++) {
        for (int j = 0; j < PoleWidth; j++) {
            if (pole[i][j] == Sym) {
                if (count == Index) {
                    hero.row = i;
                    hero.col = j;
                    return hero;
                }
                count++;
            }
        }
    }
    return hero;
}

void StartGame()
{
    Score = 0;
    Live = 3;
    for (int i = 0; i < 21; i++) {
        for (int j = 0; j < 28; j++) {
            pole[i] = pole2[i];
        }
    }
    system("cls");
    DrawPole();
    CursorHide(FALSE);
    Coord Hero = GetHero();
    Coord HeroSpawn = Hero;
    int key = 0;
    bool isGameOver = false;
    int WRow = PoleRow + PoleHeight;
    int WCol = PoleCol;

    while (!isGameOver)
    {

        int dRow = 0, dCol = 0;
        if (_kbhit()) {
            key = _getch();
        }
        switch (key)
        {
        case _KEY::UP:
            if (pole[Hero.row - 1][Hero.col] != '#') {
                dRow = -1;
            }
            break;
        case _KEY::DOWN:
            if (pole[Hero.row + 1][Hero.col] != '#') {
                dRow = 1;
            }
            break;
        case _KEY::LEFT:
            if (pole[Hero.row][Hero.col - 1] != '#') {
                dCol = -1;
            }
            break;
        case _KEY::RIGHT:
            if (pole[Hero.row][Hero.col + 1] != '#') {
                dCol = 1;
            }
            break;
        case _KEY::ESC:
            isGameOver = true;
            break;
        case _KEY::SPACE:
            continue;
            system("cls");
            break;
        }
        int newy = Hero.row;
        int newx = Hero.col;
        Coord Win = GetHero('.');
        Coord Enemy1 = GetHero('1');
        if (dRow != 0 || dCol != 0) {
            pole[Hero.row][Hero.col] = ' ';
            Hero.row += dRow;
            Hero.col += dCol;
            if (pole[Hero.row][Hero.col] == '1') {
                pole[Hero.row][Hero.col] = '&';
                Live--;
                Hero = HeroSpawn;
                if (Live == 0) {
                    isGameOver = true;
                    int WRow = PoleRow + PoleHeight;
                    int WCol = PoleCol;
                    SetPos(WRow + 3, WCol + 12);
                    cout << "Game Over";
                    break;
                }
                else {
                    pole[Hero.row][Hero.col] = '&';
                }
            }

            else if (Win.col == 0 && Win.row == 0) {
                int WRow = PoleRow + PoleHeight;
                int WCol = PoleCol;
                SetPos(WRow + 3, WCol + 10);
                cout << "WIN";
                break;
            }
            else if (pole[Hero.row][Hero.col] == '.') {
                Score += 10;
                pole[Hero.row][Hero.col] = '&';
            }
            else if (pole[Hero.row][Hero.col] == '$') {
                Score += 50;
                pole[Hero.row][Hero.col] = '&';
            }
            else if (newy == 9 && (newx == 1 || newx == 27)) {
                if (newx == 1) {
                    newx = 26;
                }
                else {
                    newx = 2;
                }
                pole[Hero.row][Hero.col] = ' ';
                pole[newy][newx] = '&';

                Hero.row = newy;
                Hero.col = newx;
            }
            else {
                pole[Hero.row][Hero.col] = '&';
            }
        }; 

        for (int i = 0; i < 4; i++) {
            for (int j = 0; j < 1; j++) {
                int hod = RND(1, 10);
                Enemy1 = GetHero('1', i);
                if (hod <= 3) {
                    int masDir2[4]{};
                    int cntDir2 = 0;         
                    if (pole[Enemy1.row - 1][Enemy1.col] == ' ' ||
                        pole[Enemy1.row - 1][Enemy1.col] == '&') {
                        masDir2[cntDir2++] = 1;
                    }
                    if (pole[Enemy1.row + 1][Enemy1.col] == ' ' ||
                        pole[Enemy1.row + 1][Enemy1.col] == '&') {
                        masDir2[cntDir2++] = 2;
                    }
                    if (pole[Enemy1.row][Enemy1.col - 1] == ' ' ||
                        pole[Enemy1.row][Enemy1.col - 1] == '&') {
                        masDir2[cntDir2++] = 3;
                    }
                    if (pole[Enemy1.row][Enemy1.col + 1] == ' ' ||
                        pole[Enemy1.row][Enemy1.col + 1] == '&') {
                        masDir2[cntDir2++] = 4;
                    }
                    if (cntDir2 == 0) {
                        continue;
                    }
                    int BotDir2 = masDir2[rand() % cntDir2];
                    pole[Enemy1.row][Enemy1.col] = ' ';
                    switch (BotDir2) {
                    case 1: Enemy1.row--; break;
                    case 2: Enemy1.row++; break;
                    case 3: Enemy1.col--; break;
                    case 4: Enemy1.col++; break;
                    }
                    if (pole[Enemy1.row][Enemy1.col] == pole[Hero.row][Hero.col]) {
                        Live--;
                        Hero = HeroSpawn;
                        if (Live == 0) {
                            isGameOver = true;
                            SetPos(WRow + 3, WCol + 10);
                            cout << "Game Over";
                            break;
                        }
                        else {
                            pole[Hero.row][Hero.col] = '&';
                        }
                    }
                    pole[Enemy1.row][Enemy1.col] = '1';
                }
                else {
                    pole[Enemy1.row][Enemy1.col] = ' ';
                    if (Enemy1.row < Hero.row) {
                        if (pole[Enemy1.row + 1][Enemy1.col] == ' ' ||
                            pole[Enemy1.row + 1][Enemy1.col] == '&' ||
                            pole[Enemy1.row + 1][Enemy1.col] == '.') {
                            Enemy1.row++;
                        }
                    }
                    if (Enemy1.row > Hero.row) {
                        if (pole[Enemy1.row - 1][Enemy1.col] == ' ' ||
                            pole[Enemy1.row - 1][Enemy1.col] == '&' ||
                            pole[Enemy1.row - 1][Enemy1.col] == '.') {
                            Enemy1.row--;
                        }
                    }
                    if (Enemy1.col < Hero.col) {
                        if (pole[Enemy1.row][Enemy1.col + 1] == ' ' ||
                            pole[Enemy1.row][Enemy1.col + 1] == '&' ||
                            pole[Enemy1.row][Enemy1.col + 1] == '.') {
                            Enemy1.col++;
                        }
                    }
                    if (Enemy1.col > Hero.col) {
                        if (pole[Enemy1.row][Enemy1.col - 1] == ' ' ||
                            pole[Enemy1.row][Enemy1.col - 1] == '&' ||
                            pole[Enemy1.row][Enemy1.col - 1] == '.') {
                            Enemy1.col--;
                        }
                    }
                    if (pole[Enemy1.row][Enemy1.col] == pole[Hero.row][Hero.col]) {
                        Live--;
                        Hero = HeroSpawn;
                        if (Live == 0) {
                            isGameOver = true;
                            int WRow = PoleRow + PoleHeight;
                            int WCol = PoleCol;
                            SetPos(WRow + 3, WCol + 10);
                            cout << "Game Over";
                            break;
                        }
                        else {
                            pole[Hero.row][Hero.col] = '&';
                        }
                    }
                    int newyE = Enemy1.row;
                    int newxE = Enemy1.col;
                    if (newyE == 9 && (newxE == 1 || newxE == 27)) {
                        if (newxE == 1) {
                            newxE = 26;
                        }
                        else {
                            newxE = 2;
                        }
                        pole[Hero.row][Hero.col] = ' ';
                        pole[newy][newx] = '&';

                        Hero.row = newyE;
                        Hero.col = newxE;
                    }
                    pole[Enemy1.row][Enemy1.col] = '1';
                }
            }
        }

        DrawPole();
        ShowGameInfo();
        Sleep(80);
    }
    system("pause > nul");
    system("cls");
}


void ShowGameInfo()
{
    system("chcp 866 > nul");

    int LiveRow = PoleRow + PoleHeight + 1;
    int LiveCol = PoleCol;
    SetColor(COLOR::black, COLOR::light_yellow);
    SetPos(LiveRow, LiveCol);
    cout << char(2) << " " << Live;

    int chetRow = PoleRow + PoleHeight - 22;
    int chetCol = PoleCol;
    SetPos(chetRow, chetCol);
    SetColor(COLOR::black, COLOR::bright_white);
    cout << Score;

    int UpRow = PoleRow + PoleHeight - 23;
    int UpCol = PoleCol;
    SetPos(UpRow, UpCol);
    SetColor(COLOR::black, COLOR::bright_white);
    cout << Up << "UP";

    SetPos(UpRow, UpCol + 10);
    SetColor(COLOR::black, COLOR::bright_white);
    cout << "HIGH SCORE";

    SetPos(chetRow, chetCol + 13);
    SetColor(COLOR::black, COLOR::bright_white);
    cout << High_score;
}


void DrawPole()
{
    for (int i = 0; i < PoleHeight; i++)
    {

        SetPos(PoleRow + i, PoleCol);

        for (int j = 0; j < PoleWidth; j++)
        {
            if (pole[i][j] == '#') {
                SetColor(COLOR::black, COLOR::blue);
                cout << char(177);
            }
            else if (pole[i][j] == '1') {
                SetColor(COLOR::black, COLOR::light_red);
                cout << char(2);
            }
            else if (pole[i][j] == '.') {
                SetColor(COLOR::black, COLOR::light_yellow);
                cout << '.';
            }
            else if (pole[i][j] == '$') {
                SetColor(COLOR::black, COLOR::light_yellow);
                cout << "o";
            }
            else if (pole[i][j] == '&') {
                SetColor(COLOR::black, COLOR::light_yellow);
                cout << char(2);
            }
            else { cout << pole[i][j]; }
        }
    }
}