#include<iostream>
#include<vector>
#include <map>

using namespace std;
using ll = long long;
const ll mod = 1e9 + 7;

int ansx = -1, ansy = -1;

bool prv(int x, int y, int v) {
    if (ansx == x && ansy == y) return 1;
    if (v == 1 || v == 8 || v == 2) {
        return x > ansx;
    } else if (v == 5 || v == 4 || v == 6) {
        return x < ansx;
    } else if (v == 3) {
        return y < ansy;
    } else if (v == 7) {
        return y > ansy;
    }
    return 1000;
}

void solve() {
	int n, m;
	cin >> n >> m;
	vector<vector<int>> a(n + 2, vector<int>(m + 2));
	for (int i = 1; i <= n; i++) {
        for (int j = 1; j<= m; j++) {
            cin >> a[i][j];
        }
	}
	bool b = false;
	for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            int ul, ur, dl, dr;
            ul = (a[i-1][j-1] == 4 || a[i-1][j-1] == 8);
            ur = (a[i-1][j+1] == 6 || a[i-1][j+1] == 2);
            dl = (a[i+1][j-1] == 2 || a[i+1][j-1] == 6);
            dr = (a[i+1][j+1] == 8 || a[i+1][j+1] == 4);

            if ((ul && ur) || (dl && dr) || (ul && dl) || (ur && dr)) {
                ansx = i;
                ansy = j;
                b = true;
                cout << i << " " << j << endl;
                break;
                //return;
            }
        }
        if (b) break;
	}
	if (ansx == -1) {
        if ((a[2][1] == 1 || a[2][1] == 5) && (a[1][2] == 3 || a[1][2] == 7)) {
            //a[1][1]
            ansx = 1;
            ansy = 1;
            cout << 1 << " " << 1 << endl;
        } else if ((a[n-1][1] == 1 || a[n-1][1] == 5) && (a[n][2] == 3 || a[n][2] == 7)) {
            //a[n][1]
            ansx = n;
            ansy = 1;
            cout << n << " " << 1 << endl;
        } else if ((a[2][m] == 1 || a[2][m] == 5) && (a[1][m-1] == 7 || a[1][m-1] == 3)) {
            //a[1][m]
            ansx = 1;
            ansy = m;
            cout << 1 << " " << m << endl;
        } else if ((a[n-1][m] == 1 || a[n-1][m] == 5) && (a[n][m-1] == 7 || a[n][m-1] == 3)) {
            //a[n][m]
            ansx = n;
            ansy = m;
            cout << n << " " << m << endl;
        }
	}


	int c = -1;
	int r = -1;
	for (int i = 1; i <= n; i++) {
        int cnt = 0;
        for (int j = 1; j <= m; j++) {
            cnt += !prv(i, j, a[i][j]);
        }
        if (cnt >= 2) {
            r = i;
            break;
        }
	}
	for (int j = 1; j <= m; j++) {
        int cnt = 0;
        for (int i = 1; i <= n; i++) {
            cnt += !prv(i, j, a[i][j]);
        }
        if (cnt >= 2) {
            c = j;
            break;
        }
	}
	cout << r << " " << c << endl;
	//cout << "CHKA" << endl;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);
	solve();
}
