import tkinter as tk
from tkinter import messagebox
import random
 
FONT = ('Courier', 30)
FONT_SMALL = ('Courier', 15)
 
class Game:
    def __init__(self, root):
        self.gui = GUI(root)
 
class GUI:
    def __init__(self, root):
        W = 400
        self.root = root
        self.root.title('Search double')
        self.canvas = canvas = tk.Canvas(root, width=W, height=W, bg='Thistle')
        self.canvas.pack(padx=10, pady=10)
        CELL = int(W * 0.25)
        ROWS = 4
        COLS = 4
        for row in range(ROWS):
            for col in range(COLS):
                canvas.create_line(0, row * CELL, W * CELL, row * CELL)
                canvas.create_line(col * CELL, 0, col * CELL, W * CELL)
                canvas.create_text(row * CELL+CELL/2, col * CELL+CELL/2, text=random.randint(1, 8), font='Times 30')
 
 
class Blocks:
    def __init__(self, name):
        self.name = name
        names = [1, 2, 3, 4, 5, 6, 7, 8] * 2
 
if __name__ == '__main__':
    root = tk.Tk()
    game = Game(root)
 
    root.mainloop()
