#include <iostream>
#include <cmath>
using namespace std;
long int  nextPowerOfTwo(int  n)
{

	long int value = 1;

	while (value <= n)
	{

		value = value << 1;
	}
	return value;
}

int  previousPowerOfTwo(int  n)
{
	if ((n && !(n & (n - 1))) == 1)
	{
		return (n >> 1);
	}
	while (n & n - 1)
	{
		n = n & n - 1;
	}
	return  n;
}
int degree(long long n) {
	long long next = nextPowerOfTwo(n);
	long long prev = previousPowerOfTwo(n);
	if (next - n < n - prev) {
		return log2(next);
	}
	return log2(prev);
}
int solve(long long n) {
	int steps = 0;
	if (n == 0) {
		return 0;
	}
	long long cur = n;
	while (true) {
		steps++;
		if (pow(2, degree(abs(cur))) == abs(cur)) {
			return steps;
		}
		cur = abs(pow(2, degree(abs(cur))) - abs(cur));
	}
}
int main() {
	long long n, a[100000];
	cin >> n;
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	for (int i = 0; i < n; i++) {
		cout << solve(a[i])<<endl;
	}
}