#include <stdio.h>

#include <algorithm>
#include <bitset>
#include <cassert>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <ctime>
#include <deque>
#include <fstream>
#include <functional>
#include <iomanip>
#include <iostream>
#include <iterator>
#include <list>
#include <map>
#include <queue>
#include <random>
#include <set>
#include <sstream>
#include <stack>
#include <string>
#include <unordered_map>
#include <unordered_set>
#include <vector>
//#include<bits/stdc++.h>
using namespace std;
#define ll long long
#define pb push_back
#define mp make_pair
#define f first
#define s second
#define ld long double

const ll maxn = 1e7 + 501, maxm = 3e3 + 1;
const ll mod = 998244353, inf = 1e9, block = 550, hb = 31, base = 1000050017;
const ld eps = 1e-9;

int q, c, v, sz;
int bor[maxn][2];
pair<int, int> dp[maxn];
void add(string q, int query, int color){
    v = 0;
    for (auto it : q){
        int type = 0;
        if (it == 'R')
            type = 1;
        if (bor[v][type] == 0){
            bor[v][type] = ++sz;
        }
        v = bor[v][type];
    }
    dp[v] = mp(query, color);
}
int get(string q){
    v = 0;
    pair<int, int> lastquery = mp(-1, -1);
    int pos = -1;
    for (int i = 0; i < q.size(); ++i){
        char it = q[i];
        int type = 0;
        if (it == 'R'){
            type = 1;
        }
        if (bor[v][type] == 0){
            break;
        }
        v = bor[v][type];
        if (dp[v].f != 0) {
            lastquery = max(lastquery, dp[v]);
            if (lastquery.f == dp[v].f){
                pos = i;
            }
        }
    }
    if (pos == -1)
        return -1;
    int color = lastquery.s;
    for (int j = pos + 1; j < q.size(); ++j){
        char it = q[j];
        if (it == 'L'){
            color = (color + 1) % c;
        }
        else{
            color = (color - 1 + c) % c; 
        }
    }
    return color;
}
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> q >> c;
    for (int i = 1; i <= q; ++i){
        int t;
        cin >> t;
        if (t == 1){
            int x;
            cin >> x;
            string s;
            cin >> s;
            add(s, i, x);
        }
        else{
            string s;
            cin >> s;
            cout << get(s) << '\n';
        }
    }
}
