#include <bits/stdc++.h>

using namespace std;

#define sz(x) (int)((x).size())
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const char en = '\n';
const int INF = 1e9 + 7;
const ll INFLL = 1e18;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

template<class T>
istream &operator>>(istream &is, vector<T> &a) {
    for (auto &i: a) {
        is >> i;
    }
    return is;
}

#ifdef LOCAL
#include "debug.h"
#else
#define debug(...) 42
#endif

void solve() {
    int q;
    cin >> q;
    for (int w = 0; w < q; ++w) {
        ll x;
        cin >> x;
        x = abs(x);
        if (x == 0) {
            cout << 0 << en;
            continue;
        }
        vector<int> bits;
        for (int l = 60; l >= 0; --l) {
            if ((x & (1LL << l)) == 0) {
                if (!bits.empty()) {
                    bits.emplace_back(0);
                }
            } else {
                bits.emplace_back(1);
            }
        }
        bits.emplace_back(0);
//        int c = 0;
//        vector<int> segs;
//        for (auto i: bits) {
//            if (i == 0) {
//                segs.push_back(c);
//                c = 0;
//            }
//            else {
//                ++c;
//            }
//        }
        int k = sz(bits), ans = k;
        vector<int> dp(k, 1e9);
        for (int i = 0; i < k; i++) {
            int cnt = 0;
            for (int j = i; j >= 0; j--) {
                cnt += bits[j] ^ 1;
                dp[i] = min(dp[i], (i == j ? bits[i] : 2 + cnt) + (j > 0 ? dp[j - 1] : 0));
            }
        }
//        debug(bits);
//        debug(dp);
        cout << dp[k - 1] << en;
    }
}

int32_t main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif
    solve();
    return 0;
}
