#include <bits/stdc++.h>

using namespace std;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const char en = '\n';
const int INF = 1e9 + 7;
const ll INFLL = 1e18;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

template<class T>
istream &operator>>(istream &is, vector<T> &a) {
    for (auto &i: a) {
        is >> i;
    }
    return is;
}

#ifdef LOCAL
#include "debug.h"
#else
#define debug(...) 42
#endif

void solve() {
    int n;
    cin >> n;
    vector<ll> a(n);
    cin >> a;
    ll s = 0;
    for (auto i: a) {
        s += i;
    }
    ll mn = (s + 1) / 2;
    deque<ll> q;
    ll cur = 0;
    int ans = n;
    int l = 0, r = 0;
    while (r < n) {
        cur += a[r];
        while (!q.empty() && a[r] < q.back()) {
            q.pop_back();
        }
        q.push_back(a[r]);
        if (cur >= mn) {
            ans = min(ans, r - l + 1);
        }
        if (!q.empty() && cur - q.front() >= mn) {
            ans = min(ans, r - l);
        }
        while (l < r && cur >= mn) {
            if (a[l] == q.front()) {
                q.pop_front();
            }
            cur -= a[l];
            ++l;
        }
        ++r;
    }
    cout << ans << en;
}

int32_t main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif
    solve();
    return 0;
}
