#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <algorithm>
#include <array>

using namespace std;

typedef long long ll;
typedef long double ld;

ll Get(pair<ll, ll>a, pair<ll, ll>b, pair<ll, ll>c)
{
	return a.first * b.second + b.first * c.second + c.first * a.second;
}

int main() {
	cin.tie(0);
	ios_base::sync_with_stdio(0);
	int n;
	cin >> n;
	vector<pair<int, int>>a(n);
	for (int i = 0; i < n; i++)
		cin >> a[i].first >> a[i].second;
	vector<int>now, next;
	if (Get(a[0], a[1], a[2]) >= Get(a[2], a[1], a[0]))
		now = { 0, 1, 2 };
	else
		now = { 2, 1, 0 };
	for (int i = 3; i < n; i++)
	{
		for (int k = 0; k < now.size() + 1; k++)
		{
			bool f = 0;
			if(k>0 && k<now.size())
				if (Get(a[now[k - 1]], a[i], a[now[k]]) < Get(a[now[k]], a[i], a[now[k - 1]]))
				{
					f = 1;
				}
			if (k + 1 < now.size())
				if (Get(a[i], a[now[k]], a[now[k + 1]]) < Get(a[now[k + 1]], a[now[k]], a[i]))
					f = 1;
			if (k > 1)
				if (Get(a[now[k - 2]], a[now[k - 1]], a[i]) < Get(a[i], a[now[k - 1]], a[now[k - 2]]))
					f = 1;
			if (!f)
			{
				next.push_back(i);
				for (int l = k; l < now.size(); l++)
				{
					next.push_back(now[l]);
				}
				swap(next, now);
				next.clear();
				break;
			}
			else
			{
				next.push_back(now[k]);
			}
		}
	}
	for (auto& i : now)
		cout << i + 1 << " ";
	return 0;
}