#include <bits/stdc++.h>

using namespace std;

#define int long long
#define pii pair<int, int>
#define F first
#define S second
#define pb push_back
#define eb emplace_back
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define sz(a) int(a.size())
#define dbg(a) cout << #a << " = " << a << "\n"
#define dbg1(a) cout << #a << " = [ "; for (auto& _ : a) cout << _ << " "; cout << "]\n"
#define dbg2(a) cout << #a << " = [ "; for (auto& _ : a) cout << "(" << _.first << " " << _.second << ") "; cout << "]\n"
#define fastIo(a) ios_base::sync_with_stdio(a); cin.tie(a); cout.tie(a)

using ll = long long;
using ld = long double;
const double Pi = 3.14159265;


const int INF = 2e9;
const ll INFll = 2e18;
const double EPS = 1e-8;

mt19937 rnd(time(0));

const int p = 239, mod = 1e9 + 7;

int R = 1;
struct SegmentTree{
    vector<int> tree;
    SegmentTree (vector<int>& v) {
        while (R < v.size()) R <<= 1;
        tree.resize(2 * R);
        for (int i = 0; i < v.size(); i++) tree[i + R] = v[i];
        for (int i = R - 1; i > 0; i--) {
            tree[i] = min(tree[i * 2], tree[i * 2 + 1]);
        }
    }
    int get(int ql, int qr, int nl=0, int nr=R, int node=1) {
        if (ql >= nr || nl >= qr) return INF;
        if (ql <= nl && nr <= qr) return tree[node];
        int nm = (nl + nr) / 2;
        return min(get(ql, qr, nl, nm, node * 2), get(ql, qr, nm, nr, node * 2 + 1));
    }
};

void solve() {
    int n;
    cin >> n;
    vector<int> v(n), pref(n + 1);
    ll sm = 0;
    for (auto &i : v) {
        cin >> i;
        sm += i;
    }
    for (int i = 1; i <= n; i++) pref[i] = pref[i - 1] + v[i - 1];
    SegmentTree sg(v);
    int l = 0, r = n + 1;
    while (l + 1 < r) {
        int m = (l + r) / 2;
        bool ok = false;
        for (int i = m - 1; i < n; i++) {
            ok |= (pref[i + 1] - pref[i - m + 1]) >= ((sm + 1) / 2);
        }
        if (ok) r = m;
        else l = m;
    }
    int ans = r;

    l = 0, r = n + 1;
    while (l + 1 < r) {
        int m = (l + r) / 2;
        bool ok = false;
        for (int i = m; i < n; i++) {
            ok |= (pref[i + 1] - pref[i - m] - sg.get(i - m, i + 1)) >= ((sm + 1) / 2);
        }
        if (ok) r = m;
        else l = m;
    }
    cout << min(ans, r);
}

signed main() {
    fastIo(0);
    int t = 1;
//    cin >> t;
    while (t--) solve();
}
