#include <bits/stdc++.h>

using namespace std;

#define int long long
#define pii pair<int, int>
#define F first
#define S second
#define pb push_back
#define eb emplace_back
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define sz(a) int(a.size())
#define dbg(a) cout << #a << " = " << a << "\n"
#define dbg1(a) cout << #a << " = [ "; for (auto& _ : a) cout << _ << " "; cout << "]\n"
#define dbg2(a) cout << #a << " = [ "; for (auto& _ : a) cout << "(" << _.first << " " << _.second << ") "; cout << "]\n"
#define fastIo(a) ios_base::sync_with_stdio(a); cin.tie(a); cout.tie(a)

using ll = long long;
using ld = long double;
const double Pi = 3.14159265;


const int INF = 2e9;
const ll INFll = 2e18;
const double EPS = 1e-8;

mt19937 rnd(2392281337);


void solve() {
    int n;
    cin >> n;
    vector<int> a(n), b(n);
    for (int i = 0; i < n; i++)
        cin >> a[i] >> b[i];
    vector<int> ids(n);
    iota(all(ids), 0);
    auto bad = [&](int id) {
        int i = ids[id - 2], j = ids[id - 1], k = ids[id];
        if (a[i] * b[j] + a[j] * b[k] + a[k] * b[i] < a[i] * b[k] + a[k] * b[j] + a[j] * b[i])
            return true;
        return false;
    };
    for (int i = n - 1; i >= 2; i--) {
        if (bad(i))
            swap(ids[i - 2], ids[i - 1]);
    }
    for (int i : ids) cout << i + 1 << " "; cout << '\n';
}

signed main() {
    fastIo(0);
    int t = 1;
    //cin >> t;
    while (t--) solve();
}
