#include <iostream>
#include <bits/stdc++.h>    
#include <cmath>
#include <algorithm>
#include <vector>
#include <deque>
#include <set>
#include <stack>
#include <string>
#include <map>
#include <queue>

#pragma comment(linker, "/stack:200000000")
#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,tune=native")

using namespace std;

#define int long long
#define ll long long
#define vi vector<long long>
#define pb push_back
#define sz(s) (int)s.size()
#define all(v) v.begin(), v.end()
#define show(a) cerr << #a <<" -> "<< a <<"\n"
#define pp pair<int,int>
#define FF first
#define SS second

const int N = 1e5 + 1, N3 = 1e3 + 6, inf = 1e18 + 7;
map<char, int> md{{'N', 0}, {'E', 1}, {'S', 2}, {'W', 3}};
const int dx[] = {-1, 0, 1, 0};
const int dy[] = {0, 1, 0, -1};
string stepDir = "RDLU";

int n, a[N], prf[N], t[N*4], sum;

void build(ll v, ll tl, ll tr)
{
    if(tl==tr)
    {
        t[v] = a[tl];
        return;
    }
    ll tm = (tl+tr)/2;
    build(v*2, tl, tm);
    build(v*2+1, tm+1, tr);
    t[v] = min(t[v*2], t[v*2+1]);
}
ll get(ll v, ll tl, ll tr, ll l, ll r)
{
    if(r<tl || tr<l) return inf;
    if(l<=tl && tr<=r) return t[v];
    ll tm = (tl+tr)/2;
    return min(get(v*2, tl, tm, l, r), get(v*2+1, tm+1, tr, l, r));
}
bool check(int k) {
    for (int i = 1; i <= n; i++) {
        int sum1 = prf[i + k - 1] - prf[i - 1];
        int sum2 = sum1 - get(1, 1, n, i, i + k - 1) + a[i + k];
        if (max(sum1, sum2)*2 >= sum) return 1; 
    }
    return 0;
}

main () {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);    
    
//  freopen("unionday.in", "r", stdin);
//  freopen("unionday.out", "w", stdout);
    
    cin >> n;
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
        prf[i] = prf[i - 1] + a[i];
        sum += a[i];
    }
    build(1, 1, n);
    
    int l = 1, r = n, ans = -1;
    while (l <= r) {
        int mid = (l + r) / 2;
        if (check(mid)) {
            ans = mid;
            r = mid - 1;
        }
        else {
            l = mid + 1;
        }
    }
    cout << ans;
    
    
    return 0;   
}
