﻿#include <iostream>
#include <algorithm>
#include <math.h>
#include <vector>
#include <set>
#include <string>
#include <map>
#include <stack>
#include <deque>
using namespace std;
using ll = long long;
const ll LONGINF = 1e18 + 7;
const int INF = 1e9 + 7;

ll g(int n)
{
    return n * (n - 1) / 2;
}

void solve() 
{
    int n;
    cin >> n;
    vector<vector<ll>> dp(n + 1, vector<ll>(n + 1, LONGINF));
    for (int i = 1; i <= n; i++) dp[i][i] = g(i);
    for (int i = 1; i <= n; i++)
    {
        for (int j = i - 1; j >= 0; j--)
        {
            dp[i][j] = dp[i][j + 1];
            if (i >= j)
            {
                dp[i][j] = min(dp[i][j], dp[i - j][j + 1] + g(j));
            }
        }
    }
    cout << dp[n][1] << '\n';
}
int main()
{
    int t = 1;
    //cin >> t;
    while (t--) solve();
}
//confirmed by association of the best code