#include <bits/stdc++.h>

using namespace std;

struct Node {
  long long color;
  Node *l = nullptr, *r = nullptr;

  Node(long long c = -1) {
    color = c;
  }
};

int main() {
  int q; cin >> q;
  long long c; cin >> c;
  Node *root = new Node;
  for(int i = 0; i < q; i++) {
    int t; cin >> t;
    if(t == 1) {
      int u; cin >> u;
      string s; cin >> s;
      Node *p = root;
      for(int j = 0; j < s.size(); j++) {
        if(s[j] == 'L') {
          if(p->l == nullptr) p->l = new Node();
          p = p->l;
        } else if(s[j] == 'R') {
          if(p->r == nullptr) p->r = new Node();
          p = p->r;
        }
      }
      p->color = u;
      p->l = new Node((p->color + 1) % c);
      p->r = new Node((p->color - 1 + c) % c);
    } else {
      string s; cin >> s;
      Node *p = root;
      long long color = -1;
      for(int j = 0; j < s.size(); j++) {
        if(s[j] == 'L') {
          p = p->l;
          if(p == nullptr) break;
          if(p->color != -1) color = p->color;
        } else if(s[j] == 'R') {
          p = p->r;
          if(p == nullptr) break;
          if(p->color != -1) color = p->color;
        }
      }
      cout << color << endl;
    }
  }

  return 0;
}

