#include <iostream>
#include <utility>
#include <vector>
#include <cmath>
#include <algorithm>
#include <unordered_set>
#include <set>
#include <queue>
#include <cmath>
#include <numeric>
#include <sstream>
#include <string>
#include <map>
#include <unordered_map>
#include <deque>
#include <iomanip>
#include <unordered_set>
#include <limits>
#include <list>
#include <bitset>
#include <random>
#include <cstring>
#include <cassert>
#include <chrono>
#include <array>

#pragma GCC optimize("Ofast")

#define ff first
#define err(x) cerr << "["#x"]  " << (x) << "\n"
#define errv(x) {cerr << "["#x"]  ["; for (const auto& ___ : (x)) cerr << ___ << ", "; cerr << "]\n";}
#define errvn(x, n) {cerr << "["#x"]  ["; for (auto ___ = 0; ___ < (n); ++___) cerr << (x)[___] << ", "; cerr << "]\n";}
#define ss second
#define pb push_back
#define all(a) a.begin(), a.end()
typedef long long ll;
typedef long double ld;
using namespace std;
const int MOD = 1000000007;
mt19937 rnd(std::chrono::high_resolution_clock::now().time_since_epoch().count());

template<typename T1, typename T2>
inline bool relaxmi(T1 &a, const T2 &b) {
    return a > b ? a = b, true : false;
}

template<typename T1, typename T2>
inline bool relaxma(T1 &a, const T2 &b) {
    return a < b ? a = b, true : false;
}

double GetTime() { return clock() / (double) CLOCKS_PER_SEC; }

/// Actual code starts here
const int N = 1505;

int get_t(int x, int y, int x2, int y2) {
    if (x - y == x2 - y2) {
        if (y < y2) return 4;
        else return 8;
    } else if (x + y == x2 + y2) {
        if (x < x2) return 6;
        else return 2;
    } else {
        if (abs(x - x2) < abs(y - y2)) {
            if (y < y2) return 3;
            else return 7;
        } else {
            if (x < x2) return 5;
            else return 1;
        }
    }
}

int table[N][N], n, m, table2[N][N];
int obr[10];

bool check(int x, int y, int &resx, int &resy) {
    vector<int> cnt(n), cnt2(m);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            table2[i][j] = 0;
            if (i == x && j == y) continue;
            int tp = get_t(i, j, x, y);
            if (tp != table[i][j]) {
                if (obr[tp] != table[i][j]) return false;
                else table2[i][j] = 1;
            }
        }
    }
    int xx = -1, yy = -1;
    for (int i = 0; i < n; i++) {
        int sum = 0;
        for (int j = 0; j < m; j++) sum += table2[i][j];
        if (sum == m) xx = i;
        else if (sum == m - 1 && x == i) xx = i;
    }

    for (int i = 0; i < m; i++) {
        int sum = 0;
        for (int j = 0; j < n; j++) sum += table2[j][i];
        if (sum == n) yy = i;
        else if (sum == n - 1 && y == i) yy = i;
    }
    if (xx == -1 || yy == -1) return false;
    resx = xx, resy = yy;
    return true;
}

bool used[N][N];

bool valid(int x, int y) {
    if (x >= 0 && x < n && y >= 0 && y < m) return true;
    return false;
}

void solve() {
    for (int i = 1; i <= 8; i++) {
        if (i <= 4) {
            obr[i] = i + 4;
        } else obr[i] = i - 4;
    }
    cin >> n >> m;
    for (int i = 0; i < n; i++)
        for (int j = 0; j < m; j++)
            cin >> table[i][j];

    for (int i = 0; i < n; i++)
        for (int j = 0; j < m; j++) {
            if (min(i, n - i) < 5 && min(j, m - j) < 5) {
                int resx, resy;
                if (check(i, j, resx, resy)) {
                    cout << i + 1 << ' ' << j + 1 << '\n' << resx + 1 << ' ' << resy + 1;
                    return;
                }
            }
        }

    vector<int> cand_x, cand_y;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (used[i][j]) continue;
            if (table[i][j] == 2) {
                int x = i, y = j;
                while (x >= 0 && y < m && !used[x][y]) {
                    x--, y++;
                    if (!valid(x, y)) {
                        if (valid(x + 1, y - 1)) {
                            cand_x.pb(x + 1);
                            cand_y.pb(y - 1);
                        }
                        break;
                    }
                    used[x][y] = true;
                    if (table[x][y] != 2) {
                        cand_x.pb(x);
                        cand_y.pb(y);
                        break;
                    }
                }
                used[i][j] = true;

            } else if (table[i][j] == 6) {
                int x = i, y = j;
                while (x < n && y >= 0 && !used[x][y]) {
                    x++, y--;
                    if (!valid(x, y)) {
                        if (valid(x - 1, y + 1)) {
                            cand_x.pb(x - 1);
                            cand_y.pb(y + 1);
                        }
                        break;
                    }
                    used[x][y] = true;
                    if (table[x][y] != 6) {
                        cand_x.pb(x);
                        cand_y.pb(y);
                        break;
                    }
                }
                used[i][j] = true;
            } else if (table[i][j] == 8) {
                int x = i, y = j;
                while (x >= 0 && y >= 0 && !used[x][y]) {
                    x--, y--;
                    if (!valid(x, y)) {
                        if (valid(x + 1, y + 1)) {
                            cand_x.pb(x + 1);
                            cand_y.pb(y + 1);
                        }
                        break;
                    }
                    used[x][y] = true;
                    if (table[x][y] != 8) {
                        cand_x.pb(x);
                        cand_y.pb(y);
                        break;
                    }
                }
                used[i][j] = true;

            } else if (table[i][j] == 4) {
                int x = i, y = j;
                while (x < n && y < m && !used[x][y]) {
                    x++, y++;
                    if (!valid(x, y)) {
                        if (valid(x - 1, y - 1)) {
                            cand_x.pb(x - 1);
                            cand_y.pb(y - 1);
                        }
                        break;
                    }
                    used[x][y] = true;
                    if (table[x][y] != 4) {
                        cand_x.pb(x);
                        cand_y.pb(y);
                        break;
                    }
                }
                used[i][j] = true;

            }
        }
    }
    sort(all(cand_x));
    sort(all(cand_y));
    cand_x.resize(unique(all(cand_x)) - cand_x.begin());
    cand_y.resize(unique(all(cand_y)) - cand_y.begin());
    for (auto i: cand_x)
        for (auto j: cand_y) {
            int resx = -1, resy = -1;
            if (check(i, j, resx, resy)) {
                cout << i + 1 << ' ' << j + 1 << '\n' << resx + 1 << ' ' << resy + 1;
                return;
            }
        }
    while (true) {
        cout << "AAAA\n";
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int tt = 1;
    //cin >> tt;
    while (tt--)
        solve();
}
