#include <iostream>
#include <utility>
#include <vector>
#include <cmath>
#include <algorithm>
#include <unordered_set>
#include <set>
#include <queue>
#include <cmath>
#include <numeric>
#include <sstream>
#include <string>
#include <map>
#include <unordered_map>
#include <deque>
#include <iomanip>
#include <unordered_set>
#include <limits>
#include <list>
#include <bitset>
#include <random>
#include <cstring>
#include <cassert>
#include <chrono>
#include <array>

#define ff first
#define err(x) cerr << "["#x"]  " << (x) << "\n"
#define errv(x) {cerr << "["#x"]  ["; for (const auto& ___ : (x)) cerr << ___ << ", "; cerr << "]\n";}
#define errvn(x, n) {cerr << "["#x"]  ["; for (auto ___ = 0; ___ < (n); ++___) cerr << (x)[___] << ", "; cerr << "]\n";}
#define ss second
#define pb push_back
#define all(a) a.begin(), a.end()
typedef long long ll;
typedef long double ld;
using namespace std;
const int MOD = 1000000007;
mt19937 rnd(std::chrono::high_resolution_clock::now().time_since_epoch().count());

template<typename T1, typename T2>
inline bool relaxmi(T1 &a, const T2 &b) {
    return a > b ? a = b, true : false;
}

template<typename T1, typename T2>
inline bool relaxma(T1 &a, const T2 &b) {
    return a < b ? a = b, true : false;
}

double GetTime() { return clock() / (double) CLOCKS_PER_SEC; }

/// Actual code starts here
const int N = 500555;

int tr[N * 2][2];
pair<int, int> last[2 * N];
int T = 1, C;

void add(int t, int x, string &s) {
    int v = 0;
    for (auto i: s) {
        int sym = (i == 'L' ? 0 : 1);
        if (tr[v][sym] == -1) tr[v][sym] = T++;
        v = tr[v][sym];
    }
    last[v] = {t, x};
}

int get(string &s) {
    int v = 0;
    pair<int, int> g = {-1, -1};
    int pos = -1, t = 0;
    for (auto i: s) {
        t++;
        int sym = (i == 'L' ? 0 : 1);
        if (tr[v][sym] == -1) tr[v][sym] = T++;
        v = tr[v][sym];
        if (relaxma(g, last[v])) pos = t;
    }
    if(g.ff == -1 || g.ff == 0) return -1;
    int res = g.ss;
    for(int j = pos;j < s.size();j++) {
        if(s[j] == 'L') {
            res = (res + 1) % C;
            v = tr[v][0];
        } else {
            res = (res - 1 + C) % C;
            v = tr[v][1];
        }
    }
    return res;
}

void solve() {
    for (int i = 0; i < N; i++)
        for (int j = 0; j < 2; j++)
            tr[i][j] = -1;
    int q;
    cin >> q >> C;
    for(int i = 1;i <= q;i++) {
        int t;
        cin >> t;
        if(t == 1) {
            string s;
            int x;
            cin >> x >> s;
            add(i, x, s);
        } else {
            string s;
            cin >> s;
            cout << get(s) << '\n';
        }
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int tt = 1;
    //cin >> tt;
    while (tt--)
        solve();
}
