#include <iostream>
#include <utility>
#include <vector>
#include <cmath>
#include <algorithm>
#include <unordered_set>
#include <set>
#include <queue>
#include <cmath>
#include <numeric>
#include <sstream>
#include <string>
#include <map>
#include <unordered_map>
#include <deque>
#include <iomanip>
#include <unordered_set>
#include <limits>
#include <list>
#include <bitset>
#include <random>
#include <cstring>
#include <cassert>
#include <chrono>
#include <array>

#define ff first
#define err(x) cerr << "["#x"]  " << (x) << "\n"
#define errv(x) {cerr << "["#x"]  ["; for (const auto& ___ : (x)) cerr << ___ << ", "; cerr << "]\n";}
#define errvn(x, n) {cerr << "["#x"]  ["; for (auto ___ = 0; ___ < (n); ++___) cerr << (x)[___] << ", "; cerr << "]\n";}
#define ss second
#define pb push_back
#define all(a) a.begin(), a.end()
typedef long long ll;
typedef long double ld;
using namespace std;
const int MOD = 1000000007;
mt19937 rnd(std::chrono::high_resolution_clock::now().time_since_epoch().count());

template<typename T1, typename T2>
inline bool relaxmi(T1 &a, const T2 &b) {
    return a > b ? a = b, true : false;
}

template<typename T1, typename T2>
inline bool relaxma(T1 &a, const T2 &b) {
    return a < b ? a = b, true : false;
}

double GetTime() { return clock() / (double) CLOCKS_PER_SEC; }
/// Actual code starts here
const int N = 100005;

int dp[61][2];
bool used[61][2];
ll x;
ll inv_x;

int rec(int i, int inv) {
    if (used[i][inv]) {
        return dp[i][inv];
    }
    used[i][inv] = true;
    if (i == 0) {
        return dp[i][inv] = 1;
    }
    int j = i - 1;
    if (!inv) {
        while (!(x & (1ll << j))) {
            --j;
        }
    } else {
        while (!(inv_x & (1ll << j))) {
            --j;
        }
    }
    dp[i][inv] = 1 + rec(j, inv);
    j = i - 1;
    if (inv) {
        while (!(x & (1ll << j))) {
            --j;
        }
    } else {
        while (!(inv_x & (1ll << j))) {
            --j;
        }
    }
    dp[i][inv] = min(dp[i][inv], 1 + rec(j, !inv));
    return dp[i][inv];
}

void solve() {
    cin >> x;
    x = abs(x);
    if (x == 0) {
        cout << "0\n";
        return;
    }
    while (x % 2 == 0) {
        x >>= 1;
    }
    inv_x = 1;
    for (int i = 0; i <= 60; ++i) {
        used[i][0] = used[i][1] = false;
    }
    int i = 0;
    while ((1ll << (i + 1)) <= x) {
        ++i;
    }
    for (int j = 1; j <= i; ++j) {
        if (x & (1ll << j)) {
            continue;
        }
        inv_x |= (1ll << j);
    }
    cout << rec(i, 0) << '\n';
    return;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int tt = 1;
    cin >> tt;
    while (tt--)
        solve();
}
