#include <iostream>
#include <utility>
#include <vector>
#include <cmath>
#include <algorithm>
#include <unordered_set>
#include <set>
#include <queue>
#include <cmath>
#include <numeric>
#include <sstream>
#include <string>
#include <map>
#include <unordered_map>
#include <deque>
#include <iomanip>
#include <unordered_set>
#include <limits>
#include <list>
#include <bitset>
#include <random>
#include <cstring>
#include <cassert>
#include <chrono>
#include <array>

#define ff first
#define int long long
#define err(x) cerr << "["#x"]  " << (x) << "\n"
#define errv(x) {cerr << "["#x"]  ["; for (const auto& ___ : (x)) cerr << ___ << ", "; cerr << "]\n";}
#define errvn(x, n) {cerr << "["#x"]  ["; for (auto ___ = 0; ___ < (n); ++___) cerr << (x)[___] << ", "; cerr << "]\n";}
#define ss second
#define pb push_back
#define all(a) a.begin(), a.end()
typedef long long ll;
typedef long double ld;
using namespace std;
const int MOD = 1000000007;
mt19937 rnd(std::chrono::high_resolution_clock::now().time_since_epoch().count());

template<typename T1, typename T2>
inline bool relaxmi(T1 &a, const T2 &b) {
    return a > b ? a = b, true : false;
}

template<typename T1, typename T2>
inline bool relaxma(T1 &a, const T2 &b) {
    return a < b ? a = b, true : false;
}

double GetTime() { return clock() / (double) CLOCKS_PER_SEC; }

/// Actual code starts here
const int N = 100055;

int tr[4 * N], a[N], n;

void build(int v = 0, int L = 0, int R = n) {
    if (R - L == 1) {
        tr[v] = a[L];
        return;
    }
    int M = (L + R) / 2;
    build(v * 2 + 1, L, M);
    build(v * 2 + 2, M, R);
    tr[v] = min(tr[v * 2 + 1], tr[v * 2 + 2]);
}

int get(int l, int r, int v = 0, int L = 0, int R = n) {
    if (l == L && r == R) {
        return tr[v];
    }
    int res = MOD, M = (L + R) / 2;
    if (l < M) res = min(res, get(l, min(M, r), v * 2 + 1, L, M));
    if (M < r) res = min(res, get(max(l, M), r, v * 2 + 2, M, R));
    return res;
}

int pf[N];

void solve() {
    cin >> n;
    for (int i = 0; i < n; i++) cin >> a[i];
    build();
    for (int i = 0; i < n; i++) pf[i] = a[i];
    for (int i = 1; i < n; i++) pf[i] += pf[i - 1];
    int res = MOD, sum = pf[n - 1];
    int need = (sum + 1) / 2;
    for (int i = 0; i < n; i++) {
        int l = i, r = n - 1, ans = -1;
        while (l <= r) {
            int c = (l + r) / 2;
            int cur = pf[c];
            if (i) cur -= pf[i - 1];
            if (cur >= need) ans = c, r = c - 1;
            else l = c + 1;
        }
        if (ans != -1) {
            relaxmi(res, ans - i + 1);
            int cur = pf[ans] - (i == 0 ? 0 : pf[i - 1]);
            cur -= get(i, ans + 1);
            if (cur >= need) relaxmi(res, ans - i);
        }
    }
    cout << res;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int tt = 1;
    //cin >> tt;
    while (tt--)
        solve();
}
