#include <bits/stdc++.h>
#include <bits/extc++.h>


#define ff first
#define err(x) cerr << "["#x"]  " << (x) << "\n"
#define errv(x) {cerr << "["#x"]  ["; for (const auto& ___ : (x)) cerr << ___ << ", "; cerr << "]\n";}
#define errvn(x, n) {cerr << "["#x"]  ["; for (auto ___ = 0; ___ < (n); ++___) cerr << (x)[___] << ", "; cerr << "]\n";}
#define ss second
#define pb push_back
#define all(a) a.begin(), a.end()
typedef long long ll;
typedef long double ld;
using namespace std;
using namespace __gnu_pbds;
const int MOD = 1000000007;
mt19937 rnd(std::chrono::high_resolution_clock::now().time_since_epoch().count());

template<typename T1, typename T2>
inline bool relaxmi(T1 &a, const T2 &b) {
    return a > b ? a = b, true : false;
}

template<typename T1, typename T2>
inline bool relaxma(T1 &a, const T2 &b) {
    return a < b ? a = b, true : false;
}

double GetTime() { return clock() / (double) CLOCKS_PER_SEC; }

/// Actual code starts here
const int N = 100005;

using ld = long double;

const ll mod = (ll) 1e18 + 7;

inline ll sum(ll a, ll b) {
    a += b;
    if (a >= mod) {
        a -= mod;
    }
    return a;
}

inline ll mul(__int128 a, __int128 b) {
    return ((__int128) a * b) % mod;
}

const ll base = 31;

inline ll h(char c) {
    return ll(c - 'a') + 1ll;
}

inline bool check(vector<vector<ll> > &p, int n, int x) {
    if (x == 0) {
        return true;
    }
    cc_hash_table<ll, bool> mp;
    for (int i = 0; i < n; ++i) {
        mp[p[i][x - 1]] ^= 1;
    }
    for (auto &[hh, vv]: mp) {
        if (vv) {
            return false;
        }
    }
    return true;
}

void solve() {
    int n, m;
    cin >> n;
    vector<string> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    m = a[0].size();
    vector<vector<ll> > p(n, vector<ll>(m));
    for (int i = 0; i < n; ++i) {
        p[i][0] = h(a[i][0]);
        for (int j = 1; j < m; ++j) {
            p[i][j] = sum(mul(p[i][j - 1], base), h(a[i][j]));
        }
    }
    int l = 0;
    int r = m;
    while (l < r) {
        int x = (l + r + 1) >> 1;
        if (check(p, n, x)) {
            l = x;
        } else {
            r = x - 1;
        }
    }
    cout << l;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int tt = 1;
    //cin >> tt;
    while (tt--)
        solve();
}
