#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <queue>
#include <deque>
#include<stack>
#include<string>
#include<iomanip>
#include<set>

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

using namespace std;
using ll = long long;
using ld = long double;

ll gcd(ll a, ll b) {
	if (b == 0) return a;
	return gcd(b, a % b);
}

ll lcm(ll a, ll b) {
	return a / gcd(a, b) * b;
}

void cinv(vector <ll>& a) {
	for (int i = 0; i < a.size(); ++i) {
		cin >> a[i];
	}
}

// ==============================================================================

void solve() {
	ll n;
	cin >> n;
	vector<ll>a(n);
	ll cnt = 0;
	for (int i = 0; i < n; i++) {
		cin >> a[i];
		cnt += a[i];
	}
	vector<ll>b(n), c(n);
	b[n - 1] = a[n - 1];
	c[n - 1] = a[n - 1];
	for (int i = n - 2; i >= 0; i--) {
		b[i] = b[i + 1] + a[i];
		c[i] = min(c[i + 1], a[i]);
	}
	ll sch = cnt / 2;
	for (int i = n - 1; i >= 0; i--) {
		if (b[i] - c[i] >= sch) {
			cout << n - i - 1;
			return;
		}
		else if (b[i] >= sch) {
			cout << n - i;
			return;
		}
	}
}

// ==============================================================================

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	ll t = 1;
	//cin >> t;
	while (t--) solve();
	return 0;
}