#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;
using namespace std;

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<int>> field(n, vector<int>(m));
    for (auto& row : field)
        for (auto& x : row)
            cin >> x;
    bool found_first = false;
    bool found_second = false;
    int first = 0;
    int second = 0;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (field[i][j] == 4 || field[i][j] == 8) {
                found_first = true;
                first = i - j;
            } else if (field[i][j] == 2 || field[i][j] == 6) {
                found_second = true;
                second = i + j;
            }
        }
    }
    if (!found_first) {
        if (n != m) {
            if (second == n - 1)
                first = n - 1;
            else
                first = -m + 1;
        }
        if (field[0][1] == 7 || field[0][1] == 3)
            first = -m + 1;
        else
            first = n - 1;
    } else if (!found_second) {
        if (n != m) {
            if (first == 0)
                second = 0;
            else
                second = n + m - 2;
        } else {
            if (field[0][1] == 7 || field[0][1] == 3)
                second = 0;
            else
                second = n + m - 2;
        }
    }
    int y = (first + second) / 2;
    int x = (second - first) / 2;
    int horizontal = -1;
    int vertical = -1;
    for (int i = 0; i < n; i++) {
        if (i == y)
            continue;
        if (i < y && field[i][x] == 5 || i > y && field[i][x] == 1)
            continue;
        if (horizontal != -1) {
            vertical = x;
            break;
        }
        horizontal = i;
    }
    if (vertical != -1) {
        if (x < m - 1)
            for (int i = 0; i < n; i++) {
                if (i < y - 1) {
                    if (field[i][x + 1] == 5)
                        continue;
                } else if (i == y - 1) {
                    if (field[i][x + 1] == 6)
                        continue;
                } else if (i == y) {
                    if (field[i][x + 1] == 7)
                        continue;
                } else if (i == y + 1) {
                    if (field[i][x + 1] == 8)
                        continue;
                } else {
                    if (field[i][x + 1] == 1)
                        continue;
                }
                horizontal = i;
                break;
            }
        else {
            for (int i = 0; i < n; i++) {
                if (i < y - 1) {
                    if (field[i][x - 1] == 5)
                        continue;
                } else if (i == y - 1) {
                    if (field[i][x - 1] == 4)
                        continue;
                } else if (i == y) {
                    if (field[i][x - 1] == 3)
                        continue;
                } else if (i == y + 1) {
                    if (field[i][x - 1] == 2)
                        continue;
                } else {
                    if (field[i][x - 1] == 1)
                        continue;
                }
                horizontal = i;
                break;
            }
        }
    } else if (horizontal == -1) {
        horizontal = y;
        if (y < n - 1) {
            for (int i = 0; i < m; i++) {
                if (i < x - 1) {
                    if (field[y + 1][i] == 3)
                        continue;
                } else if (i == x - 1) {
                    if (field[y + 1][i] == 2)
                        continue;
                } else if (i == x) {
                    if (field[y + 1][i] == 1)
                        continue;
                } else if (i == x + 1) {
                    if (field[y + 1][i] == 8)
                        continue;
                } else {
                    if (field[y + 1][i] == 7)
                        continue;
                }
                vertical = i;
                break;
            }
        } else {
            for (int i = 0; i < m; i++) {
                if (i < x - 1) {
                    if (field[y - 1][i] == 3)
                        continue;
                } else if (i == x - 1) {
                    if (field[y - 1][i] == 4)
                        continue;
                } else if (i == x) {
                    if (field[y - 1][i] == 5)
                        continue;
                } else if (i == x + 1) {
                    if (field[y - 1][i] == 6)
                        continue;
                } else {
                    if (field[y - 1][i] == 7)
                        continue;
                }
                vertical = i;
                break;
            }
        }
    } else {
        for (int i = 0; i < m; i++) {
            if (i == x)
                continue;
            if (i < x && field[y][i] == 3 || i > x && field[y][i] == 7)
                continue;
            vertical = i;
            break;
        }
    }

    cout << y + 1 << " " << x + 1 << "\n";
    cout << horizontal + 1 << " " << vertical + 1;
}

signed main() {
    cin.tie(NULL);
    ios_base::sync_with_stdio(false);

    solve();
}