#include <bits/stdc++.h>

#define all(a) a.begin(), a.end()
#define last(a) (a.end() - 1)

using namespace std;

typedef long long ll;
typedef long double ld;

template<class T>
ostream& operator<<(ostream& os, vector<T> &a) {
	for (auto &i: a) {
		os << i << " ";
	}
	return os;
}

template<class T>
ostream& operator<<(ostream& os, vector<vector<T>> &a) {
	for (auto &i: a) {
		os << i << "\n";
	}
	return os;
}

template<class X, class Y>
ostream& operator<<(ostream& os, pair<X, Y> &a) {
	os << a.first << " " << a.second;
	return os;
}

// #define FILEI "input.txt"
// #define FILEO "output.txt"

int main() {
	#ifdef FILEI
		freopen(FILEI, "r", stdin);
	#else
		ios::sync_with_stdio(false);
		cin.tie(0);
	#endif
	#ifdef FILEO
		freopen(FILEO, "w", stdout);
	#else
		cout.tie(0);
	#endif

	vector<long long> ans(5001);

	set<int> polygons;

	int n;
	cin >> n;

	for (int i = 0; i < 5000; i++) {
		for (int verts = 1; verts <= 5000; verts++) {
			if (polygons.find(verts) == polygons.end()) {
				polygons.emplace(verts);
				break;
			}
			if (polygons.find(verts + 1) == polygons.end()) {
				polygons.erase(verts);
				polygons.emplace(verts + 1);
				break;
			}
		}
		for (auto &pol: polygons) {
			ans[i] += pol * (pol - 1) / 2;
		}
	}
	cout << ans[n];
	return 0;
}