#include <bits/stdc++.h>

#define all(a) a.begin(), a.end()
#define last(a) (a.end() - 1)

#pragma GCC optimize("O0")

using namespace std;

typedef long long ll;
typedef long double ld;

template<class T>
ostream& operator<<(ostream& os, vector<T> &a) {
	for (auto &i: a) {
		os << i << " ";
	}
	return os;
}

template<class T>
ostream& operator<<(ostream& os, vector<vector<T>> &a) {
	for (auto &i: a) {
		os << i << "\n";
	}
	return os;
}

template<class X, class Y>
ostream& operator<<(ostream& os, pair<X, Y> &a) {
	os << a.first << " " << a.second;
	return os;
}

long long x;

map<long long, bool> *visited;

long long rec(long long cur, long long turns, int dir) {
	if (cur == x) {
		return turns;
	}

	if ((*visited)[cur]) return 1e18;
	
	(*visited)[cur] = true;

	int k = __lg(abs(cur - x));

	long long a = cur + (1 << k) * dir, b = cur + (1 << (k + 1)) * dir;
	if (abs(x - a) < abs(x - b)) {
		swap(a, b);
		dir *= -1;
	}

	return min(rec(a, turns + 1, dir), rec(b, turns + 1, -dir));
}

// #define FILEI "input.txt"
// #define FILEO "output.txt"

int main() {
	#ifdef FILEI
		freopen(FILEI, "r", stdin);
	#else
		ios::sync_with_stdio(false);
		cin.tie(0);
	#endif
	#ifdef FILEO
		freopen(FILEO, "w", stdout);
	#else
		cout.tie(0);
	#endif

	int t;
	cin >> t;
	while (t--) {
		visited = new map<long long, bool>();
		cin >> x;
		cout << rec(0, 0, x > 0 ? 1 : -1) << "\n";
	}
	return 0;
}