﻿#include "bits/stdc++.h"
#include <ext/pb_ds/detail/standard_policies.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
#define all(x) (x).begin(), (x).end()
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

#ifdef CLOWN

#include "trash.h"

#define dbg(...) cout << "[" << #__VA_ARGS__ << "]:", debug_out(__VA_ARGS__);
#else
#define dbg(...);
#endif

int test = 0;

void fastio() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
}


const ll N = 1e5 + 5;
const ll LG = 17;
ll n, a[N], pref[N], sum = 0;
ll st[LG][N];

void make() {
    for (int i = 0; i < n; i++) {
        st[0][i] = a[i];
    }
    for (int lg = 0; lg < LG - 1; lg++) {
        for (int i = 0; i + (1ll << lg) < n; i++) {
            st[lg + 1][i] = min(st[lg][i], st[lg][i + (1ll << lg)]);
        }
    }
}

ll get_min(int l, int r) { //[l, r)
    int lg = __lg(r - l);
    return min(st[lg][l], st[lg][r - (1ll << lg)]);
}

ll get_pref(int l, int r) {
    if (l == 0)
        return pref[r];
    return pref[r] - pref[l - 1];
}

bool check1(ll len) {
    for (int i = 0; i + len - 1 < n; i++) {
        ll got = get_pref(i, i + len - 1);
        if (got >= sum)
            return true;
    }
    return false;
}

bool check2(ll len) {
    len++;
    for (int i = 0; i + len - 1 < n; i++) {
        ll sum1 = get_pref(i, i + len - 1);
        ll mn = get_min(i, i + len);
        ll got = sum1 - mn;
        if (got >= sum)
            return true;
    }
    return false;
}

void solve() {
    cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        sum += a[i];
    }
    make();
    sum = (sum + 1) / 2;
    for (int i = 0; i < n; i++) {
        if (i)
            pref[i] = pref[i - 1];
        pref[i] += a[i];
    }

    ll l = -1, r = n; //MEOW
    while (r - l > 1) {
        ll mid = (r + l) / 2;
        if (check1(mid)) {
            r = mid;
        } else {
            l = mid;
        }
    }
    ll best = r;
    l = -1, r = n;
    while (r - l > 1) {
        ll mid = (r + l) / 2;
        if (check2(mid)) {
            r = mid;
        } else {
            l = mid;
        }
    }
    cout << min(r, best);
}

int32_t main() {
#ifdef CLOWN
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t = 1;
    fastio();
    if (test) cin >> t;
    while (t--) { solve(); }
    return 0;
}
