﻿#include "bits/stdc++.h"
#include <ext/pb_ds/detail/standard_policies.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
#define all(x) (x).begin(), (x).end()
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

#ifdef CLOWN

#include "trash.h"

#define dbg(...) cout << "[" << #__VA_ARGS__ << "]:", debug_out(__VA_ARGS__);
#else
#define dbg(...);
#endif

int test = 0;
const int P = 239, MOD = 1e9 + 7, N = 2e6 + 5;
int n, mn = N;
ll pows[N];


void make() {
    pows[0] = 1;
    for (int i = 1; i < N; i++) {
        pows[i] = pows[i - 1] * P % MOD;
    }
}

void fastio() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
}


struct Hash {
    vector<ll> hsh;

    void build(string &s) {
        int n = (int) s.size();
        hsh.resize(n);
        hsh[0] = s[0];
        for (int i = 1; i < n; i++) {
            hsh[i] = (hsh[i - 1] * P % MOD + s[i]) % MOD;
        }
    }

    ll get(int l, int r) {
        if (l == 0)
            return hsh[r];
        return (hsh[r] - hsh[l - 1] * pows[r - l + 1] % MOD + MOD) % MOD;
    }
};

vector<Hash> info;

bool check(int len) {
    map<ll, int> cnt;
   for(int i = 0; i < n; i++) {
       ll got = info[i].get(0, len - 1);
       cnt[got]++;
   }
   for(auto i : cnt) {
       if(i.second & 1)
           return false;
   }
   return true;
}

void solve() {
    cin >> n;
    vector<string> a(n);
    for (auto &i: a) {
        cin >> i;
        mn = min(mn, (int) i.size());
    }
    make();
    info.resize(n);
    for (int i = 0; i < n; i++) {
        info[i].build(a[i]);
    }

    int l = 0, r = mn + 1; //MEOW
    while (r - l > 1) {
        int mid = (r + l) / 2;
        if (check(mid)) {
            l = mid;
        } else {
            r = mid;
        }
    }
    cout << l;
}

int32_t main() {
#ifdef CLOWN
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t = 1;
    fastio();
    if (test) cin >> t;
    while (t--) { solve(); }
    return 0;
}
