#include <bits/stdc++.h>

#define fr(i, a, b) for (int i = (a); i <= (b); ++i)
#define rf(i, a, b) for (int i = (a); i >= (b); --i)
#define fe(x, y) for (auto& x : y)

#define fi first
#define se second
#define pb push_back
#define mp make_pair
#define mt make_tuple

#define all(x) (x).begin(), (x).end()
#define sz(x) (int)(x).size()
#define pw(x) (1LL << (x))

using namespace std;

mt19937_64 rng(chrono::system_clock::now().time_since_epoch().count());

#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;
template <typename T>
using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
#define fbo find_by_order
#define ook order_of_key

template <typename T>
bool umn(T& a, T b) { return (a > b ? (a = b, 1) : 0); }
template <typename T>
bool umx(T& a, T b) { return (a < b ? (a = b, 1) : 0); }

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
template <typename T>
using ve = vector<T>;

const int N = 101;
const ld EPS = 1e-9;

struct Point {
    ll x, y;
    void scan() {
        cin >> x >> y;
    }
    ld len() {
        return sqrt(*this % *this);
    }
    Point operator+(const Point& other) const {
        return Point{x + other.x, y + other.y};
    }
    Point operator-(const Point& other) const {
        return Point{x - other.x, y - other.y};
    }
    ld operator*(const Point& other) const {
        return x * other.y - y * other.x;
    }
    ld operator%(const Point& other) const {
        return x * other.x + y * other.y;
    }
    bool operator==(const Point &other) const {
        return x == other.x && y == other.y;
    }
};

int n;
Point A[N], B[N];

bool pointOnSegm(Point X, Point A, Point B) {
    if ((B - A) * (X - A) != 0) {
        return 0;
    }
    if (X == A || X == B) {
        return 1;
    }
    return (X - A) % (B - A) > 0 && (X - B) % (A - B) > 0;
}

int sign(ll x) {
    if (x < 0) return -1;
    if (x > 0) return 1;
    return 0;
}

bool segmIntersect(Point A, Point B, Point C, Point D) {
    if ((B - A) * (D - C) == 0) {
        return pointOnSegm(A, C, D) ||
               pointOnSegm(B, C, D);
    }

    bool good = 1;
    Point AC = C - A;
    Point AD = D - A;
    Point AB = B - A;
    good &= sign(AB * AC) != sign(AB * AD);
    Point CA = A - C;
    Point CB = B - C;
    Point CD = D - C;
    good &= sign(CD * CA) != sign(CD * CB);
    return good;
}

ld distPointSegm(Point X, Point A, Point B) {
    Point AX = X - A;
    Point BX = X - B;
    if (AX % (B - A) > 0 && BX % (A - B) > 0) {
        return abs(AX * (B - A)) / (B - A).len();
    } else {
        return min(AX.len(), BX.len());
    }
}

ld distSegm(Point A, Point B, Point C, Point D) {
    ld ans = 1e18;
    umn(ans, distPointSegm(A, C, D));
    umn(ans, distPointSegm(B, C, D));
    umn(ans, distPointSegm(C, A, B));
    umn(ans, distPointSegm(D, A, B));
    return ans;
}

bool possible(int i, int j, int k) {
    if (segmIntersect(A[i], B[i], A[j], B[j])) {
        return 1;
    }
    if (segmIntersect(A[i], B[i], A[k], B[k])) {
        return 1;
    }
    if (segmIntersect(A[j], B[j], A[k], B[k])) {
        return 1;
    }

    ld val = distSegm(A[j], B[j], A[k], B[k]);
//    cout << val << "\n";

    return val <= (B[i] - A[i]).len();
}

int main() {
#ifndef LOCAL
    ios::sync_with_stdio(0);
    cin.tie(0);
#else
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    cin >> n;
    fr (i, 1, n) {
        A[i].scan();
        B[i].scan();
    }
//
//    cout << possible(4, 1, 3) << "\n";
//
//    return 0;

    int ans = 0;
    fr (i, 1, n) {
        fr (j, i + 1, n) {
            fr (k, j + 1, n) {
                if (possible(i, j, k) || possible(j, i, k) || possible(k, i, j)) {
                    ans++;
//                    cout << i << " " << j << " " << k << "\n";
                }
            }
        }
    }

    cout << ans << "\n";


    return 0;
}
