#include <bits/stdc++.h>

#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

#define fi first
#define se second

#define pll pair <ll, ll>
#define pii pair <int, int>

#define sqr(x) (x) * (x)
#define pw(x) (1LL << x)

#define all(s) s.begin(), s.end()

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef long double ld;

const ll inf = 1e18;
const ll mxN = 2e5 + 3;
const ld pi = acos(-1);

ll binpow (ll a, ll b) {
    ll res = 1;

    while (b) {

        if (b & 1)
            res *= a;

        a *= a;
        b >>= 1;
    }

    return res;
}

void solve() {

    ll S;

    cin >> S;

    ll d[19], pref_d[19];

    for (int i = 1; i <= 18; i += 1) {
        d[i] = ((binpow (10, i) - 1) - (binpow (10, i - 1) - 1));
    }
    d[1] = 10;

    ll l, r, answer = 0;

    l = 0;
    r = 1000000000000000000;

    while (l < r) {

        ll mid = (l + r) / 2;
        ll mid_1 = 0;
        ll pos = 1, sum = 0;

        for (int i = 1; i <= 18; i += 1) {
            if (sum + d[i] * i > mid) {
                pos = i;
                break;
            }
            sum += d[i];
        }

        answer = sum;
        answer += (mid - sum) * pos;

//        cout << mid << " - " << answer << " " << S << " - " << l << " " << r << endl;

        if (answer > S) {
            r = mid;
        } else {
            l = mid + 1;
        }
    }

    pll Answer = make_pair (0LL, l - 1);

    if (answer == S) {
        cout << answer << endl;
        cout << 0 << " " << l - 1 << endl;
    } else {
        ll x = answer - S;


        while (l < r) {

            ll mid = (l + r) / 2;
            ll mid_1 = 0;
            ll pos = 1, sum = 0;

            for (int i = 1; i <= 18; i += 1) {
                if (sum + d[i] * i > mid) {
                    pos = i;
                    break;
                }
                sum += d[i];
            }

            answer = sum;
            answer += (mid - sum) * pos;

//        cout << mid << " - " << answer << " " << S << " - " << l << " " << r << endl;

            if (answer > x) {
                r = mid;
            } else {
                l = mid + 1;
            }
        }
        cout << S << endl;
        cout << l - Answer.second << " " << Answer.second << endl;
    }


}

int main() {

#ifdef local
    freopen ("input.txt", "r", stdin);
    freopen ("output.txt", "w", stdout);
#endif // local

    solve();


    return 0;
}
