


#include <bits/stdc++.h>

using namespace std;

#define int long long

const int Inf = 0x4f4f4f4f;
const long long inf = 1144000000000000000;
const int dx[] = {-1, 0, 1, 0};
const int dy[] = {0, -1, 0, 1};

int tr[400005];

void build(int v, int l, int r, vector<int>& a) {
    if (l == r) {
        tr[v] = a[l];
        return;
    }
    build(v * 2 + 1, l, (l + r) / 2, a);
    build(v * 2 + 2, (l + r) / 2 + 1, r, a);
    tr[v] = min(tr[v * 2 + 1], tr[v * 2 + 2]);
}

int get(int v, int l, int r, int ql, int qr) {
    if (l >= ql && r <= qr) {
        return tr[v];
    }
    if (l > qr || r < ql) {
        return inf;
    }
    return min(get(v * 2 + 1, l, (l + r) / 2, ql, qr), get(v * 2 + 2, (l + r) / 2 + 1, r, ql, qr));
}
void solve() {
    int n;
    cin >> n;
    vector<int> a(n), b(1,0);
    int total = 0;
    for (auto& e : a)
        cin >> e, b.push_back(e + b.back()), total += e;
    a.push_back(inf);
    b.push_back(inf);\
    total = (total + 1) / 2;
    build(0, 0, n - 1, a);
    int ans = inf;
    for (int i = 0; i < n; ++i) {
        int l = i, r = n;
        while (r - l > 1) {
            int m = (l + r) / 2;
            int z = b[m + 1] - b[i] - get(0, 0, n - 1, i, m);
            if (z >= total)
                r = m;
            else
                l = m;
        }
        if(r==n)r=inf;
        //cout << "I=" << i << ' ' << r << '\n';
        int tasks = r - i;
        l = i - 1, r = n;
        while (r - l > 1) {
            int m = (l + r) / 2;
            int z = b[m + 1] - b[i];
            if (z >= total) r = m;
            else l = m;
        }
        if(r==n)r=inf;

        tasks = min(tasks, r - i + 1);
        //cout << "I=" << i << ' ' << r << '\n';
        ans = min(ans, tasks);
        //cout << "ans=" << ans << '\n';
    }
    cout << ans;
}

signed main() {
    cin.tie(0);
    ios_base::sync_with_stdio(0);

    int Tc = 1;
    // cin >> Tc;
    while(Tc--)
        solve(), cout << '\n';
}

/*

#include <bits/stdc++.h>

using namespace std;

const int Inf = 0x4f4f4f4f;
const long long inf = 1144000000000000000;
const int dx[] = {-1, 0, 1, 0};
const int dy[] = {0, -1, 0, 1};


void solve() {

}

signed main() {
    cin.tie(0);
    ios_base::sync_with_stdio(0);

    int Tc = 1;
    // cin >> Tc;
    while(Tc--)
        solve(), cout << '\n';
}

6 3
1 2
L
2
LL
1 0
LL
2
LLR
2
LR
2R
R

*/

