#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <unordered_map>
#include <map>
#include <unordered_set>
#include <set>
#include <bitset>
#include <queue>
#include <stack>
#include <iomanip>
#include <fstream>
#include <ctime>
#include <random>
#include <cassert>

#define int long long
#define fi first
#define se second
#define pii pair<int,int>
#define p_b push_back
#define m_p make_pair
#define all(x) x.begin(),x.end()
#define rall(x) x.rbegin(),x.rend()
#define sqr(x) ((x)*(x))
#define pw(x) (1LL << x)
#define sz(x) (int)x.size()

using namespace std;

int c;

struct node
{
    int l;
    int r;
    int pr;
    int col;
    node(): l(-1), r(-1), pr(-1), col(-1) {}
};

vector < node > t(1);

void upd(int x, string path, int pr)
{
    int v = 0;
    for(auto let : path)
    {
        if(let == 'L')
        {
            if(t[v].l == -1)
            {
                t[v].l = sz(t);
                t.p_b(node());
            }
            v = t[v].l;
        }
        else
        {
            if(t[v].r == -1)
            {
                t[v].r = sz(t);
                t.p_b(node());
            }
            v = t[v].r;
        }
    }
    t[v].pr = pr;
    t[v].col = x;
}

int get(string path)
{
    int v = 0;
    int pr = -1, col = -1;
    for(auto let : path)
    {
        if(let == 'L')
        {
            if(t[v].l == -1)
            {
                t[v].l = sz(t);
                t.p_b(node());
            }
            if(pr != -1)
                col = (col + 1) % c;
            v = t[v].l;
        }
        else
        {
            if(t[v].r == -1)
            {
                t[v].r = sz(t);
                t.p_b(node());
            }
            if(pr != -1)
                col = (col + c - 1) % c;
            v = t[v].r;
        }
        if(t[v].pr != -1 && (pr == -1 || t[v].pr < pr))
        {
            pr = t[v].pr;
            col = t[v].col;
        }
    }
    return col;
}

main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int q;
    cin >> q >> c;
    while(q--)
    {
        int type;
        cin >> type;
        if(type == 1)
        {
            int x;
            string path;
            cin >> x >> path;
            upd(x, path, q);
        }
        else
        {
            string path;
            cin >> path;
            cout << get(path) << '\n';
        }
    }
    return 0;
}
