#include <iostream>
#include <algorithm>
#include <cmath>
#include <cstring>
#include <cstdlib>
#include <iomanip>
#include <stack>
#include <queue>
#include <set>
#include <map>
#include <unordered_map>
#include <fstream>

using namespace std;

#define int unsigned long long
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define sz(x) (int)x.size()

const int inf = 1e18;
const int mod = 1e9 + 7;


int fastPow(int a, int b){
    if (b == 0)
        return 1;
    int x = fastPow(a, b / 2);
    if (b % 2 == 0)
        return x * x;
    return x * x * a;
}

int check(int l, int r){
    int ans = 0;
    for(int len = 1; len <= 18; len ++){
        int left = fastPow(10, len - 1);
        int right = fastPow(10, len) - 1;
        if (len == 1)
            left = 0;

        int here = max(min(right, r) - max(left, l) + 1, (unsigned long long)0);
        if (min(right, r) < max(left, l))
            here = 0;
        ans += here * len;
    }

    return ans;
}

int myMinus(int a, int b){
    if (a > b)
        return a - b;
    return 0;
}

main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int N;
    cin >> N;
//N = 1000000000000000000;
//for(N = 1000000000000000000 - 20; N <= 1000000000000000000; N ++){
    int n = N;
    if (n <= 10)
        return cout << n << '\n' << 0 << ' ' << n - 1, 0;

    n -= 10;

    int len = 2;
    int now = 90;
    while(n > now * len){
        n -= now * len;
        now *= 10;
        len ++;
    }

    int k = n / len;
    int rest = (n % len);
    int l = 0, r = fastPow(10, len - 1) + k - 1;

    if (rest > 0){
        r ++;
        l += (len - rest);
    }

    bool was = false;
    if (check(l, r) == N)
        was = true;
    for(int left = max(myMinus(l, 500), (unsigned long long)0); left <= min(l + 500, (unsigned long long)(1e18)); left ++){
        for(int right = max(myMinus(r, 500), (unsigned long long)0); right <= min(r + 500, (unsigned long long)1e18); right ++){
            int ans = check(left, right);
            if (ans == N){
                if (!was || (r - l + 1) < (right - left + 1)){
                    l = left; r = right;
                }
                was = true;
//                break;
            }
        }
//        if (was)
//            break;
    }

    int ans = check(l, r);
    if (ans != N)
        return cout << -1, 0;
    cout << (r - l) + 1 << endl;
    cout << l << ' ' << r << endl;
//    cout << ans;
//    cout << "HUSDUFISDOFIJO: " << ans;
//    if (ans != N){
//        cout << "HALT:" << N << ' ' << ans << " | " << l << ' ' << r << endl;
//    } else
//        cout << "GOOD: " << N << endl;
//    }
}

/*
1000000000000000000
100000000000000004
100000000000000003
1000000000008
*/
