#include <bits/stdc++.h>
   
using namespace std;

#define int long long
#define ff first
#define ss second
#define pb push_back
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

const int N = 200001;

int t[N * 4], n, tmin[4 * N];

void update(int i, int x, int tl = 1, int tr = n, int idx = 1) {
	if(tr <= tl) {
		t[idx] = x;
	} else {
		int tm = (tl + tr) / 2;
		if(i <= tm) {
			update(i, x, tl, tm, idx << 1);
		} else {
			update(i, x, tm + 1, tr, idx << 1 | 1);
		}
		t[idx] = t[idx << 1] + t[idx << 1 | 1];
	}
}

int sum(int l, int r, int tl = 1, int tr = n, int idx = 1) {
	if(tl > r || tr < l)
		return 0;
	if(tr <= r && tl >= l) {
		return t[idx];
	}
	int tm = (tl + tr) / 2;
	return sum(l, r, tl, tm, idx << 1) + sum(l, r, tm + 1, tr, idx << 1 | 1);
}

void update2(int i, int x, int tl = 1, int tr = n, int idx = 1) {
	if(tr <= tl) {
		tmin[idx] = x;
	} else {
		int tm = (tl + tr) / 2;
		if(i <= tm) {
			update2(i, x, tl, tm, idx << 1);
		} else {
			update2(i, x, tm + 1, tr, idx << 1 | 1);
		}
		tmin[idx] = min(tmin[idx << 1], tmin[idx << 1 | 1]);
	}
}

int getmin(int l, int r, int tl = 1, int tr = n, int idx = 1) {
	if(tl > r || tr < l) {
		return 1e9;
	}
	if(tr <= r && tl >= l) {
		return tmin[idx];
	}
	int tm = (tl + tr) / 2;
	return min(getmin(l, r, tl, tm, idx << 1), getmin(l, r, tm + 1, tr, idx << 1 | 1));
}

signed main(){
    ios::sync_with_stdio(0); cin.tie(0);
    int ans = 1e9;
    cin >> n;
    vector<int> a(N);
    for(int i = 1; i <= n; i++) {
    	cin >> a[i];
    	update(i, a[i]);
    	update2(i, a[i]);
    }
    for(int i = n; i >= 1; i--) {
    	if(sum(i, n) - getmin(i, n) >= sum(1, n) / 2) {
    		cout << i - 1;
    		return 0;
    	}
    }
    return 0;
}