#include <bits/stdc++.h>

typedef long long ll;
using namespace std;

const int A = 23, B = 1e9 + 7;

ll binpow(ll n, ll k){
    if (k == 0) return 1;
    ll x = binpow(n, k / 2);
    x = x * x % B;
    if (k % 2) x = x * n % B;
    return x;
}

const int N = 1e6 + 3e2;
int L[N], R[N];

void solve(){
    int q, c;
    cin >> q >> c;

    map<ll, pair<int, int>> mp;

    ll inv = binpow(A, B - 2);

    for (int tt = 1; tt <= q; tt++){
        int t;
        cin >> t;
        if (t == 1){
            int x; string s;
            cin >> x >> s;

            ll h = 0;
            for (char c : s){
                h = (h * A + c) % B;
            }

            for (char c : s){
                L[tt] += (c == 'L');
                R[tt] += (c == 'R');
            }

            mp[h] = make_pair(tt, x);

           // cout << "\t" << h << endl;

        } else {
            string s;
            cin >> s;

            ll h = 0;
            for (char c : s) h = (h * A + c) % B;

            //cout << "\t" << h << endl;

            int curl = 0, curr = 0;
            for (char c : s){
                curl += (c == 'L');
                curr += (c == 'R');
            }

            int last = -1;
            int par = -1, col = -1;
            for (int i = (int)s.size() - 1; i >= 0; i--){
                h -= s[i];
                if (h < 0) h += B;
                h = h * inv % B;

                h = (h % B + B) % B;

                if (mp.find(h) != mp.end()){
                    if (mp[h].first > last){
                        last = mp[h].first;
                        col = mp[h].second;
                        par = h;
                    }
                }

            }

            if (last == -1){
                cout << -1 << endl;
            } else {
                int diff = (curl - L[last]) - (curr - R[last]);
                cout << ((col + diff) % c + c) % c << endl;
            }

        }
    }

}

int main(){
    //freopen("input.txt", "r", stdin);
    int tc = 1;
    //cin >> tc;

    while (tc--) solve();

    return 0;
}
