﻿//#pragma clang diagnostic push
//#pragma ide diagnostic ignored "modernize-use-emplace"

#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef vector<int> vi;
typedef vector<vector<int>> vvi;
typedef pair<int, int> pi;
typedef long double ld;
int inf = 1e9 + 7;

struct seg_tree {
    int sz;
    vi a, tree;

    void build(int v, int tl, int tr) {
        if (tr - tl == 1) tree[v] = a[tl];
        else {
            int tm = (tl + tr) / 2;

            build(2 * v + 0, tl, tm);
            build(2 * v + 1, tm, tr);

            tree[v] = min(tree[2 * v], tree[2 * v + 1]);
        }
    }

    seg_tree(vi &s) {
        a = s;
        sz = a.size();
        tree.resize(4 * sz);
        build(1, 0, sz);
    }

    int get_min(int v, int tl, int tr, int l, int r) {
        if (l <= tl && r >= tr) return tree[v];
        if (l >= tr || r <= tl) return inf;

        int tm = (tl + tr) / 2;

        int m1 = get_min(2 * v + 0, tl, tm, l, r);
        int m2 = get_min(2 * v + 1, tm, tr, l, r);

        return min(m1, m2);
    }

    int get_min(int l, int r) {
        return get_min(1, 0, sz, l, r);
    }

};

//int sum(ll a, ll b) {
//    if (b == 0) {
//        return a;
//    }
//    if (b < 0) {
//        return sum(a - 1, b + 1);
//    } else {
//        return sum(a + 1, b - 1);
//    }
//}
//
//ll findpow(ll n) {
//    int l = 0, r = 63;
//    while (r - l > 1) {
//        int m = (l + r) / 2;
//        if ((ll) (1ll << m) > n) {
//            r = m;
//        } else {
//            l = m;
//        }
//    }
//    return (ll) (1ll << r);
//}
//
//int getans(ll n) {
//    int ans = 0;
//    while (n) {
//        ans += n % 2;
//        n /= 2;
//    }
//    return ans;
//}

signed main() {
//    ifstream cin("C:\\Users\\nasvv\\CLionProjects\\ternarniy\\aboba.in");
//    ofstream cout("C:\\Users\\nasvv\\CLionProjects\\ternarniy\\aboba.out");
    int n;
    cin >> n;
    vector<string> s(n);
    for (string &i : s) cin >> i;
    sort(s.begin(), s.end());
    int ans = 2e9;
    for (int i = 0; i < n; ++ ++i) {
        int c = 0;
        while (c < s[0].size() && s[i][c] == s[i + 1][c]) c++;
        ans = min(ans, c);
    }
    cout << ans;
}


//#pragma clang diagnostic pop