#pragma optimize ("g",on)
#pragma GCC optimize ("inline")
#pragma GCC optimize ("unroll-loops")
#pragma GCC optimize ("03")
#pragma GCC optimize ("Ofast")
#include <bits/stdc++.h>
using namespace std;
#define ll long long
#define pb push_back
#define F first
#define S second
#define all(v) v.begin(), v.end()
#define sz(v) int(v.size())
const int N=1e5+7;

struct stree {
    vector<int> tr;
    int rz=1;
    void init(int n) {
        rz=1;
        while(rz<n)rz*=2;
        tr.assign(2*rz+1, 0);
    }
    void build(vector<int> &a, int v, int lx, int rx) {
        if (rx-lx==1) {
            if (lx<=sz(a)) {
                tr[v]=a[lx];
            }
        }else {
            int m=(lx+rx)>>1;
            build(a, (v<<1), lx, m);
            build(a, (v<<1)+1, m, rx);;
            tr[v]=min(tr[(v<<1)], tr[(v<<1)+1]);
        }
    }
    void build(vector<int> &a) {
        build(a, 1, 1, rz+1);
    }
    int minn(int l, int r, int v, int lx, int rx) {
        if (r<=lx || rx<=l) {
            return INT_MAX;
        }if (l<=lx && rx<=r) {
            return tr[v];
        }
        int m=(lx+rx)>>1;
        int s=minn(l, r, (v<<1), lx, m);
        int s1=minn(l, r, (v<<1)+1, m, rx);
        return min(s, s1);
    }
    int miN(int l, int r) {
        return minn(l, r, 1, 1, rz+1);
    }
};
ll dp[N];
signed main () {
    ios_base::sync_with_stdio(NULL);
    cin.tie(NULL);
    int n;
    cin>>n;
    stree tr;
    vector<int> v(n+1);
    tr.init(n);
    for(int i=1; i<=n; i++)cin>>v[i];
    for(int i=1; i<=n; i++) {
        dp[i]=dp[i-1]+v[i];
    }
    tr.build(v);
    for(int j=(n+1)/2; j>=2; j--) {
        bool ok=0;  
        for(int i=j; i<=n; i++) {
            int r=i, l=i-j;
            ll s=dp[r]-dp[l];
            int mi=tr.miN(l+1, r);
            if(s-mi>=(dp[n]+1)/2) {
                ok=1;
                break;
            }
        }
        if(!ok) {
            cout << j << '\n';
            return 0;
        }
    }
    cout << 1 << '\n';
}