#include<bits/stdc++.h>

using namespace std;

long long q, C;

struct node {
    node *left, *right;
    int cl;
    int ti;
    node() {
        left = nullptr; 
        right = nullptr;
        ti = 0;
        cl = -1;
    }
};

node trie;
void update(string &s, int x, int tm) {
    node *v = &trie;
    for(int i = 0; i < (int)s.size(); i++) {
        if(s[i] == 'L') {
            if(!v->left) v->left = new node();
            v = v->left;
        } 
        else {
            if(!v->right) v->right = new node();
            v = v->right;
        }
    } 
    v->ti = tm;
    v->cl = x;
}
int get(string &s) {
    node *v = &trie;
    long long cl = -1, tm = 0;
    for(int i = 0; i < (int)s.size(); i++) {
        if(s[i] == 'L') {
            if(!v->left) {
                v->left = new node();
            }
            v = v->left;
            if(cl != -1) cl = (cl + 1) % C;
        } else {
            if(!v->right) {
                v->right = new node();
            }
            v = v->right;
            if(cl != -1) cl = (cl - 1 + C) % C;
        }
        if(v->ti > tm) {
            tm = v->ti;
            cl = v->cl;
        } else {
            v->ti = tm;
            v->cl = cl;
        }
    }
    return v->cl;
}
int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);cout.tie(0);

    cin >> q >> C;    
    for(int i = 1; i <= q; i++) {
        int tp;
        cin >> tp;
        if(tp == 1) {
            int x; string u;
            cin >> x >> u;
            update(u, x, i);
        } else {
            string u;
            cin >> u;
            cout << get(u) << '\n';
        }
    }   
}