#include <bits/stdc++.h>
using namespace std;

typedef long long int ll;

const ll N = 1e6 + 5, LOG = 20, INF = 1e9+10, SQ = 375, base = 100, MOD = 1e9+7;
struct node
{
    int l, r;
    ll val = INF;

     int size(){
         return r-l;
     }

     bool leaf(){
         if(size() == 1)return true;
         return false;
     }

    int unity(int lq, int rq){
        return max(0, min(rq, r) - max(lq, l));
     }
};
node seg[N];
ll a[N];

void build(int u, int l, int r){
    seg[u].l = l; seg[u].r = r;
    if(seg[u].leaf()){
        seg[u].val = a[l];
        return ;
    }
    int mid = (r+l)/2;
    build(2 * u, l, mid);
    build(2 * u + 1, mid, r);
    seg[u].val = min(seg[2*u].val , seg[2*u+1].val);
}

ll get(int u, int l, int r){
    if(!seg[u].unity(l,r))
        return INF;
    if(seg[u].unity(l,r) == seg[u].size())
        return seg[u].val;
    return min(get(2*u,l,r) , get(2*u+1,l,r));
}

void change(int u, int id, int cv){
    if(!seg[u].unity(id, id+1))
        return ;
    if(seg[u].leaf()){
        seg[u].val = cv;
        return ;
    }
    change(2*u, id, cv);
    change(2*u+1, id, cv);
    seg[u].val = min(seg[2*u].val,seg[2*u+1].val);
}

long long int ps[N];

int main(){
    int n;
    cin >> n;

    for(int i = 0; i < n; i ++)cin >> a[i];
    build(1, 0, n);
    ps[0] = 0;
    for(int i = 1; i <= n; i ++){ps[i] = ps[i-1]+a[i-1];}

    long long int s = ps[n]/2;
    int ans = n, tp;
    for(int i = 1; i <= n; i ++){
        if(ps[i] < s)continue;
        int j = upper_bound(ps, ps+n+1, ps[i]-s)-ps;
        tp = i-j+1;
        if(ps[i]-ps[j-1]-get(1, j-1, i) >= s)tp--;
        ans = min(ans, tp);
    }
    ans = max(1, ans);
    cout << ans << '\n';
    return 0;
}
