#include <iostream>
#include <cmath>
using namespace std;

long long getPow(long long x) {
    long long cnt=1;
    while (x > 1) {
        x /= 2;
        cnt++;
    }
    return cnt;
}

long long rec(long long x) {
    if (x == 0) return 0;
    if (x == 1) return 1;
    if (x == 2) return 1;
    long long cnt = getPow(x);
    // cout << x << " " << pow(2, cnt) << " ! " << pow(2, cnt-1) << endl;
    return 1 + rec(min(pow(2, cnt) - x, x - pow(2, cnt-1)));
}



int main()
{
    long long n, now;
    cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> now;
        if (now < 0) now *= -1;
        cout << rec(now) << endl;
    }
}
