#include <iostream>
#include <cmath>
using namespace std;

long long getmyPow(long long x) {
    long long cnt=1;
    while (x > 1) {
        x /= 2;
        cnt++;
    }
    return cnt;
}
long long myPow(long long a, long long n) {
    if (n == 0) return 1;
    if (n == 1) return a;
    if (n % 2 == 0) {
        long long x = myPow(a, n/2);
        return x*x;
    } else {
        long long x = myPow(a, (n-1)/2);
        return x*x*a;
    }
}

long long rec(long long x) {
    if (x == 0) return 0;
    if (x == 1) return 1;
    if (x == 2) return 1;
    long long cnt = getmyPow(x);
    //cout << x << " " << myPow(2, cnt) << " ! " << myPow(2, cnt-1) << " @ " << min(myPow(2, cnt) - x, x - myPow(2, cnt-1)) << endl;
    return 1 + rec(min(myPow(2, cnt) - x, x - myPow(2, cnt-1)));
}



int main()
{
    long long n, now;
    cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> now;
        if (now < 0) now *= -1;
        cout << rec(now) << endl;
    }
}
