#include <bits/stdc++.h>

using namespace std;

#define ff first
#define ss second
#define vt vector
#define pb push_back
#define ppb pop_back
#define all(a) a.begin(), a.end()
#define tostr(x) to_string(x)
#define tonum(s) atoi(s.c_str())
#define ent "\n"
#define sp ' '

using ll = long long;
using db = double;
using ldb = long double;
using pll = pair <ll, ll>;
using pii = pair <int, int>;

const ll INF = 8e18;
const ll inf = 1e9 + 7;
const int MOD = 998244353;
const int N = 2e5 + 7;
const ldb eps = 1e-7;

/*-------------------------main-------------------------*/

ll a[N], t[N * 4], mn[N * 4];

void build(int v, int tl, int tr){
    if (tl == tr){
        t[v] = mn[v] = a[tl];
        return;
    }
    int tm = (tl + tr) >> 1;
    build(v + v, tl, tm);
    build(v + v + 1, tm + 1, tr);
    t[v] = t[v + v] + t[v + v + 1];
    mn[v] = min(mn[v + v], mn[v + v + 1]);
}

ll get_sum(int v, int tl, int tr, int l, int r){
    if (tl > r || l > tr || l > r) return 0;
    if (l <= tl && tr <= r) return t[v];
    int tm = (tl + tr) >> 1;
    return get_sum(v + v, tl, tm, l, r) + get_sum(v + v + 1, tm + 1, tr, l, r);
}

ll get_min(int v, int tl, int tr, int l, int r){
    if (tl > r || l > tr || l > r) return inf;
    if (l <= tl && tr <= r) return mn[v];
    int tm = (tl + tr) >> 1;
    return min(get_min(v + v, tl, tm, l, r), get_min(v + v + 1, tm + 1, tr, l, r));
}

void solve() {
    #define test
    int n;
    cin >> n;
    ll sum = 0;
    for (int i = 1; i <= n; i++){
        cin >> a[i];
        sum += a[i];
    }
    sum /= 2;
    build(1, 1, n);
    int ans = n + 1;
    for (int i = 1; i <= n; i++){
        int l = i, r = n, res = n + 1;
        while (l <= r){
            int mid = (l + r) >> 1;
            if (get_sum(1, 1, n, i, mid) >= sum) r = mid - 1;
            else l = mid + 1;
        }
        r++;
        if (r > n) break;
        res = r - i + 1;
        l = i, r = n;
        while (l <= r){
            int mid = (l + r) >> 1;
            if (get_sum(1, 1, n, i, mid) - get_min(1, 1, n, i, mid) >= sum) r = mid - 1;
            else l = mid + 1;
        }
        r++;
        if (r <= n){
            res = r - i;
        }
        ans = min(ans, res);
    }
    cout << ans;
}

signed main() {
    //freopen("", "r", stdin);
    //freopen("", "w", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int testcases;
    #ifdef tests
        cin >> testcases;
    #endif
    #ifdef test
        testcases = 1;
    #endif
    while (testcases--) {
        solve();
    }
    return 0;
}
