#include<iostream>
#include<string>
#include<vector>
#define ll long long
using namespace std;

struct Node {
    int l, r, color;
    Node() {
        l = -1;
        r = -1;
        color = -1;
    }
};

vector<Node> arr;
int c;

void set(string& str, int x, int i = 0, int t = 0) {
    if (i == str.size()) {
        arr[t].color = x;
        if (arr[t].l != -1) {
            arr[arr[t].l].color = (x + 1) % c;
        }
        else {
            arr[t].l = arr.size();
            arr.emplace_back();
            arr[arr[t].l].color = (x + 1) % c;
        }
        if (arr[t].r != -1) {
            arr[arr[t].r].color = (x + c - 1) % c;
        }
        else {
            arr[t].r = arr.size();
            arr.emplace_back();
            arr[arr[t].r].color = (x + c - 1) % c;
        }
        return;
    }
    if (str[i] == 'L') {
        if (arr[t].l != -1) {
            set(str, x, i + 1, arr[t].l);
        }
        else {
            arr[t].l = arr.size();
            arr.emplace_back();
            set(str, x, i + 1, arr[t].l);
        }
    }
    else {
        if (arr[t].r != -1) {
            set(str, x, i + 1, arr[t].r);
        }
        else {
            arr[t].r = arr.size();
            arr.emplace_back();
            set(str, x, i + 1, arr[t].r);
        }
    }
}

int find(string& str, int i = 0, int t = 0) {
    if (i == str.size()) {
        return arr[t].color;
    }
    if (str[i] == 'L') {
        if (arr[t].l != -1) {
            return find(str, i + 1, arr[t].l);
        }
        else {
            return -1;
        }
    }
    else {
        if (arr[t].r != -1) {
            return find(str, i + 1, arr[t].r);
        }
        else {
            return -1;
        }
    }
}

void solve() {
    int q;
    cin >> q >> c;
    arr.emplace_back();
    for (int i = 0; i < q; ++i) {
        int t;
        string str;
        cin >> t;
        if (t == 1) {
            int x;
            cin >> x;
            cin >> str;
            set(str, x);
        }
        else {
            cin >> str;
            cout << find(str) << endl;
        }
    }
}

//long long colz(long long a) {
//    long long sol = 0, ag = 1;
//    while (ag <= a) {
//        ag *= 10;
//        ++sol;
//    }
//    return sol;
//}
//
//long long can(long long l, long long r) {
//    long long lg = 1, rg = 1;
//    while (l > lg) lg *= 10;
//    while (r > rg * 10) rg *= 10;
//    long long czl = colz(l);
//    long long czlg = colz(lg);
//    long long czrg = colz(rg);
//    long long czr = colz(r);
//    long long sum = czl * (lg - l);
//    long long li = lg;
//    for (int i = czlg; i <= czrg; ++i) {
//        sum += 9 * li * i;
//        li *= 10;
//    }
//    sum += czr * (r - rg);
//    return sum;
//}
//
//void solve2() {
//    long long s = 0;
//    //cin >> s;
//    long long l = 0, r = 1e16;
//    can(0, 2);
//    for(int i = 0; i < 113; ++i){
//        if (can(l, r) == s) break;
//        if (can(l, r) > s)
//            r = (l + r) / 2;
//        else
//            l = (l + r) / 2;
//    }
//    if (can(l, r) == s) 
//        cout << r - l << "\n" << l << " " << r;
//    else
//        cout << "-1\n";
//}

signed main() {
    //freopen("vikings.in", "rt", stdin);
    //freopen("vikings.out", "wt", stdout);
    ios_base::sync_with_stdio(false);
    //srand((unsigned int)time(nullptr));
    cout.setf(ios::fixed);
    cout.precision(9);
    cout.tie(nullptr);
    cin.tie(nullptr);

    int T = 1;
    //cin >> T;
    while (T--) solve();
    return 0x0;
}