#include<iostream>
#include<string>
#include<vector>
#define ll long long
using namespace std;

struct Node {
    int deep;
    int cl;
    vector<int> pr;
    Node (){
        cl = 0;
        pr.assign(26, -1);
    }
};

vector<Node> arr;


void set(string& str, int i = 0, int x = 0) {
    if (i == str.size()) {
        ++arr[x].cl;
        return;
    }
    if (arr[x].pr[str[i] - 'a'] != -1) {
        ++arr[x].cl;
        set(str, i + 1, arr[x].pr[str[i] - 'a']);
    }
    else {
        arr[x].pr[str[i] - 'a'] = arr.size();
        arr.emplace_back();
        arr[arr[x].pr[str[i] - 'a']].deep = arr[x].deep + 1;
        ++arr[x].cl;
        set(str, i + 1, arr[x].pr[str[i] - 'a']);
    }
}

int get(int t = 0) {
    int sol = 1e9;
    for (int i : arr[t].pr) {
        if(i != -1)
            if (arr[i].cl % 2 != 0) {
                return arr[t].deep;
            }
            else {
                sol = min(sol, get(i));
            }
    }
    return (sol == 1e9 ? arr[t].deep : sol);
}

void solve() {
    int n;
    cin >> n;
    arr.emplace_back();
    arr[0].deep = 0;
    for (int i = 0; i < n; ++i) {
        string str;
        cin >> str;
        set(str);
    }
    
    cout << get();
}

signed main() {
    ////freopen("vikings.in", "rt", stdin);
    ////freopen("vikings.out", "wt", stdout);
    //ios_base::sync_with_stdio(false);
    ////srand((unsigned int)time(nullptr));
    //cout.setf(ios::fixed);
    //cout.precision(9);
    //cout.tie(nullptr);
    //cin.tie(nullptr);

    int T = 1;
    //cin >> T;
    while (T--) solve();
    return 0;
}