import string

def one_apart(words, word):
    res = set()
    for i, _ in enumerate(word):
        for c in string.ascii_lowercase:
            w = word[:i] + c + word[i+1:]
            if w != word and w in words:
                res.add(w)
    return res


pairs = set()
for w in words:
  for other in one_apart(words, w):
    pairs.add(frozenset((w, other)))

for pair in pairs:
  print(pair)


  
