// #pragma GCC optimize ("Ofast")
// #pragma GCC optimize ("unroll-loops")
// #pragma GCC optimize ("03")
// #pragma GCC target ("sse,sse2,sse3,ssse3,sse4,popcnt,abm,avx2,mmx,fma,avx,tune=native")
// #pragma comment(linker, "/stack:200000000")
#include <algorithm>
#include <iostream>
#include <iomanip>
#include <cmath>
#include <queue>
#include <map>
#include <set>

using namespace std;
typedef long long ll;
struct segment{int l, r;
int size(){return r-l+1;}};
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
#define ent "\n"

const int maxn = 5e3 + 100;
const ll INF = (1ll<<61);
const int MOD = 1e9 + 123;
const int inf = (1<<30);
const int maxl = 101;
const int P = 31;

int n;
int dp[maxn][maxn];

void test(){
    cin >> n;
    for(int i = 0; i <= n; i++){
        for(int j=0;j<=n;j++)dp[i][j]=inf;
    }
    dp[0][0]=0;
    for(int i = 1; i <= n; i++){
        for(int j=1;j<=i;j++){
            dp[i][j]=dp[i-j][min(i-j,j-1)]+j*(j-1)/2;
        }
        for(int j=2;j<=i;j++)dp[i][j]=min(dp[i][j-1],dp[i][j]);
    }
    cout << dp[n][n] << ent;
}

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
    int t; t = 1;
    while(t--) test();
}
