// #pragma GCC optimize ("Ofast")
// #pragma GCC optimize ("unroll-loops")
// #pragma GCC optimize ("03")
// #pragma GCC target ("sse,sse2,sse3,ssse3,sse4,popcnt,abm,avx2,mmx,fma,avx,tune=native")
// #pragma comment(linker, "/stack:200000000")
#include <algorithm>
#include <iostream>
#include <iomanip>
#include <cmath>
#include <queue>
#include <map>
#include <set>

using namespace std;
typedef long long ll;
struct segment{int l, r;
int size(){return r-l+1;}};
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
#define ent "\n"

const int maxn = 1e6 + 100;
const ll INF = (1ll<<61);
const int MOD = 1e9 + 123;
const int inf = (1<<30);
const int maxl = 101;
const int P = 31;

int n;
string a[maxn];

bool ok(int x){
    map<int, int> cnt;
    for(int i = 1; i <= n; i++){
        ll h = 0;
        for(int j = 1; j <= x; j++){
            h = (h * P % MOD + a[i][j-1] - 'a' + 1) % MOD;
        }
        cnt[h]++;
    }
    for(auto x: cnt){
        if(x.second & 1) return 0;
    }
    return 1;
}

void test(){
    cin >> n;
    for(int i = 1; i <= n; i++){
        cin >> a[i];
    }
    int ans = 0;
    for(int l = 1, r = a[1].size(); l <= r;){
        int mid = (l + r) >> 1; 
        if(!ok(mid)) r = mid - 1;
        else l = mid + 1, ans = mid;
    }
    cout << ans;
}

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
    int t; t = 1;
    while(t--) test();
}
