#include <iostream>
#include <vector>
#include <algorithm>
#include <string>

using namespace std;
using ll=long long;

struct Edge{
    int L;
    int R;
    int X;
};
int timer=1;
vector<Edge> tree((int)1e7);
int c;
void push(int u){
    if (tree[u].L==-1){
        tree[u].L=timer++;
        tree[u].R=timer++;
        tree[tree[u].L].L=-1;
        tree[tree[u].L].R=-1;
        tree[tree[u].R].L=-1;
        tree[tree[u].R].R=-1;
        tree[tree[u].L].X=-1;
        tree[tree[u].R].X=-1;
    }
    if (tree[u].X!=-1){
        tree[tree[u].L].X=(tree[u].X+1)%c;
        tree[tree[u].R].X=(tree[u].X+c-1)%c;
    }
}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int q,t,x, u;
    string s;
    cin>>q>>c;
    tree[0]={-1,-1,-1};
    for (int i=0; i<q; i++) {
        cin>>t;
        if (t==1){
            cin>>x>>s;
            u=0;
            for (char b:s){
                push(u);
                if (b=='L'){
                    u=tree[u].L;
                }
                else{
                    u=tree[u].R;
                }
            }
            tree[u].X=x;
            
        }
        else{
            cin>>s;
            u=0;
            for (char b:s){
                push(u);
                if (b=='L'){
                    u=tree[u].L;
                }
                else{
                    u=tree[u].R;
                }
            }
            cout<<tree[u].X<<endl;
        }
    }
    return 0;
}