#ifdef LOCAL
    #define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

#define pll pair<ll, ll>
#define pii pair<int, int>
#define pdd pair<ld, ld>
#define ff first
#define ss second
#define all(v) v.begin(),v.end()

typedef tree<
    pii,
    null_type,
    less<pii>,
    rb_tree_tag,
    tree_order_statistics_node_update> ordset;

#pragma GCC optimize("-O3")
#pragma GCC optimize("unroll-loops")

ll INF = 2e18;
const ll mod = 1000000007;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

ll binpow(ll n, ll m){
    if(m == 0) return 1ll;
    if(m & 1ll) return (n * binpow(n, m - 1ll)) % mod;
    ll b = binpow(n, m / 2ll);
    return (b*b) % mod;
}

struct str{
    ll l = -1, r = -1;
    ll c = -1;
    ll push = -1;
};

void solve(){
    int q, c;
    cin >> q >> c;
    vector<str> a(2000000);
    string s;
    int cnt = 1;
    for(int i = 0; i < q; i++){
        int t, x;
        cin >> t;
        if(t == 1){
            cin >> x;
            cin >> s;
            int cur = 0;
            for(char cc : s){
                if(a[cur].l == -1) a[cur].l = cnt++;
                if(a[cur].r == -1) a[cur].r = cnt++;
                if(a[cur].push != -1){
                    int left = a[cur].l, right = a[cur].r;
                    a[left].c = (a[cur].push + 1) % c;
                    a[right].c = (a[cur].push - 1 + c) % c;
                    a[left].push = a[left].c;
                    a[right].push = a[right].c;
                    a[cur].push = -1;
                }
                if(cc == 'L'){
                    cur = a[cur].l;
                } else{
                    cur = a[cur].r;
                }
            }
            a[cur].c = x;
            a[cur].push = x;
            //cout << cur << ' ' << x << '\n';
        } else {
            cin >> s;
            int cur = 0;
            for(char cc : s){
                if(a[cur].l == -1) a[cur].l = cnt++;
                if(a[cur].r == -1) a[cur].r = cnt++;
                //cout << cur << ' ' << a[cur].c << '\n';
                if(a[cur].push != -1){
                    int left = a[cur].l, right = a[cur].r;
                    a[left].c = (a[cur].push + 1) % c;
                    a[right].c = (a[cur].push - 1 + c) % c;
                    //cout << a[left].c << ' '<< a[right].c << '\n';
                    a[left].push = a[left].c;
                    a[right].push = a[right].c;
                    a[cur].push = -1;
                }
                if(cc == 'L'){
                    cur = a[cur].l;
                } else{
                    cur = a[cur].r;
                }
            }
            cout << a[cur].c << '\n';
        }
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        //freopen("output.txt", "w", stdout);
    #endif
	int tt;
    //cin >> tt;
    tt = 1;
	while (tt--) {
		solve();
		#ifdef LOCAL
            cout << "__________________________________" << endl;
		#endif
	}
	#ifdef LOCAL
        cout << "finished in " << clock() * 1.0 / CLOCKS_PER_SEC << "sec" << '\n';
	#endif
	return 0;
}




