#ifdef LOCAL
    #define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

#define pll pair<ll, ll>
#define pii pair<int, int>
#define pdd pair<ld, ld>
#define ff first
#define ss second
#define all(v) v.begin(),v.end()

typedef tree<
    pii,
    null_type,
    less<pii>,
    rb_tree_tag,
    tree_order_statistics_node_update> ordset;

#pragma GCC optimize("-O3")
#pragma GCC optimize("unroll-loops")

ll INF = 2e18;
const ll mod = 1000000007;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

ll binpow(ll n, ll m){
    if(m == 0) return 1ll;
    if(m & 1ll) return (n * binpow(n, m - 1ll)) % mod;
    ll b = binpow(n, m / 2ll);
    return (b*b) % mod;
}

void solve(){
    int n;
    cin >> n;
    vector<ll> a(n), pref(n);
    for(int i = 0; i < n; i++){
        cin >> a[i];
        pref[i] = (i ? pref[i - 1] : 0) + a[i];
    }
    auto get = [&](int l, int r){
        return (ll)(pref[r] - (l ? pref[l - 1] : 0));
    };
    vector<vector<ll>> sp(n, vector<ll>(21));
    vector<int> logs(n + 1);
    logs[1] = 0;
    for(int i = 2; i <= n; i++) logs[i] = logs[i / 2] + 1;
    for(int i = 0; i < n; i++) sp[i][0] = a[i];
    for(int lev = 1; (1 << lev) <= n; lev++){
        for(int i = 0; i + (1 << lev) <= n; i++){
            sp[i][lev] = min(sp[i][lev - 1], sp[i + (1 << (lev - 1))][lev - 1]);
        }
    }
    ll need = (pref[n - 1] + 1ll) / 2ll;
    ll res = n;
    for(int i = 0; i < n; i++){
        int l = i, r = n - 1;
        ll ans = -1;
        while(l <= r){
            int mid = (l + r) / 2;
            if(get(i, mid) >= need){
                r = mid - 1;
                ans = mid;
            } else l = mid + 1;
        }
        if(ans == -1) continue;
        res = min(res, ans - i + 1);
        int lev = logs[ans - i + 1];
        ll mn = min(sp[i][lev], sp[ans - (1 << lev) + 1][lev]);
        if(need <= get(i, ans) - mn) res = min(res, ans - i);
    }
    cout << res;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        //freopen("output.txt", "w", stdout);
    #endif
	int tt;
    //cin >> tt;
    tt = 1;
	while (tt--) {
		solve();
		#ifdef LOCAL
            cout << "__________________________________" << endl;
		#endif
	}
	#ifdef LOCAL
        cout << "finished in " << clock() * 1.0 / CLOCKS_PER_SEC << "sec" << '\n';
	#endif
	return 0;
}




