#include <bits/stdc++.h>
using namespace std;
#define int long long
#define forn(i,n) for (int i=0; i<n; ++i)
const int inf = 1e18;
#define all(a) a.begin(),a.end()
#define pb(x) push_back(x)
#define f first
#define s second
#define pi pair<int,int>

vector<int> t(4e5+30,inf);
int sz=1;
void build(int i, int l, int r) {
	if (r-l==1) return;
	int m=(l+r>>1);
	build(2*i+1,l,m);
	build(2*i+2,m,r);
	t[i]=min(t[2*i+1],t[2*i+2]);
}

int query(int i, int l, int r, int lx, int rx) {
	if (l>=rx || r<=lx) return inf;
	if (l>=lx && r<=rx) return t[i];
	int m=(l+r)>>1;
	int L=query(2*i+1,l,m,lx,rx);
	int R=query(2*i+2,m,r,lx,rx);
	return min(L,R);
}

int query(int l,int r) {
	return query(0,0,sz,l,r);
}

void solve() {
	
	int n; cin>>n; while (sz<n) sz<<=1;
	vector<int> a(n); forn(i,n) cin>>a[i];
	forn(i,n) t[sz-1+i] = a[i];
	build(0,0,sz);

	int l=0,r=0;
	int ans=inf;
	int need=0;
	forn(i,n) need+=a[i];
	need++; need>>=1; 
	vector<int> pr(n+1,0);
	forn(i,n) pr[i+1]=pr[i]+a[i];

	forn(i,n) {
		int l=i,r=n-1;
		while (l<r) {
			int m=(l+r)>>1;
			if (pr[m+1]-pr[i]>=need) r=m;
			else l=m+1;
		}
		if (pr[r+1]-pr[i]>=need) ans = min (ans,r-i+1);
		l=i, r=n-1;
		while (l<r) {
			int m=(l+r)>>1;
			int x=query(i,m+1);
			int y=pr[m+1]-pr[i];
			if (y-x>=need) r=m;
			else l=m+1;
		}
		int x=query(i,r+1);
		int y=pr[r+1]-pr[i];
		if (y-x<need) continue;
		ans = min (ans,r-i);
	}
	cout<<ans;

} 

int32_t main() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	int t=1; 
	//cin>>t;
	while (t--) solve();
	return 0;
}