#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

ll n, a[111111], need, t[444444];
vector < int > sum;


void build(int v, int tl, int tr) {
	if (tl == tr)
		t[v] = a[tl];
	else {
		int tm = (tl + tr) / 2;
		build(v * 2, tl, tm);
		build(v * 2 + 1, tm + 1, tr);
		t[v] = min(t[v * 2], t[v * 2 + 1]);
	}
}

int get_min(int v, int tl, int tr, int l, int r) {
	if (l > r) return INT_MAX;
	
	if (l == tl && r == tr) return t[v];
	
	int tm = (tl + tr) / 2;
	return min(get_min(v * 2, tl, tm, l, min(r, tm)),
				get_min(v * 2 + 1, tm + 1, tr, max(l, tm + 1), r));
}

int main () {
	
	cin >> n;
	vector < int > sum(n + 1);
	sum[0] = 0;
	for (int i = 1; i <= n; i++) {
		cin >> a[i];
		sum[i] = sum[i - 1] + a[i];
	}
	need = (sum[n] - 1) / 2 + 1;
	build(1, 1, n);
	
	ll ans = n;
	for (int i = 1; i <= n; i++) {
		ll pos = lower_bound(sum.begin() + i, sum.end(), need + sum[i - 1]) - sum.begin();
		if (pos > n) continue;
		if (sum[pos] - sum[i - 1] - get_min(1, 1, n, i, pos) >= need) {
			ans = min(pos - i, ans);
		}
	}
	
	
	cout << ans;
	return 0;
}
