#include <iostream>
#include <string>
#include <map>
#include <vector>
#include <algorithm>
#include <cmath>
using namespace std;

#define ll long long

const int N = 2e5 + 5;
string a[N];

void solve() {
	int n;
	cin >> n;
	for (int i = 1; i <= n; ++i) {
		cin >> a[i];
	}
	int ans = 10000000;
	sort(a + 1, a + n + 1);
	for (int i = 1; i <= n; i += 2) {
		int j = 0;
		while(j < a[i].size() && a[i][j] == a[i + 1][j]) {
			++j;
		}
		ans = min(ans, j);
	}
	cout << ans << "\n";
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);
	int t = 1;
	while (t--) {
		solve();
	}
}