#include <iostream>
#include <algorithm>
#include <cmath>
#include <string>
#include <vector>
#include <map>
#include <set>
#include <iomanip>
#include <queue>
#include <time.h>
#include <bitset>
#include <unordered_map>
 
using namespace std;
 
#define ll long long
#define ull unsigned long long
#define ft first
#define sc second
#define add push_back
#define all(v) v.begin(),v.end()
#define mpr make_pair
#define sz(v) (ll)v.size()
#define vi vector<int>
#define pii pair<int,int>
#define pll pair<ll,ll>
#define FOR(i,a,b) for(ll i = (a); i < (b); i++)
#define FORD(i,a,b) for(ll i = (a); i >= (b); i--)
#define fastio ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
 
const ll MOD = 998244353;
const ll INF = 1e18;
const ll N = 200005;
 
//#define endl '\n'
 
vector<string> v;
unordered_map<string, int> mp;
 
int main()
{
 
    fastio;
 
    ll n;
    cin>>n;
 
    ll MIN = INF;
 
    FOR(i,1,n+1)
    {
        string s;
        cin>>s;
        v.add(s);
    }
 
    sort(all(v));

    ll l = 0, r = sz(v[0]);
    ll ans = 0;

    while(l <= r)
    {
        ll k = (l+r)/2;
        string lst = "";
        ll cntnow = 0;
        bool check = true;

        for(auto f : v)
        {
            string s = f.substr(0,k);
            if(s == lst)
            {
                cntnow++;
            }
            else
            {
                if(cntnow % 2 == 1)
                {
                    check = false;
                    break;
                }
                cntnow = 1;
                lst = s;
            }
        }
        if(check)
        {
            ans = k;
            l = k+1;
        }
        else
        {
            r = k-1;
        }
    }
    cout<<ans<<endl;
 
    return 0;
}