#include "bits/stdc++.h"
#define int long long
#define M7 1'000'000'007LL
#define INF 1e9
#define ALL(x) x.begin(), x.end()
using namespace std;

void solve ();
int32_t main () {
    ios_base::sync_with_stdio(false); cout.tie (0);
#ifdef tulizh
    freopen ("input.txt", "r", stdin);
    freopen ("output.txt", "w", stdout);
#endif
    int t=1; //cin >> t;
    while (t--) solve ();
#ifdef tulizh
    cout << '\n' << clock () / 1000.0 << " s.\n";
#endif
}
const int NMAX = 131072;
int tree[4 * NMAX];

void build(int l, int r, vector<int> &a, int poz = 1){
    if(l == r){
        if(l < a.size()) tree[poz] = a[l];
        else tree[poz] = INF;
        return;
    }
    int m = (l + r) / 2;
    build(l, m, a, 2 * poz);
    build(m + 1, r, a, 2 * poz + 1);
    tree[poz] = min(tree[2 * poz], tree[2 * poz + 1]);
}
int get(int ql, int qr, int l, int r, int poz = 1){
    if(qr < l || ql > r) return INF;
    if(l <= ql && qr <= r) return tree[poz];
    int m = (ql + qr) / 2;
    int left = get(ql, m, l, r, 2 * poz);
    int right = get(m + 1, qr, l, r, 2 * poz + 1);
    return min(right, left);
}

void solve () {


    int n; cin >> n;
    vector<int> a(n); for(auto &i : a) cin >> i;

    build(0, NMAX - 1, a);
    int need = (accumulate(a.begin(), a.end(), 0LL)/2) + (accumulate(a.begin(), a.end(), 0LL) % 2);
    int ans = INF;
    for(int i = 1; i < n; i++) a[i] += a[i - 1];
    for(int i = 0; i < n; i++){
        int look = a[i] + need;
        if(i) look -= a[i - 1];
        auto it = lower_bound(a.begin(), a.end(), look);
        if(it == a.end()) break;
        int r = it - a.begin();
        int have_sum = a[r];
        if(i) have_sum -= a[i - 1];

        if(have_sum == need){
            ans = min(ans, r - i + 1);
            continue;
        }
        int mini = get(0, NMAX - 1, i, r);
        if(have_sum - mini >= need) ans = min(ans, r - i);
    }
    cout << ans;



}
