﻿#include <iostream>
#include <string>
#include <sstream>
#include <cmath>
#include <memory.h>
#include <algorithm>
#include <stack>
#include <deque>
#include <iomanip>
#include <stdio.h>
#include <queue>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <random>
#include <ctime>
#include <cstdlib>
#include <cassert>
#include <chrono>
#include <array>
//#include <bits/stdc++.h>
#define int long long
#define intt __int128
#define F first
#define S second
#define pii pair <int, int>
#define pb push_back
#define all(vc) vc.begin(), vc.end()
#define fir first
#define sec second
#define endl "\n"
#define un unsigned
#define INF 1000000009
#define double long double
using namespace std;

const int N = 1000005, R = 1 << 20,  ABC = 26, logn = 19;

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());
 
struct Hash {
    int x, y;

    Hash(int a, int b) : x(a), y(b) {}
    Hash() : x(0), y(0) {}
};

Hash P = { 31, 37 }, MOD = { (int)(1e9 + 7), (int)(1e9 + 9) };
Hash operator + (Hash a, Hash b) {
    return { (a.x + b.x) % MOD.x, (a.y + b.y) % MOD.y };
}

Hash operator * (Hash a, Hash b) {
    return { (a.x * b.x) % MOD.x, (a.y * b.y) % MOD.y };
}

Hash operator * (Hash a, int b) {
    return { (a.x * b) % MOD.x, (a.y * b) % MOD.y };
}


Hash operator - (Hash a, Hash b) {
    return { (a.x - b.x+MOD.x) % MOD.x, (a.y - b.y + MOD.x) % MOD.y };
}

bool operator == (Hash a, Hash b) {
    return (a.x == b.x && a.y == b.y);
}

bool operator != (Hash a, Hash b) {
    return (a.x != b.x || a.y != b.y);
}

vector<Hash> pw(N);

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    srand(time(0));
    cout.precision(17);

    pw[0] = { 1,1 };
    for (int i = 1; i < N; i++)
        pw[i] = pw[i - 1] * P;
    
    int n;
    cin >> n;

    vector<string> s(n);
    for (int i = 0; i < n; i++)
        cin >> s[i];

    vector<vector<Hash>> vc(n);

    for (int i = 0; i < n; i++) {
        s[i] = "1" + s[i];
        vc[i].resize(s[i].size());
        for (int j = 1; j < s[i].size(); j++) {
            vc[i][j] = vc[i][j - 1] + pw[j] * (s[i][j] - 'a');
        }
    }
    int l = 0, r = s[0].size();

    while (r - l > 1) {
        int m = (r + l) / 2;

        map<pii, int> mp;

        for (int i = 0; i < n; i++) {
            mp[{vc[i][m].x, vc[i][m].y}]++;
        }

        bool flag = 1;
        for (auto u : mp) {
            if (u.second & 1) {
                flag = 0;
                break;
            }
        }
        if (flag)
            l = m;
        else
            r = m;
    }

    cout << l;
    return 0;
}
