#include <algorithm>
#include <cmath>
#include <iostream>
#include <map>
#include <set>
#include <string>
#include <vector>

using namespace std;

const int N = 5e5 + 2;
const long long mod = 1e7 + 3121;

int q, c;

int sz = 1;
vector<pair<int, int>> g;
vector<int> l, r;

void build(int s)
{
    g.push_back({ -1, -1 });
    g.push_back({ -1, -1 });
    l.push_back(-1);
    l.push_back(-1);
    r.push_back(-1);
    r.push_back(-1);
    l[s] = sz;
    r[s] = sz + 1;
    sz += 2;
}

int main() {
    g.push_back({ -1, -1 });
    l.push_back(-1);
    r.push_back(-1);
    cin >> q >> c;
    for (int t = 1; t <= q; t++)
    {
        int tp;
        cin >> tp;
        if (tp == 1)
        {
            int x;
            string v;
            cin >> x >> v;
            int cur = 0;
            for (int i = 0; i < v.size(); i++)
            {
                if (l[cur] == -1)
                    build(cur);
                //cout << cur << ' ';
                if (v[i] == 'L')
                {
                    cur = l[cur];
                }
                else
                {
                    cur = r[cur];
                }
            }
            if (l[cur] == -1)
                build(cur);
            //cout << cur << endl;
            g[cur] = { t, x };
        }
        else
        {
            int x = -1;
            string v;
            cin >> v;
            int cur = 0, ct = -1;
            for (int i = 0; i < v.size(); i++)
            {
                if (l[cur] == -1)
                    build(cur);
                if (g[cur].first > ct)
                {
                    ct = g[cur].first;
                    x = g[cur].second;
                }
                //cout << x << ' ';
                if (v[i] == 'L')
                {
                    if (x != -1)
                    {
                        x++;
                        if (x == c)
                            x = 0;
                    }
                    cur = l[cur];
                }
                else
                {
                    if (x != -1)
                    {
                        x--;
                        if (x == -1)
                            x = c - 1;
                    }
                    cur = r[cur];
                }
            }
            if (g[cur].first > ct)
            {
                ct = g[cur].first;
                x = g[cur].second;
            }
            cout << x << ' ';
            cout << endl;
        }
    }
    return 0;
}