#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
using namespace std;
 
void io(){
   ios_base::sync_with_stdio(0);
   cin.tie(0);
   cout.precision(5);
}
 
vector<int> z_function(vector<int> s){
   int n = s.size();
   vector<int> z(n,0);
   int l = 0 , r = 0;
   for(int i = 1; i < n; i++){
      if (i <= r) z[i] = min(z[i-l] , r-i+1);
      while(z[i]+i < n && s[z[i]] == s[z[i]+i]) z[i]++;
      if (z[i]+i-1 > r) r = z[i]+i-1 , l = i;
   }
   z[0] = n;
   return z;
}
 
 
int solve(string &s1 , string &s2){
   int maxx = 0;
   while(maxx < s1.size() && s1[maxx] == s2[maxx]) maxx++;
   return maxx;
}
 
int main() {
   io();
   int n , m;
   cin >> n >> m;
   m+=7;
   if (n == 1 || n == 3 || n == 5 || n == 7 || n == 8 || n==10 || n == 12){
      if (m > 31){
         m = m - 31;
      }
   }else if(n == 4 || n == 6 || n == 9 || n == 11){
      if (m > 30){
         m = m - 30;
      }
   }else{
      if (m > 28){
         m = m - 28;
      }
   }
   cout << m+1;
    return 0;
}