#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
using namespace std;
 
void io(){
   ios_base::sync_with_stdio(0);
   cin.tie(0);
   cout.precision(5);
}
 
vector<int> z_function(vector<int> s){
   int n = s.size();
   vector<int> z(n,0);
   int l = 0 , r = 0;
   for(int i = 1; i < n; i++){
      if (i <= r) z[i] = min(z[i-l] , r-i+1);
      while(z[i]+i < n && s[z[i]] == s[z[i]+i]) z[i]++;
      if (z[i]+i-1 > r) r = z[i]+i-1 , l = i;
   }
   z[0] = n;
   return z;
}
 
 
int solve(string &s1 , string &s2){
   int maxx = 0;
   while(maxx < s1.size() && s1[maxx] == s2[maxx]) maxx++;
   return maxx;
}
bool cmp(int a , int b){
    return a > b;
}
int main() {
   io();
   int n;
   cin >> n;
   int a[n];
   long long sum = 0LL;
   for(int i = 0; i < n; i++){
      cin >> a[i];
      sum += a[i];
   }
   long long ans = 0LL;
   sort(a , a+n , cmp);
   for(int i = 0; i < n; i++){
       ans += a[i];
       if(ans >= (sum + 1LL)/ 2LL){
            cout << i+1;
            return 0;
       }  
   }
    return 0;
}